C            this program will tell you the memory size
C            of ctak.f   2001/Jul/10
C you should prepare the necessary inputs and run this program
C      CTAK program   1998 Dec. 10  1-way coupling 
C      RSCPHS modified 2000/11/18
C      WJPX table renewed 2000/11/15
C      DMAS defined       2001/02/16
C      GSORTH rewritten   2001/05/04
C      Smat(break-up)--> divided by sqrt(DKbin)   2001/05/25
C      FCC and DCC array structure modified   2001/07/05
C      CDC14 added and CDC16 simplified       2001/07/08
C     controle routine  
C   KNTL( 1) = NPN,  number of p-n (L S J) pair
C   KNTL( 2) = NPOT, number of nucleon potential parameters
C   KNTL( 3) = 1     add Coulomb break up
C            = 2     vac. pol. correction for diag. elements
C            = 3     both
C   KNTL( 4) = 1,    one-way coupling by using CDC27
C   KNTL( 5) = 1,    vacuum pol. correction for diag. elements
C   KNTL( 6) = 1,    print p-n pair wave functions
C   KNTL( 7) = 1,    print form-factor quantum numbers
C   KNTL( 8) = 1,    print matrix elements
C   KNTL( 9) = 1,    print S-matrix elements
C            = 2,    print S-matrix elemtnts onto file(smat.out)
C            = 3,    both
C   KNTL(10)         print indep. solutions
C
C      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
     +             EPN(400), FKPN(400), KPLPN(400), PPN(400), RPN(400),
     +             LLPN(400), ISPN(400), JJPN(400), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX, IWMAX
      COMMON /FF1/ CPOT(0:150), RFFTAB(0:150), DRHO,  DR, DRFF, DRDW,
     +             TMAS, TZ, RMASS, EFACT, ETOT,
     +             NRHOMX, NRMAX, NRFFMX, NRDWMX, NFF,
     +             IPNWFX, JTMIN, JTMAX, JTINC
      COMMON /CNST/AMU,DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
      CHARACTER*50 TITLE
C       define input file of basic data
      OPEN(5,FILE='ctak.in',STATUS='OLD')
      OPEN(6,FILE='ctakms.out',STATUS='UNKNOWN')
      READ(5,10)TITLE
   10 FORMAT(A50)  
      READ(5, 11)KNTL, TITLE
   11 FORMAT(10I2, A50)
      WRITE(6,12)KNTL, TITLE
   12 FORMAT(1H ,6X,'   2   4   6   8  10',25X,'CTAK Sep. 1999'/
     +       1H ,2X,'KNTL',10I2,2X,A50)
C         read all the necessary data
      CALL CDC10( LSPOT)
      WRITE(6,13)
   13 FORMAT(/,20X,20('*')/)   
C         count the number of p-n wave functions
      CALL CDCCNT(NCC, NCW, KCC)
C         some additional numbers
      NRF1=NRFFMX+1
      WRITE(6,21)KNTL(1),NRF1,NCC
   21 FORMAT(10X,'common area /FF0/ IDPN  to ISLS use',I6/
     +       5X,'/FF1/ RFFTAB,  CPOT use',I6,2X,'=NRFFMX+1'/
     +       5X,'/QCM/ EDCM  to NCID use',I6,2X,'=NCC'/
     +       5X,'/VCC/ should be kept as is'/) 
C        p-n system wave functions etc.
      NWFH=NWF*(NRHOMX+1)
      NRMX1=NRMAX+1
      NPOT=KNTL(2)
      NPX=NPOT*NRMX1
      NFTAB=NFF*NRF1
      WRITE(6,22)NWF,NWFH,NPX,NFF,NFTAB
   22 FORMAT(10X,'p-n system wave functions '/
     +       5X,'number of wave functions=',I8,2X,'=NWF'/
     +       5X,'array PNWF          uses ',I8,2X,'=NWF*(NRHOMX+1)'/
     +      10X,' equivalenced with FCC and DCC'/
     +       5X,'array PTAB          uses ',I8,2X,'=NPOT*(NRMAX+1)'/
     +      10X,' equivalenced with UR'/
     +       5X,'array IPFF LTRFF IDFF    ',I8,2X,'=NFF'/
     +       5X,'array FFTAB         uses ',I8,2X,'=NFF*(NRFFMX+1)'/)
C        p+n system
      KCX=KCC*(KCC+1)*NRF1
      KC5=5*KCC**2
      KC8=8*KCC**2
      NC3=3*NCC
      WRITE(6,23)KCC,NCW,KCX,KC5,KC8,NC3,KCC,KCC
   23 FORMAT(10X,'p+n system functions'/
     +       5X,'number of eff. coup. ch. ',I8,2X,'=KCC'/
     +       5X,'array F FP G GP      use ',I8/
     +       5X,'array FCC/DCC        use ',I8,2X,
     +                                 '=KCC*(KCC+1)*(NRFFMX+1)'/
     +       5X,'      these arrays are superposed'/
     +       5X,'array UR  and UI     use ',I8,2X,'=5*KCC**2'/
     +       5X,'array VUR and VUI    use ',I8,2X,'=8*KCC**2'/
     +       5X,'array SR  and SI     use ',I8,2X,'=3*NCC'/
     +       5X,'array ER  and EI     use ',I8,2X,'=KCC'/
     +       5X,'array WR WI IW WX    use ',I8,2X,'=KCC'/)
C          parameters to define upper limits
      WRITE(6,24)KNTL(1),NWF,NFF,NFTAB,NCC,KCX,NCW,NC3,NRFFMX,
     +           KC5,KC8
   24 FORMAT(/10X,'parameters minimum required'/
     +   5X,'variable',2X,'minimum',7X,'variable',2X,'minimum'/
     +   5X,'NPMAX   ',I9,            7X,'NWFMAX  ',I9/
     +   5X,'NFFMAX  ',I9,            7X,'MAXFFT  ',I9/
     +   5X,'NCCMAX  ',I9,            7X,'NFSZMX  ',I9/
     +   5X,'NCOUL   ',I9,            7X,'ISMAX   ',I9/
     +   5X,'NRFMAX  ',I9,            7X,'NUMAX   ',I9/
     +   5X,'NVUMAX  ',I9)
      STOP
      END
      SUBROUTINE CDCCNT(NCC, NCW, KCC)
C       count the number of p-n wave functions
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10),
C                    quantum numbers for the "deuteron" wave functions
     +             EPN(400), FKPN(400), KPLPN(400), PPN(400), RPN(400),
     +             LLPN(400), ISPN(400), JJPN(400), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX, IWMAX
      COMMON /FF1/ CPOT(0:150), RFFTAB(0:150), DRHO,  DR, DRFF, DRDW,
     +             TMAS, TZ, RMASS, EFACT, ETOT,
     +             NRHOMX, NRMAX, NRFFMX, NRDWMX, NFF,
     +             IPNWFX, JTMIN, JTMAX, JTINC
C***************************************************************************
      COMMON /CNST/AMU, DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
C         number of p-n wave functions
      NPN=KNTL(1)
      NWF=0
      M=0
      DO 12 N=1, NPN
      KPL=KOUPLE(N)
      NKB=NKBIN(N)
      ISB=ISBND(N)
      IF(KPL .EQ. 0) NW=  NKB
      IF(KPL .EQ. 1) NW=4*NKB
      IF(ISB .NE. 0) NW=NW+2
      NWF=NWF+NW
      ID=IDPN(N)
      IF(KPL .NE. 0) ID=2*ID+6
      LS=LLTAB(ID)
      II=JJTAB(ID)
      NK=(KPL+1)*NKB+ISB
      DO 11 KP=1,KPL+1
      DO 10 NM=1,NK
      M=M+1
      LLPN(M)=LS
   10 JJPN(M)=II
   11 LS=LS+2
   12 CONTINUE
CXXXXXXXXXXXXXXXX
      LMAX=6
C           count the number of independent form factors
      NFFX=0
      L12=0
      DO 13 N1=1,NWF
      LS1=LLPN(N1)
      II1=JJPN(N1)
      DO 13 N2=1,N1
      LS2=LLPN(N2)
      II2=JJPN(N2)
      LMIN=MAX0(IABS(LS1-LS2), IABS(II1-II2), LAMMIN)
      LMAX=MIN0(     LS1+LS2,       II1+II2,  LAMMAX)
      IF((-1)**(LS1+LS2+LMIN) .NE. 1) LMIN=LMIN+1
      IF(L12.LT.LMAX)L12=LMAX
      IF(LMIN .LE. LMAX) NFFX=NFFX+(LMAX-LMIN)/2+1
   13 CONTINUE
      NFF=NFFX*NPTYPE
      IF(L12 .GT. LMAX) WRITE(6,111) L12, LMAX
  111 FORMAT('CDC16 requested LMAX=',I2,' while allowed =',I2)
      IF(L12 .GT. LMAX) STOP '**********************************'
CXXXXXXXXXXXXXXX
C        correspond to deuteron bound state
      NCC=3
C           p-n state (S, L and I are specified )
      DO 14 N=1, NPN
      KPL=KOUPLE(N)
      NKB=NKBIN (N)
      J  =JJ    (N)
   14 NCC=NCC+(2*J+1)*NKB*(KPL+1)
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
C      count number of independent Coulomb wave functions
      JMAX=0
      NCW=1
      DO 22 N1=1, NPN
      J=JJ(N1)
      IF(J .GT. JMAX)JMAX=J
      DO 21 N2=1, N1-1
      IF(    NKBIN(N1)-NKBIN(N2)  .EQ. 0      .AND.
     +   ABS(FKMIN(N1)-FKMIN(N2)) .LT. 1.0E-3 .AND.
     +   ABS(FKMAX(N1)-FKMAX(N2)) .LT. 1.0E-3) GOTO 21
   21 CONTINUE   
      NCW=NCW+NKBIN(N1)
   22 CONTINUE
      NCW=NCW*(JTMAX+JMAX+1)
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
C        count number of coupled channles for given Jt and parity
C        even value of JT is assumed
      KCC=0
      DO 27 JP=-1,1,2
      KC=2
      IF(JP.EQ.1) KC=1
      DO 26 NP=1, NPN
      LMIN=-JJ(NP)
      ID  =IDPN(NP)
      LS  =LLTAB(ID)
      IF((-1)**(LMIN+LS) .NE. JP) LMIN=LMIN+1
      IF(J .LT. LMIN) GOTO 27
      LMUL=(J-LMIN)/2+1
      KC=KC+LMUL*NKBIN(NP)*(KOUPLE(NP)+1)
   26 CONTINUE
      IF(KCC .LT. KC) KCC=KC
   27 CONTINUE
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      RETURN
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      
      SUBROUTINE CDC10( LSPOT)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10),
C                    quantum numbers for the "deuteron" wave functions
     +             EPN(400), FKPN(400), KPLPN(400), PPN(400), RPN(400),
     +             LLPN(400), ISPN(400), JJPN(400), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX, IWMAX
      COMMON /FF1/ CPOT(0:150), RFFTAB(0:150), DRHO,  DR, DRFF, DRDW,
     +             TMAS, TZ, RMASS, EFACT, ETOT,
     +             NRHOMX, NRMAX, NRFFMX, NRDWMX, NFF,
     +             IPNWFX, JTMIN, JTMAX, JTINC
      DIMENSION DRF(10), RF(0:10)
      CHARACTER PNSPEC*60
C      specify p-n states to be used
      NPN=KNTL(1)
      DO 15 N=1, NPN
      READ(5,11)PNSPEC
   11 FORMAT(A60)
      WRITE(6,12)PNSPEC
   12 FORMAT(1H ,'PNSPEC=',A50)
      CALL PNIN(PNSPEC, IT(N), JJ(N), IS(N), KOUPLE(N), ISBND(N),
     +                  NKBIN(N), FKMIN(N), FKMAX(N))
C      define ID number
C        3D3 is treated seperately
      IF(JJ(N) .EQ. 3 .AND. IS(N) .EQ. 1) THEN
         IDPN(N)=7
         KOUPLE(N)=0
         GOTO 15
      END IF
      IF(KOUPLE(N) .EQ. 1) GOTO 14
      DO 13 ID=1,6
      IF(IT(N) .NE. ITSTAT(ID)) GOTO 13
      IF(IS(N) .NE. ISSTAT(ID)) GOTO 13
      IF(JJ(N) .NE.  JSTAT(ID)) GOTO 13
      IDPN(N)=ID
      GOTO 15
   13 CONTINUE
      GOTO 903
   14 IDPN(N)=0
      IF(IT(N) .EQ. 0 .AND. JJ(N) .EQ. 1 .AND. IS(N) .EQ. 1) IDPN(N)=1
      IF(IT(N) .EQ. 1 .AND. JJ(N) .EQ. 2 .AND. IS(N) .EQ. 1) IDPN(N)=2
      IF(IDPN(N) .EQ. 0) GOTO 901
   15 CONTINUE
C            reset ISBND
      ISOK=0
      IF(ISBND(1).NE.0)ISOK=1
      DO 16 NP=2, NPN
   16 ISBND(NP)=0
      IF(ISOK.EQ.0) GOTO 905
C            print input
      WRITE(6,17)
   17 FORMAT(/1H ,5X,'p-n bins specified '/
     +        1H ,2X,'N',2X,'T',2X,'S',2X,'J',2X,'K',2X,'B',2X,'ID',
     +            2X,'BIN',2X,'FKMIN', 3X,'FKMAX')
      DO 19 N=1, NPN
      WRITE(6,18)N,IT(N), IS(N), JJ(N), KOUPLE(N), ISBND(N), IDPN(N),
     +           NKBIN(N), FKMIN(N), FKMAX(N)
   18 FORMAT(1H ,6I3,2I4,2F8.3)
   19 CONTINUE
C       define potential parameters
      NPOT=KNTL(2)
      LLPMIN=100
      LLPMAX=-LLPMIN
      DO 20 N=1, NPOT
      READ(5,*)ISN(N), ISI(N), ISLS(N), (POTPRM(M,N),M=1,5)
C        pick-up Coulomb charge radius
C      IF(ISN(N) .EQ. 0 .AND. ISI(N) .EQ. 0 .AND. ISLS(N) .EQ. 0)
C     +   R0C=POTPRM(5,N)
      LLPM=ISI(N)+2*(ISLS(N)+2*ISN(N))
      IF(LLPM .LT. LLPMIN) LLPMIN=LLPM
      IF(LLPM .GT. LLPMAX) LLPMAX=LLPM
   20 LLPN(N)=LLPM
C       reorder potential table i.e., LLPN: p/n;  r/i; cen/L*S 
      NN=1
      DO 24 LL=LLPMIN, LLPMAX
      DO 23 N =1, NPOT
      LLPM=LLPN(N)
      IF(LLPM .NE. LL) GOTO 23
C          swap X(N) <--> X(NN)
      IF(N .EQ. NN) GOTO 22
      II=ISI(N)
      ISI(N )=ISI(NN)
      ISI(NN)=II
      II=ISN(N)
      ISN(N )=ISN(NN)
      ISN(NN)=II
      II=ISLS(N)
      ISLS(N )=ISLS(NN)
      ISLS(NN)=II
      LLPN(N )=LLPN(NN)
      LLPN(NN)=LLPM
      DO 21 M=1, 5
      TEMP=POTPRM(M,N)
      POTPRM(M, N )=POTPRM(M,NN)
   21 POTPRM(M, NN)=TEMP
   22 NN=NN+1
   23 CONTINUE
   24 CONTINUE
C            count potential types. max. of 4
C            real/imag,  cent./L*S
      NRC=0
      NIC=0
      NRL=0
      NIL=0
      DO 26 N=1, NPOT      
      IF(ISN(N) .GT. 0) ISN(N)=1
      IF(ISN(N) .LE. 0) ISN(N)=0
      IF(ISI(N) .GT. 0) ISI(N)=1
      IF(ISI(N) .LE. 0) ISI(N)=0
      IF(ISLS(N).GT. 0) ISLS(N)=1
      IF(ISLS(N).LE. 0) ISLS(N)=0
      IF(ISI(N) .EQ. 0 .AND. ISLS(N) .EQ. 0) NRC=1
      IF(ISI(N) .NE. 0 .AND. ISLS(N) .EQ. 0) NIC=1
      IF(ISI(N) .EQ. 0 .AND. ISLS(N) .NE. 0) NRL=1
      IF(ISI(N) .NE. 0 .AND. ISLS(N) .NE. 0) NIL=1
   26 CONTINUE
      NPTYPE=NRC+NIC+NRL+NIL
C        define LSPOT flag
      LSPOT=MAX0(NRL, NIL)
C
      READ(5,*)LAMMIN, LAMMAX, TMAS, TZ, ELAB
C       define mesh size and number of meshes
      READ(5,*)DRHO, NRHOMX, DR, NRMAX
      READ(5,*)NRF,(DRF(M), RF(M), M=1, NRF)
      READ(5,*)DRDW
      READ(5,*)JTMIN, JTMAX, JTINC
C
      DRFF=DRF(1)
      NRDWMX=RF(NRF)/DRDW+0.01
      NRFFMX=0
      RF0=0
      DO 27 M=1,NRF
      RF1=RF(M)
      NRFFMX=NRFFMX+(RF1-RF0)/DRF(M)+0.01
   27 RF0=RF1
C
      IZ=TZ+0.1
      IA=TMAS+0.1
      WRITE(6,30)IZ, IA, ELAB
   30 FORMAT(/,2X,60('-')/3X,'target Z=',I4,2X,'mass number=',I5,
     +         3X,'incident Energy=',F8.3/
     +         2X,60('-'))  
      WRITE(6,31)
   31 FORMAT(/1H ,10X,'potential parameters '/
     +  1H ,3X,'p.ID  ISN  ISI ISLS  p.type',2X,'V(MeV)',3X,'R0(fm)',
     +      3X,'a(fm)',2X,'R0C or Csd')
      DO 33 N=1, NPOT
      WRITE(6,32)N,ISN(N), ISI(N),ISLS(N),(POTPRM(M,N),M=1,5)
   32 FORMAT(1H ,4I5,2X,F6.1,2X,F9.4,2F8.4,2X,F8.4)
   33 CONTINUE
C
      RHOMX=DRHO*NRHOMX
      RPMAX=DR*NRMAX
      RDWMX=DRDW*NRDWMX
      WRITE(6,34)DRHO, NRHOMX, RHOMX, DR, NRMAX, RPMAX, 
     +           DRDW, NRDWMX, RDWMX, NRFFMX
   34 FORMAT(/1H ,5X,'Rho   :  DRHO =',F8.5,3X,'NRHOMX=',I5,2X,
     +                        'RHOMX=',F8.2/
     +        1H ,5X,'Rp/Rn :  DR   =',F8.5,3X,'NRMAX =',I5,2X,
     +                        'RPMAX=',F8.2/
     +        1H ,5X,'Rwf   :  DRDW =',F8.5,3X,'NRDWMX=',I5,2X,
     +                        'RDWMX=',F8.2/
     +        1H ,5X,'form factors   ',11X,     'NRFFMX=',I5)
      WRITE(6,35)(DRF(M), RF(M),M=1, NRF)
   35 FORMAT(1H ,5X,'(DRFF RFF)=',4('(',F4.1,1X,F5.1,') ':)/
     +      (1H ,16X,4('(',F4.1,1X,F5.1,') ':)))
      IF(KNTL(3) .GT. 0 .AND. IZ .NE. 0) WRITE(6,36)
   36 FORMAT(/1H ,5X,'Coulomb break-up option is invoked ')  
      IF(KNTL(3) .GT. 0 .AND. IZ .EQ. 0)WRITE(6,37)
   37 FORMAT(1H ,5X,50('*')/
     +       1H ,10X,'Coulomb break-up for Neutral target !'/
     +       1H ,5X,50('*'))  
      IF(KNTL(4) .GT. 0) WRITE(6,38)
   38 FORMAT(1H ,5X,'One-way Coupling is used ')  
C           range of JTOT
      WRITE(6,39)JTMIN, JTMAX, JTINC
   39 FORMAT(/1H ,5X,'JT(min)=',I3,2X,'JT(max)=',I3,2X,'JT(inc)=',I2)
      RETURN
C       error message
  901 WRITE(6,902)PNSPEC
  902 FORMAT(1H ,'PNSPEC=',A60/
     +       1H ,'KOUPLE=1 NOT accepted for this spec !! ')
      STOP
  903 WRITE(6,904)N,IT(N),IS(N),JJ(N)
  904 FORMAT(1H ,'(CDC10) failed to set ID for N IT IS JJ =',4I3)
      STOP
  905 WRITE(6,906)
  906 FORMAT(1H ,'(CDC10) No bound deuteron !')
      STOP
  907 WRITE(6,908)NRF
  908 FORMAT(1H ,'(CDC10) NRF=',I2,' should be less that 10!')
      STOP  
      END
      SUBROUTINE PNIN(STR, IT, JJ, IS, KOUPLE, ISBND, NKBIN,
     +                FKMIN, FKMAX)
C      decipher an input line, which specifies the p-n state
C Input STR: character string
C Output IT: ispspin=0 or 1 for valid line and -1 for invalid line
C        JJ: total angular momentum of the state. 0-3 are allowed
C        IS: intrinsic spin 0 or 1 are allowd
C        KOUPLE=0 for uncoupled states and 1 for coupled states
C        ISBND: =1 for deuteron ground state
C        NKBIN: number of momentum bins
C        FKMIN, FKMAX: min. and max. of momentum span.
C      IMPLICIT REAL*8(A-H, O-Z)
      CHARACTER*60 STR, LMOM(8)*1, CH*1, IFORM*4
      CHARACTER*1 Z10(10)
      DIMENSION NUM(4), LL(2)
      DATA LMOM /'s', 'S', 'p', 'P', 'd', 'D', 'f', 'F'/
      DATA Z10/'1', '2', '3', '4', '5', '6', '7', '8', '9', '0' /
      DATA IFORM /'(I1)'/
C               read One or two state identifiers
      DO 10 I=1,4
   10 NUM(I)=0
      LL(1)=0
      LL(2)=0
      K=0
      I0=1
   11 CONTINUE
      DO 12 I=I0, 60
      CH=STR(I:I)
      DO 12 J=1,8
      IF(CH .EQ. LMOM(J)) GOTO 13
   12 CONTINUE
      IF(K .EQ. 0) GOTO 901
      GOTO 20
C         hit it
   13 I1=I
      K=K+1
      LL(K)=(J+1)/2-1
C            S and J should appear
      I1=I-1
      K0=2*K-1
      DO 16 N=1,2
      CH=STR(I1:I1)
      DO 14 J=1,10
      IF(CH .EQ. Z10(J)) GOTO 15
   14 CONTINUE
      IF(K .EQ. 1) GOTO 903
      IF(K .EQ. 2) THEN
         K=1
         GOTO 20
      END IF
   15 NUM(K0)=J
      IF(J .EQ. 10) NUM(K0)=0
      K0=K0+1
   16 I1=I1+2
      I0=I+2
      IF(STR(I0:I0) .NE. '-')GOTO 20
      IF(K .EQ. 1) GOTO 11
C
   20 CONTINUE
      KOUPLE=0
      IF(K .EQ. 2) KOUPLE=1
      KP=1+KOUPLE
C            check triangular condition
      DO 21 K=1, KP
      L =LL(K)
      IS=(NUM(2*K-1)-1)/2
      JJ=NUM(2*K)
      IF(IABS(IS-L) .GT. JJ .OR. IS+L .LT. JJ) GOTO 905
   21 CONTINUE
C           read NKBIN, FKMIN, FKMAX
      DO 50 II=1, 3
      ISF=0
      FFF=0
      DO 40 I=I0, 60
C           looks for "="
      IF(STR(I:I) .NE. '=') GOTO 40
      I0=I+1
C           skip blank character
      DO 31 J=I0,60
      IF(STR(J:J) .NE. ' ') GOTO 32
   31 CONTINUE
      GOTO 907
C        read integer
   32 I0=J
      DO 34 K=I0, 60
      CH=STR(K:K)
      DO 33 J=1,10
      IF(CH .EQ. Z10(J)) GOTO 34
   33 CONTINUE
      GOTO 35
   34 CONTINUE
   35 I1=K-1
      L=I1-I0+1
      IF(L .LE. 0) GOTO 907
      IFORM(3:3)=Z10(L)
C         define integer NNN
      READ(STR(I0:I1),IFORM)NNN
      IF(II .EQ. 1) THEN
         NKBIN=NNN
         I0=I1+1
         GOTO 50
      END IF
C        define floating number
      IF(ISF .EQ. 0) FFF=NNN
      IF(ISF .EQ. 1) THEN
         FFF=FFF+FLOAT(NNN)/10**L
         GOTO 41
      END IF
      I0=I1+1
      IF( STR(I0:I0) .EQ. '.') THEN
         J=I0+1
         ISF=1
         GOTO 32
      END IF
      GOTO 41
   40 CONTINUE
   41 IF(II .EQ. 2) FKMIN=FFF
      IF(II .EQ. 3) FKMAX=FFF
   50 CONTINUE
C         JJ should be unique
      IF(KOUPLE .EQ. 1 .AND. NUM(2) .NE. NUM(4)) GOTO 909
C              define isospin
      IT=0
      K=IS+LL(1)
      IF((-1)**K .EQ. 1) IT=1
C              k-check
      IF(FKMIN .GE. FKMAX .AND. NKBIN .NE. 0) GOTO 911
C             define ISBND. just for 3S1-3D1 coupled state
      ISBND=0
      IF(KOUPLE .EQ. 1 .AND. LL(1) .EQ. 0 .AND. LL(2) .EQ. 2 .AND.
     +  JJ .EQ. 1) ISBND=1
      RETURN
C           error message !
  901 WRITE(6,902)
  902 FORMAT(1H ,'No state identifier !!')
      STOP
  903 WRITE(6,904)
  904 FORMAT(1H ,'S or J is not specified for given L !')
      STOP
  905 WRITE(6,906)LL(K), IS, JJ
  906 FORMAT(1H ,'triangle check L=',I2, 2X,'S=',I2,2X,'J=',I2)
      STOP
  907 WRITE(6,908)
  908 FORMAT(1H ,'No number is specified !')
      STOP
  909 WRITE(6,910)NUM(2), NUM(4)
  910 FORMAT(1H ,'JJ is redefined !! JJ1=',I2,2X,'JJ(2)=',I2)
      STOP
  911 WRITE(6,912)NKBIN,FKMIN, FKMAX
  912 FORMAT(1H ,'NKBIN=',I2,2X,'FKMIN=',1PE12.3,2X,'FKMAX=',1PE12.3/
     +       1H ,'***  inconsistent !! ***')
      STOP
      END
      BLOCK DATA
C           define Reid soft core potential
C      IMPLICIT REAL*8(A-H, O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      COMMON /CNST/AMU,DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
C       Basic parameters  VIFAC=1/((41.47 MeV*fm**2)*PNMU**2)
      DATA PNMU, VIFAC/0.7D0, 4.9211871D-2/
C           uncoupled case
C              (2*T+1),(2*1+1)L,J for uncoupled states
C              1,1P1: 1,3D2; 3,1S0; 3,0D2; 3,3P0; 3,3P1
C            isospins of p-n pair
      DATA ITSTAT /0, 0, 1, 1, 1, 1/
C            spins of p-n pair
      DATA ISSTAT /0, 1, 0, 0, 1, 1/
C            orbital ang. mom. of p-n pair
      DATA LSTAT  /1, 2, 0, 2, 1, 1/
C            total ang. mom. of p-n pair
      DATA JSTAT  /1, 2, 0, 2, 0, 1/
C            number of potential terms
      DATA NTERM  /3, 7, 3, 4, 8, 7/
C            powers of the potential
      DATA NPOW   /-1, -1, -1,
     +             -1, -2, -3, -2, -3, -1, -1,
     +             -1, -1, -1,
     +             -1, -1, -1, -1,
     +             -1, -2, -3, -2, -3, -1, -1, -1,
     +             -1, -2, -3, -2, -3, -1, -1/
C            potential depths
      DATA VDEP   / 31.389D0, -634.39D0, 2163.4D0,
     +  -31.389D0, -62.778D0, -62.778D0, 251.112D0,  62.778D0,
     +  -220.12D0,  871.0D0,
     +  -10.463D0, -1650.6D0,  6484.2D0,
     +  -10.463D0, -12.322D0, -1112.6D0, 6484.2D0,
     +  -10.463D0, -41.852D0, -41.852D0, 167.408D0,  41.852D0,
     +   27.133D0, -790.74D0, 20662.0D0,
     +   10.463D0,  20.926D0,  20.926D0, -83.704D0, -20.926D0,
     +  -135.25D0,  472.81D0/
C         ranges
      DATA IRPOT / -1, -2, -3,
     +             -1, -1, -1, -4, -4, -2, -3,
     +             -1, -4, -7,
     +             -1, -2, -4, -7,
     +             -1, -1, -1, -4, -4, -2, -4, -7,
     +             -1, -1, -1, -4, -4, -2, -3/
C **********************************************************************
C        here for coupled states
C       number of terms
C                  3S1-3D1   3P2-3F2
      DATA MTERM / 4, 7, 2,  3, 6, 1 /
C       power of X
C                  3S1-3D1 coupled state
      DATA MPOW /4*-1,   -1, -2, -3, -2, -3, 2*-1,   2*-1,
C                  3P2-3F2 coupled state
     +           3*-1,   -1, -2, -3, -2, -3,   -1,     -1/
C       ranges
      DATA IURNG/-1, -2, -4, -6,   3*-1, 2*-4, -4, -6,   -4, -6,
     +           -1, -4, -6,       3*-1, 2*-4, -3,       -6/
C       potential depths
      DATA UDEP/-10.463D0,  105.468D0, -3187.8D0, 9924.3D0,
     +          -10.463D0,2*-31.389D0, 125.556D0, 31.389D0,
     +                      351.77D0,  -1673.5D0,
     +           708.91D0,  -2713.1D0,
     +           3.4877D0, -933.48D0, 4152.1D0,
     +           3.4877D0, 2*10.463D0, -41.852D0, -10.463D0, -34.925D0,
     +           -2074.1D0/
C           fundamental parameters
C            Mp*c**2     habr*c      e**2/4*pi*epsilon0  Md*c**2
      DATA    AMU,        HBARC,          CFAC,        DMAS /
     +    938.27231D0, 197.327053D0, 1.4399652D0, 1.99900755D0/

C       p-n angular momentum reference
C            JD =  1  2  3  4  5  6  7  8  8 10 10
      DATA LLTAB / 1, 2, 0, 2, 1, 1, 2, 0, 2, 1, 3/
      DATA ISTAB / 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1/
      DATA JJTAB / 1, 2, 0, 2, 0, 1, 3, 1, 1, 2, 2/
      END
