C  evaluate deuteron cross section etc. 
C  by using S-matrix from TAK or CTAK
C                                    VERSION 3. Feb. 12. '00
C            Ay, Axx, Axz, Ayy added
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CDCC/EDCM, FKCM, ETACM, SR(3, 3, 0:305), SI(3, 3, 0:305),
     +             JTMIN, JTMAX
      DIMENSION  ANGTAB(360), RX(360), TKQ(5, 360),
     +           P(0:305,0:2), Q(0:305,0:2),KNTL(10) 
      COMPLEX*16 CG(0:305, -1:1, 0:1), FCC(360), ESIG(0:305)
      CHARACTER INFILE*30
C          INPUT/OUTPUT files
      OPEN(5,FILE='ctaksx.in',STATUS='OLD')
      OPEN(6,FILE='ctaksx.out',STATUS='OLD',ERR=91)
      READ(5,*)KNTL
C         Angle table
      NANG=KNTL(1)
      ANG0=KNTL(2)
      DANG=KNTL(3)*0.1D0
      IF(NANG .LE. 0) THEN 
         NANG=180
         ANG0=1.0D0
         DANG=1.0D0
      END IF
      DO 11 N=1, NANG
   11 ANGTAB(N)=ANG0+(N-1)*DANG
C
 100  READ(5,101,END=800, ERR=800)INFILE
 101  FORMAT(A30)
      IF(INFILE .EQ. '' .OR. INFILE .EQ. 'bye' .OR. INFILE .EQ. 'Bye')
     +               STOP
      WRITE(6,102)INFILE
 102  FORMAT('#INFILE=',A30)
C          read data from smat.out
      OPEN(7,FILE=INFILE, STATUS='OLD',ERR=91)
      CALL GETDAT
      CLOSE (7)
C         deuteron elastic scattering
      LPLUS=JTMAX+2
C         Coulomb phase shift and Coulomb scattering amplitudes
      CALL CPHASE(ETACM, LPLUS, S0, ESIG)
      CALL FCCAL(ETACM, FKCM, S0, NANG, ANGTAB, FCC, RX)
C         evaluate observables
      K6=KNTL(6)
      CALL TKQCAL(NANG, K6, ANGTAB, ESIG, FCC, RX, TKQ, CG, P)
C
C         near/far decomposition of elastic cross sec.
      IF(KNTL(4) .GT. 0) 
     +      CALL NFX(NANG, ANGTAB, ETACM, FCC, RX, TKQ, CG, P, Q)
      GOTO 100
  800 STOP
C         error messages
   91 WRITE(6,92)
   92 FORMAT(1H ,'(MAIN) I/O file error !!')
      STOP
      END
      SUBROUTINE TKQCAL(NANG, K6, ANGTAB, ESIG, FCC, RX, TKQ, CG, YLM0)
C        elastic observables
C Input NANG, ANGTAB(180): angle tables. angle in degree
C       JTMAX: max. of Jtotal
C       FK   : wave number
C       ESIG(0:305): exp(i*sigma(L))
C       FCC(NANG): Coulomb scattering amplitude 
C        RC(NANG): Rutherford cross sec. in mb/sr
C Output TKQ(1,*): Rutherford ratio
C        TKQ(2,*): iT11
C        TKQ(3,*), TKQ(4,*), TKQ(5,*): T20, T21 and T22
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CDCC/EDCM, FKCM, ETACM, SR(3, 3, 0:305), SI(3, 3, 0:305),
     +             JTMIN, JTMAX
      DIMENSION ANGTAB(360), RX(360), TKQ(5,360),YLM0(0:305, 0:2),
     +          TOTX(-1:1)
      COMPLEX*16  ESIG(0:305), CG(0:305, -1:1, 0:1), FCC(360)
      COMPLEX*16 FN(-1:1, -1:1), C0, CA, CB, CC, CD, CE, CW
      EQUIVALENCE (CA, FN( 1,1)), (CB, FN(1, 0)), 
     +            (CD, FN( 0,1)), (CE, FN(0, 0)),
     +            (CC, FN(-1,1))
C        define PI, i, the unit imaginary number
      DATA PI, CW/3.14159265358979D0, (0, 1)/
C            deuteron only
      IS =1      
      ISD=IS*2
      LJMAX=JTMAX+IS
      FFAC=SQRT(PI)/FKCM
C             clear geometric factor table
      DO 11 MSI=IS,   0, -1
      DO 11 MSF=IS,-MSI, -1
      DO 11 LF =  0, LJMAX
   11 CG(LF, MSF, MSI)=0
C            geometric factors
      DO 12 JT=0, JTMAX
      LMIN=IABS(JT-IS)
      LMAX=     JT+IS
      DO 12 LI=LMIN, LMAX
      CA=FFAC*SQRT(2*LI+1.0D0)*ESIG(LI)
      LIS=LI-JT+ISD
      DO 12 MSI= IS, 0, -1
      CB=CA*CG1(LI, 0, IS, MSI, JT)
      LFMIN=LMIN
      IF((-1)**(LFMIN+LI) .LE. 0) LFMIN=LFMIN+1
      DO 12 LF=LFMIN, LMAX, 2
      LFS=LF-JT+ISD
      DEL=1
      IF(LI .NE. LF) DEL=0
      CC=CMPLX(SR(LFS, LIS, JT), SI(LFS, LIS, JT))
      CC=CB*ESIG(LF)*(DEL-CC)*CW
      DO 12 MSF= IS, -MSI, -1
      ML=MSI-MSF
   12 CG(LF, MSF, MSI)=CG(LF, MSF, MSI)+CC*CG1(LF, ML, IS, MSF, JT)
C             angle loop
      RAD=PI/180
      S2=SQRT(2.0D0)
      S3=SQRT(3.0D0)
      S6=S2*S3
      XFAC=10.0D0/(ISD+1)
      DO 16 N=1, NANG
      THETA=ANGTAB(N)*RAD
      CALL YLM0TB(THETA, LJMAX, ISD, YLM0)
      DO 14 MSI= IS,   0, -1
      DO 14 MSF= IS,-MSI, -1
      ML=MSI-MSF
      IABML=IABS(ML)
      C0=0
      DO 13 LF=0, LJMAX
   13 C0=C0+CG(LF, MSF, MSI)*YLM0(LF, IABML)
      IF(ML .GT. 0) C0=(-1)**ML*C0
C          add Coulomb amplitude
      IF(ML .EQ. 0) C0=C0+FCC(N)
   14 FN(MSF, MSI)=C0
      XX=2*(CA*CONJG(CA)+CB*CONJG(CB)+CC*CONJG(CC)+CD*CONJG(CD))+
     +      CE*CONJG(CE)
C         observables
      C0      =S6*(CONJG(CB)*(CA-CC)+CONJG(CE)*CD)
      TKQ(3,N)=S2*(CONJG(CA)*CA-2*CONJG(CB)*CB+CONJG(CC)*CC
     +            +CONJG(CD)*CD-  CONJG(CE)*CE)
      TKQ(5,N)=S3*(2*DBLE(CONJG(CA)*CC)-CONJG(CD)*CD)
      TKQ(2,N)= IMAG(C0)
      TKQ(4,N)=-DBLE(C0)
      DO 15 I=2, 5
   15 TKQ(I,N)=TKQ(I,N)/XX
      TKQ(1,N)=XX*XFAC/RX(N)
   16 CONTINUE
C          print elastic observables
      IF(K6 .NE. 0) GOTO 22
      WRITE(6,21)(ANGTAB(N),RX(N),(TKQ(I,N),I=1,5),N=1,NANG)
   21 FORMAT('#Angle',3X,'Ruth(mb/sr)',3X,'Xel/Ruth',5X,'iT11',
     +            5X,'T20',6X,'T21',6X,'T22'/
     +      (1H ,0PF6.2,1P2E13.5,0P4F9.5))
      GOTO 26
C        Spin observablesin Cartesian coordinate
C        TKQ(2,*)=Ay, TKQ(3,*)=Axx, TKQ(4,*)=Axz, TKQ(5,*)=Ayy
   22 DO 23 N=1, NANG
      TKQ(2,N)=  2*TKQ(2,N)/S3        
      TKQ(4,N)=-S3*TKQ(4,N)
      AXX     = S3*TKQ(5,N)-TKQ(3,N)/S2
      TKQ(5,N)=-S3*TKQ(5,N)-TKQ(3,N)/S2
   23 TKQ(3,N)=AXX
      WRITE(6,24)(ANGTAB(N),RX(N),(TKQ(I,N),I=1,5),N=1,NANG)
   24 FORMAT('#Angle',3X,'Ruth(mb/sr)',3X,'Xel/Ruth',6X,'Ay',
     +            6X,'Axx',6X,'Axz',6X,'Ayy'/
     +      (1H ,0PF6.2,1P2E13.5,0P4F9.5))
C           total reaction cross sections
   26 DO 27 MS=-IS, IS
   27 TOTX(MS)=0
      DO 29 J=0, JTMAX
      LMIN=IABS(J-IS)
      LMAX=     J+IS
      FAC=2*J+1
      DO 29 LF=LMIN, LMAX
      LSF=LF+ISD-J
      LIMIN=LMIN
      IF((-1)**(LF+LIMIN) .LE. 0) LIMIN=LIMIN+1
      DO 29 MS=-IS, IS
      CA=0
      DO 28 LI=LIMIN, LMAX, 2
      LSI=LI+ISD-J
      CA=CA+CG1(J, -MS, IS, MS, LI)*ESIG(LI)*
     *           CMPLX(SR(LSF, LSI, J), SI(LSF, LSI, J))
   28 CONTINUE
   29 TOTX(MS)=TOTX(MS)+FAC*(CG1(J, -MS, IS, MS, LF)**2-CA*CONJG(CA))
      XFAC=10*PI/FKCM**2
      SUM=0
      DO 30 MS=-IS, IS
      TOTX(MS)=TOTX(MS)*XFAC
   30 SUM=SUM+TOTX(MS)
      SUM=SUM/(ISD+1)
      WRITE(6,31)(MS,TOTX(MS),MS=-IS,IS),SUM
   31 FORMAT(/'#Total reaction Cross sections(mb)'/
     +      '#',3('X(',I2,')=',1PE10.3,2X),'Aver=',1PE10.3)
      RETURN
      END
      SUBROUTINE YLM0TB(THETA, LMAX, MMAX, YLM0)
C        returns spherical harmonics at 0 azimuthal angle
C Input THETA: angle in radian
C       LMAX, MMAX: Lmax and Mmax
C Output YLM0(LPLUS, MPLUS)
C       YLM0=sqrt((2*L+1)*(L-abs(M))!/(4*PI*(L+abs(M))!)
C                        *P(L, abs(M), cos(Theta))
C       non negative M only
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION  YLM0(0:305, 0:2)
      IF(LMAX .GT. 305 .OR. MMAX .GT. 2) GOTO 90
      X=COS(THETA)
      S=SIN(THETA)
      WFAC=1
C
      DO 15 M=0, MMAX
      DO 12 L=0,M-1
   12 YLM0(L,M)=0
      P0=0
      P1=S**M*WFAC
      WFAC=WFAC*(2*M+1)
      YLM0(M,M)=P1
      F0=M+M
      F1=F0+1
      F2=1
      FLL=2*M+3
      DO 14 L=M+1, LMAX
      P2=(F1*X*P1-F0*P0)/F2
      F0=F0+1
      F1=F1+2
      F2=F2+1
      YLM0(L,M)=P2
      P0=P1
      P1=P2
   14 CONTINUE
   15 CONTINUE
C        sqrt((2*L+1)/(4*PI))
      WFAC=4*3.141592653589793238D0
      DO 16 L=0,LMAX
      FLL=SQRT((2*L+1)/WFAC)
      DO 16 M=0,MMAX
   16 YLM0(L,M)=FLL*YLM0(L,M)
C        weight using factorial
      DO 25 M=1, MMAX
      FDEN=1
      DO 21 N=1,2*M
   21 FDEN=FDEN*N
      WFAC=1/FDEN
      F0=0
      F1=2*M
      DO 24 L=M,LMAX
      YLM0(L,M)=YLM0(L,M)*SQRT(WFAC)
      F0=F0+1
      F1=F1+1
   24 WFAC=WFAC*F0/F1
   25 CONTINUE
      RETURN
   90 WRITE(6,91)LMAX, MMAX
   91 FORMAT(1H ,'(YLM0TB) your LMAX=',I2,' MMAX=',I2,' are more than',
     +           ' accepted')
      STOP
      END
      SUBROUTINE NFX(NANG, ANGTAB, ETA, FCC, RX, TKQ, CG, P, Q)
C        Near/Far decomposition of elastic cross sections
C Input NANG, ANGTAB(180): angle tables. angle in degree
C       JTMAX: max. of Jtotal
C       FK   : wave number
C       ESIG(0:305): exp(i*sigma(L))
C       FCC(NANG): Coulomb scattering amplitude 
C      RC(NANG)  : Rutherford cross sec. in mb/sr
C Output TKQ(1,*): (Near side cross section)/(Rutherford Cross section)
C        TKQ(2,*): (Far side cross section )/(Rutherford Cross section)
C        TKQ(3,*): Rutherford ratio
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CDCC/EDCM, FKCM, ETACM, SR(3, 3, 0:305), SI(3, 3, 0:305),
     +             JTMIN, JTMAX
      DIMENSION ANGTAB(NANG), RX(NANG), TKQ(5,NANG)
      DIMENSION P(0:305, 0:2), Q(0:305, 0:2)
      COMPLEX*16  FCC(NANG), CG(0:305, -1:1, 0:1)
      COMPLEX*16  CF, CN, CC, CCF, CCN
C        define PI, i, the unit imaginary number
      DATA PI/3.14159265358979D0/
C            deuteron only
      IS =1      
      ISD=IS*2
      LJMAX=JTMAX+IS
C         save the old Rutherford ratio
      DO 11 N=1, NANG
   11 TKQ(3,N)=TKQ(1,N) 
C        we assume that the CG table is defined already
C             angle loop
      RAD=PI/180
      XFAC=10.0D0/(ISD+1)
      DO 16 N=1, NANG
      XN=0
      XF=0
      THETA=ANGTAB(N)*RAD
      CALL PQCAL(THETA, LJMAX, ISD, P, Q)
      CALL COUNF(ETA, THETA, CC)
      CCN=   CC *FCC(N)
      CCF=(1-CC)*FCC(N)
      DO 14 MSI= IS,   0, -1
      DO 14 MSF= IS,-MSI, -1
      ML=MSI-MSF
      SIGN=1
      IF(ML .GT. 0 .AND. (-1)**ML .LE. 0) SIGN=-1
      IABML=IABS(ML)
      CF=0
      CN=0
C          add Coulomb amplitude if (MSI .EQ. MSF)
      IF(ML .EQ. 0) THEN
         CF=CCF
         CN=CCN
      END IF
      DO 13 LF=0, LJMAX
      CC=CMPLX(P(LF, IABML), Q(LF, IABML))*SIGN
      CN=CN+CG(LF, MSF, MSI)*CC
   13 CF=CF+CG(LF, MSF, MSI)*CONJG(CC)
      CC=CN+CF
      FAC=2
      IF((MSI.EQ.0) .AND. (MSF.EQ.0)) FAC=1
      XN=XN+FAC*CN*CONJG(CN)
   14 XF=XF+FAC*CF*CONJG(CF)
      TKQ(1,N)=XN*XFAC/RX(N)
   16 TKQ(2,N)=XF*XFAC/RX(N)
C       print Near/Far Rutherford ratio
      WRITE(6,31)
   31 FORMAT(/,15X,'N/F decomposition of Ruth. ratio'
     +       /,'# Ang(deg)',2X,'N-side', 7X,'F-side',7X,'X/XRuth',5X,
     +           'Ruth-Xsec')
      WRITE(6,32)(ANGTAB(N),TKQ(1,N),TKQ(2,N),TKQ(3,N),RX(N),N=1,NANG)
   32 FORMAT((0PF7.2,1P4E13.4))
      WRITE(6,33)
   33 FORMAT(/)  
      RETURN
      END
      SUBROUTINE CPHASE(ETA, LPLUS, S0, S)
C       Coulomb phase shift
C Input ETA: Coulomb parameter
C     LPLUS: (Lmax+1)
C Output S0: sigma(0)
C      S(L+1)=exp(i*sigma(L))
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 S(*)
      E2=ETA**2
      LMAX=MAX(ABS(ETA), LPLUS)+1
      FL=LMAX
      C1=FL**2+E2
      S1=SQRT(C1)
      C0=ATAN2(ETA, FL)
      S0=(FL-0.5)*C0+ETA*LOG(S1)-ETA
     +   +(((SIN(7*C0)/(1680*C1)-SIN(5*C0)/1260)/C1
     +      +SIN(3*C0)/ 360)/C1 -SIN(  C0)/12  )/S1
      C0=COS(S0)
      S0=SIN(S0)
      DO 1 L=LMAX-1,1,-1
      FL=FL-1
      Z=SQRT(FL**2+E2)
      S1=ETA/Z
      C1=FL/Z
      Z =C0*C1+S0*S1
      S0=S0*C1-C0*S1
      C0=Z
      IF(L .LE. LPLUS) S(L)=CMPLX(C0, S0)
    1 CONTINUE
      S0=ATAN2(S0, C0)
      RETURN
      END
      SUBROUTINE FCCAL(ETA, FK, S0, NANG, ANGTAB, FC, RX)
C       returns Coulomb scattering amplitude and
C               Rutherford cross section in mb**2/sr
C Input ETA, FK: Coulomb parameter and wave number
C       S0     : Coulomb phase shift for L=0
C       NANG, ANGTAB(NANG): number of angles and agle table
C Output FC(NANG): Coulomb scattering amplitude
C        RX(NANG): Rutherford cross section in mb/sr
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION RX(NANG), ANGTAB(NANG)
      COMPLEX*16 FC(NANG)
      RADH=3.14159265358979D0/360
      RUTH=-ETA/(2*FK)
      SIG2=2*S0
      DO 10 N=1, NANG
      X=ANGTAB(N)*RADH
      S=SIN(X)**2+1.0E-16
      FC(N)=RUTH*EXP((0.0D0,-1.0D0)*(ETA*LOG(S)-SIG2))/S
   10 RX(N)=10*FC(N)*CONJG(FC(N))
      RETURN
      END
      SUBROUTINE PQCAL(THETA, LMAX, MMAX, P, Q)
C   Legendre function of 1st and 2nd kind
C   Q(L,M)/PI  AND   P(L,M)/2
C   they are further scaled by *sqrt((2*L+1)/(4*PI))
C                              *sqrt((L-abs(M))!/(L+abs(M))!)
C INPUT THETA: angle in radian
C       LMAX, MMAX: DEFINE RANGE. Negative M only
C OUTPUT P(0:LMAX,0:MMAX),Q(0:LMAX,0:MMAX)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P(0:305,0:2),Q(0:305,0:2)
      PI=3.14159265358979D0
      X=COS(THETA)
      Y=SIN(THETA)
      IF(ABS(Y) .LT. 1.0D-12)THEN
         DO 10 M=0,MMAX
         DO 10 L=0,LMAX
         Q(L,M)=0
   10    P(L,M)=0
         RETURN         
      END IF
      P(0,0)=0.5D0
      P(1,0)=X/2
      Q(0,0)=LOG((1+X)/(1-X))/(2*PI)
      Q(1,0)=X*Q(0,0)-1/PI
      DO 3 M=0,MMAX
      F0=2*M+1
      F1=2*M+3
      F2=2
      DO 1 L=M+2,LMAX
      P(L,M)=(F1*X*P(L-1,M)-F0*P(L-2,M))/F2
      Q(L,M)=(F1*X*Q(L-1,M)-F0*Q(L-2,M))/F2
      F0=F0+1
      F1=F1+2
    1 F2=F2+1
      IF(M .GE. MMAX) GOTO 3
      MP=M+1
      F0=MP
      F1=1-M
      DO 2 L=0,M+2
      P(L,MP)=(F0*X*P(L,M)-F1*P(L+1,M))/Y
      Q(L,MP)=(F0*X*Q(L,M)-F1*Q(L+1,M))/Y
      F0=F0+1
    2 F1=F1+1
    3 CONTINUE
C    reset Q(L,M) for L<M
      Q(0,1)=0
      Q(0,2)=0
      Q(1,2)=0
C       scale factors   
      WFAC=4*PI
      DO 12 L=0, LMAX
      DO 12 M=0, MMAX
      FLL=SQRT((2*L+1)/WFAC)
      P(L,M)=FLL*P(L,M)
   12 Q(L,M)=FLL*Q(L,M)
      IF(MMAX .EQ. 0) RETURN
      DO 15 M=1,MMAX
      WFAC=1
      DO 13 N=2,2*M
   13 WFAC=WFAC*N
      F0=0
      F1=2*M
      WFAC=1/WFAC
      DO 14 L=M, LMAX
      FLL=SQRT(WFAC)
      P(L,M)=FLL*P(L,M)
      Q(L,M)=FLL*Q(L,M)
      F0=F0+1
      F1=F1+1
   14 WFAC=WFAC*F0/F1
   15 CONTINUE
      RETURN
      END
      SUBROUTINE COUNF(ETA, THETA, CC)
C          Near and Far side Coulomb scattering amplitude
C Input ETA  : Coulomb parameter
C       THETA: angle in radian
C Output CC : scaling for near side Coulomb amplitude
C       FC(near, theta)/FC(theta)=CC, 
C       FC(far, theta)/FC(theta)=1-FC(near,theta)/FC(theta)
C       FC(theta) is the Coulomb scattering amplitude
      IMPLICIT REAL*8 (A-H, O-Z)
      COMPLEX*16 CC, FC, C0(0:50), C1(0:50), C2(0:50)
      SAVE
      DATA ICFLAG ,PI, CONV/0, 3.14159265358979D0, 1.0E-7/
      IF(ICFLAG .GT. 0) GOTO 10
C        here for small S
      NMAX=50
      CC=CMPLX(1.0D0, ETA)
      DO 1 N=0,NMAX
    1 C0(N)=1/(CC+N)
C       here for large S
      FN=NMAX+1
      CC=CMPLX(FN, ETA)
      C2(NMAX)=LOG(FN/CC)-(1/FN   -1/CC   )/2  -(1/FN**2-1/CC**2)/12
     +                   +(1/FN**4-1/CC**4)/120-(1/FN**6-1/CC**6)/252
     +                   +(1/FN**8-1/CC**8)/240-(1/FN**10-1/CC**10)/132
      DO 2 N=NMAX-1, 0, -1
      FN=FN-1
      CC=CC-1
    2 C2(N)=C2(N+1)+1/CC-1/FN
      C1(0)=1
      CC=CMPLX(1.0D0, ETA)
      FN=1
      DO 3 N=1, NMAX
      C1(N)=C1(N-1)*CC/FN
      CC=CC+1
    3 FN=FN+1
      ICFLAG=1
      PI2=2*PI
C         power series expansion
   10 S=SIN(THETA/2)**2+1.0E-16
      CC=0
      S0=0
      XX=1
      IF(S .GT. 0.5) GOTO 12
      DO 11 N=0, NMAX
      FC=C0(N)*XX
      CC=CC+FC
      S1=ABS(DBLE(FC))+ABS(IMAG(FC))
      S0=S0+S1
      IF(S1/S0 .LT. CONV) GOTO 15
   11 XX=XX*S
      GOTO 91
   12 SI=1-S
      IF(ABS(SI) .LT. 1.0E-6) RETURN
      SL=LOG(SI)
      DO 13 N=0, NMAX
      FC=C1(N)*(C2(N)-SL)*XX
      CC=CC+FC
      S1=ABS(DBLE(FC))+ABS(IMAG(FC))
      S0=S0+S1
      IF(S1/S0 .LT. CONV) GOTO 15
   13 XX=XX*SI
      GOTO 91
   15 S0=LOG(S)
      S1=ETA*S0
      CC=1/(1-EXP(-PI2*ETA))-(0.0D0, 1.0D0)*EXP(CMPLX(S0,S1))*CC/PI2
      RETURN
   91 WRITE(6,92)S
   92 FORMAT(1H ,'(COUNF) No. conv. for S=',1PE13.4)
      STOP
      END
      SUBROUTINE GETDAT
C          read data from smat.out and
C          define all the elements in common /CDCC/
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CDCC/EDCM, FKCM, ETACM, SR(3, 3, 0:305), SI(3, 3, 0:305),
     +             JTMIN, JTMAX
      CHARACTER STR*60
C          number of coupled states     
      READ(7 ,*) NCC, JTMIN, JTMAX, JTINC
      IF(JTINC.NE.1)STOP '(GETDAT) JTinc != 1'
      READ(7,11)STR
   11 FORMAT(A60)
      DO 12 NN=1, NCC
      READ(7,*)N,A,B,C
      IF(NN .NE.1)GOTO 12
      EDCM =A
      FKCM =B
      ETACM=C
   12 CONTINUE
C        read S-matrix   
      NSKP=(NCC-1)/3
      DO 13 JJ=JTMIN, JTMAX 
      DO 13 NN=1, 3
      READ(7,*)JTOT, N
      IF(JTOT .LT. 0 .OR. JTOT .GT. 305) GOTO 93
      READ(7,*)(SR(M,N,JTOT),SI(M,N,JTOT),M=1,3)
      DO 13 M=1,NSKP
      READ(7,11)
   13 CONTINUE
C         check
      IF(JTMIN .NE. 0 .OR. JTINC .NE. 1) GOTO 91
      RETURN
   91 WRITE(6,92)JTMIN, JTMAX, JTINC
   92 FORMAT(1H ,'(JTMIN JTMAX JTINC)=(',3I3,') '/
     +       1H ,'unacceptable to calculate Xsec. etc !')
      STOP
   93 WRITE(6,94)JTOT
   94 FORMAT(1H ,'JTOT =',I3,2X,' is out of range !!')
      STOP
      END
      REAL*8 FUNCTION CG1(L, ML, IS, MS, J)
C        Clebsch-Gordan coeff. for spin 1.
C        IS=1 always 
C          Aug. 12 1999    Y. Aoki
      IMPLICIT REAL*8 (A-H,O-Z)
      CG1=0
      IF(IS .NE. 1)GOTO 90
C
      MJ=ML+MS
      IF(IABS(ML) .GT. L .OR. IABS(MS) .GT. IS .OR.
     +   IABS(MJ) .GT. J) RETURN
      IF(IABS(L-IS) .GT. J .OR. L+IS .LT. J) RETURN
C
      LMM=L-MJ
      LPM=L+MJ
      L2 =L+L
      FL2=L2+1
      ID=(J+1-L)*3+(MS+2)
      GOTO(1,2,3,4,5,6,7,8,9),ID
C       J=L-1, MS=-1
    1 CG1=SQRT(LPM*(LPM+1)/(L2*FL2))  
      RETURN
C       J=L-1, MS=0
    2 CG1=-SQRT(LMM*LPM/(L*FL2))
      RETURN
C       J=L-1,  MS=1
    3 CG1=SQRT(LMM*(LMM+1)/(L2*FL2))
      RETURN
C       J=L  MS=-1
    4 CG1=SQRT(LMM*(LPM+1.0D0)/(L2*(L+1)))
      RETURN
C       J=L,  MS=0
    5 CG1=MJ/SQRT(L*(L+1.0D0))
      RETURN
C       J=L,  MS=1
    6 CG1=-SQRT(LPM*(LMM+1)/(L2*(L+1.0D0)))
      RETURN
C       J=L+1,  MS=-1
    7 CG1=SQRT(LMM*(LMM+1)/(FL2*(FL2+1)))
      RETURN
C       J=L+1,   MS=0
    8 CG1=SQRT((LMM+1)*(LPM+1)/(FL2*(L+1)))
      RETURN
C       J=L+1,   MS=1
    9 CG1=SQRT(LPM*(LPM+1)/(FL2*(FL2+1)))
      RETURN
   90 WRITE(6,91)IS
   91 FORMAT(1H ,'(CG1) your IS=',I2,' != 1 !!')
      STOP
      END
