C  Intending the 2nd fixed version of dbu.f
C          2003/05/25
C          ACOEF: S-matrix divided by k(p-n) and mult. by (2*Pi)**1.5
C          spline interpolation modified Aug. 11
C          angle average over p/n slits
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FUND/EMP, EMN, EMD, EMT, EDL, QVAL, HBARC, PI
      COMMON /SLIT/ISC(2), SLTR(2), SLTX(2), SLTY(2),SOL(2),
     +             THETA(2), PHI(2), RR(3,3,2)
      CHARACTER FNAME*30, TITLE*50
      DIMENSION EPTAB(100), DTX(-1:1,-1:1,100), KNTL(5)
      DATA NEPMAX/100/
C           define I/O files
      OPEN(5,FILE='dbu.in', STATUS='OLD')
      OPEN(6,FILE='dbu.out',STATUS='UNKNOWN')
      READ(5,5)KNTL,TITLE
    5 FORMAT(5I2,A50)
      READ(5,6)FNAME
    6 FORMAT(A30)
C          scattering angle information
      READ(5,*)ANGPP, ANGPA, NEP
      READ(5,*)ANGNP, ANGNA
      WRITE(6,11)FNAME,KNTL,TITLE
   11 FORMAT(1H ,20X,' Program DBU by Y. Aoki',20X,'Dec. 2001 '//
     +       10X,'Smatrix file :',A20/10X,'KNTL=',5I2,'title:',A50)
      CALL DATIME
      IF(NEP.GT. NEPMAX) WRITE(6,12)NEP
   12 FORMAT(1H ,'Your NEP=',I4,' too large !'/10X,'New NEP=100')
      NEP=MIN(IABS(NEP), NEPMAX)
C
      LUN=10
      OPEN(LUN, FILE=FNAME,STATUS='OLD',ERR=91)
C          read S-matrix and convert to T-matrix.  TMT and DTM
      CALL SGET(LUN)
      CLOSE (LUN)
C          prepare interpolation and some other tables
      CALL PREP
      WRITE(6,21)ANGPP,ANGPA,ANGNP,ANGNA
   21 FORMAT(10X,' Proton (Theta, Phi)=(',F8.2,',',F8.2,') deg.'/
     +       10X,'Neutron (Theta, Phi)=(',F8.2,',',F8.2,') deg.')
C
      RAD=PI/180
      THETA(1)=ANGPP*RAD
      PHI  (1)=ANGPA*RAD
      THETA(2)=ANGNP*RAD
      PHI  (2)=ANGNA*RAD
C         here for simple triple differential cross sections 
      CALL TRIXSC(NEP, EPTAB, DTX)
      IF(KNTL(2) .LE.0) GOTO 50
C        here for integration over neutron solid angles
C          slit configuration
C ISC=0 for rectangular, =1 for circular slit, =2 whole solid angle
C       X/Y is half the jaw opening for ISC=0
C       X   is the radius for ISC=1
      CALL DATIME
      DO 31 I=1,2
   31 READ(5,*)ISC(I),SLTR(I),SLTX(I),SLTY(I)
      READ(5,*)CONV
      CALL AVR3DX(NEP, EPTAB, CONV, DTX)
      CALL DATIME
   50 STOP
   91 WRITE(6,92)FNAME
   92 FORMAT(1H ,'file open failure ',A30)
      STOP  
      END
      SUBROUTINE SGET(LUN)
C        read smat.out and returns T-matrix ==> DTM
C Input LUN: logical unit number of S-matrix file
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /SMT/ TMT(500,3,0:450), DTM(500,3,0:450), FKCM(500),
     +    FKS(500), ILS(20), IIS(20), NKB(20), IP0(20), IP1(20),      
     +             JTMAX, NPN, IIMAX, LSMAX, LLMAX, MMAX
      COMPLEX*16 TMT, DTM
      COMMON /FUND/EMP, EMN, EMD, EMT, EDL, QVAL, HBARC, PI
      DIMENSION EDCM(500), LD (500), JD(500), LDCM(500)
      DIMENSION   SR(500),  SI(500),STX(500)
      DIMENSION ISK ( 20)
      COMPLEX*16 CC(7000), CA, CW, AC(4)
C         save memory
C      EQUIVALENCE (TMT, CC)
      DATA JJMAX, NCCMAX, NPMAX,ICCMAX/ 450, 500, 20, 7000/
C          imaginary unit
      DATA  CW/ (0,1)/
C           read basic data for the S-matrix
      READ(LUN,*)NCC, JTMIN, JTMAX, JTINC, EMT
      IF(JTINC .NE. 1)     STOP '(SGET) your JTINC != 1 ' 
      IF(JTMAX .GT. JJMAX) GOTO 81
      IF(NCC   .GT.NCCMAX) GOTO 82
      READ(LUN,6)
    6 FORMAT(A50)
C                               SR is Coulomb parameter
      DO 10 N=1,NCC
      READ(LUN,*)I,EDCM(N),FKCM(N),SR(N),LDCM(N),LD(N),I,JD(N),
     +             FKS(N)
   10 CONTINUE
C      count NPN, the number of n-p states 
C
      NPN=0
      KK=0
      IIMAX=0
      LSMAX=0
      FKMX=0
      FKMN=FKCM(1)
      DO 11 N=4, NCC
      IF(IIMAX .LT. JD(N)  ) IIMAX=JD(N)
      IF(LSMAX .LT. LD(N)  ) LSMAX=LD(N)
      IF(FKMX  .LT. FKCM(N)) FKMX =FKCM(N)
      IF(FKMN  .GT. FKCM(N)) FKMN =FKCM(N)
      KL=10*LD(N)+JD(N)
      IF(KK .EQ. KL) GOTO 11
      NPN=NPN+1
      IF(NPN .GT. NPMAX) GOTO 83
      KK=KL
      ILS(NPN)=LD(N)
      IIS(NPN)=JD(N)
      IP0(NPN)=N
   11 IP1(NPN)=N
C
C         deuteron mass, lab. energy etc.
      FMU=EMP*EMN/(EMP+EMN)
      EMD=EMP+EMN+QVAL
      EMT=EMT*(EMN+EMP)/2
      RMS=EMD*EMT/(EMD+EMT)
      EDL=EDCM(1)*EMD/RMS
C     conversion of S matrix--> T matrix
C     imaginary unit and (p+n) wave number are postponed      
      ST=HBARC**2/(2*PI*RMS)
      FKI=FKCM(1)
C   count number of k-bins
      DO 13 NP=1, NPN
      I0=IP0(NP)
      I1=IP1(NP)
      F1=FKCM(I0)
      I2=2*IIS(NP)+1
      I3=I0+I2
      IF(I3 .GT. I1) GOTO 84
      F2=FKCM(I3)
      IK=1
      IF(ABS(F1-F2) .LT. 1.0E-5) IK=2
      ISK(NP)=IK
      NKB(NP)=(I1-I0+1)/(IK*I2)
      IF(IK .EQ. 2 .AND. (LSMAX .LT. ILS(NP)+2)) LSMAX=ILS(NP)+2
C                   S->T factor    
C      Hbar**2/(2*Pi*(d-t reduced mass)*sqrt(K_in*K_out))
C      imaginary unit i is retained 
      DO 12 I=I0, I1
   12 STX(I)=ST/SQRT(FKI*FKCM(I))
   13 CONTINUE
      WRITE(6,14)(N,IIS(N),ILS(N),ISK(N),NKB(N),IP0(N),IP1(N),N=1,NPN)
   14 FORMAT(/19X,'original n-p parameters '
     +       /11X,'N     I     L  ISkpl NKbin  IP0   IP1'/(6X,7I6))
C        evaluate Coulomb phase shift: 
C             SI and LD are volatile memory
C             JD(n) are pointers for L=0 Coulomb phase factor
      LLMAX=JTMAX+IIMAX
      ID=0
      IC=1
      DO 16 N=1, NCC
      E=SR(N)
C       check if evaluated already
      DO 15 I=1, ID
      IF(ABS(E-SI(I)) .LT. 1.0E-5) THEN 
         JD(N)=LD(I)
         GOTO 16
      END IF
   15 CONTINUE
      ICX=IC+LLMAX+1
      IF(ICX .GT. ICCMAX) GOTO 85
C  newly evaluate Coulomb phase factor (L=0 to LLMAX)
      CALL CPC(LLMAX, E, CC(IC))
      JD(N)=IC
      ID   =ID+1
      LD(ID)=IC
      SI(ID)=E
      IC=ICX
   16 CONTINUE
      IC=IC-1
      WRITE(6,17)IC,(SI(N), LD(N), N=1, ID)
   17 FORMAT(1H ,20X,'Eta      IP',2X,'(IPmax)=',I5/(1H ,17X,F8.5,I6))
C         read S-martix, then S --> T matrix
      DO 22 JT=0, JTMAX
      DO 22 IN=1,3
      READ(LUN,*,END=86,ERR=86)JJ, INIT
      READ(LUN,*,END=86,ERR=86)(SR(N),SI(N),N=1,NCC)
      IF(JJ .NE. JT) GOTO 87
      IF((JT.EQ.0) .AND. (IN.LE.2)) GOTO 22
C   Multiply Coulomb phase factor and  S->T factor with factor i recovered 
      L0=JT+IN-2
      CA=CC(L0+1)
      DO 21 N=4, NCC
      LFC=JT+LDCM(N)+JD(N)
      IF(LFC .LT. JD(2))GOTO 21
      TMT(N,IN,JT)=(-SI(N)+CW*SR(N))*CA*CC(LFC)*STX(N)
   21 CONTINUE
   22 CONTINUE
C         multiply A-coeff. and discouple T-matrices
C     sqrt(2*Pi)**3*exp{i(phase shift)}/(p-n wave-number)
      DO 30 NP=1, NPN
      IK=ISK(NP)
      NK=NKB(NP)
      I0=IP0(NP)
      LS=ILS(NP)
      II=IIS(NP)
      ML=2*II+1
      DO 29 MK=1, NK
      FK=FKS(I0)
      CALL ACOEF(LS, II, FK, AC)
      IF(IK .EQ. 1) GOTO 26
C        here for COUPLED states
      DO 24 M=1, ML  
      I1=I0+ML
      DO 23 JT=JTMIN, JTMAX
      DO 23 IN=1, 3
      CA           =AC(1)*TMT(I0,IN,JT)+AC(2)*TMT(I1,IN,JT)
      TMT(I1,IN,JT)=AC(3)*TMT(I0,IN,JT)+AC(4)*TMT(I1,IN,JT)
   23 TMT(I0,IN,JT)=CA
   24 I0=I0+1
      I0=I0+ML
      GOTO 29
C            here for UN coupled states
   26 CA=AC(1)
      DO 28 M =1, ML
      DO 27 JT=0, JTMAX
      DO 27 IN=1, 3  
   27 TMT(I0,IN,JT)=CA*TMT(I0,IN,JT)
   28 I0=I0+1     
   29 CONTINUE  
   30 CONTINUE
C        count number of TMT and DTM memory size 
      M=0
      DO 31 NP=1, NPN
   31 M=M+(NKB(NP)+2)*ISK(NP)*(2*IIS(NP)+1)
      NCX=M
      IF(M .GT. NCCMAX) GOTO 88
C
      FSX=SQRT(2*FMU*(EDCM(1)+QVAL))/HBARC
      FLX=FSX*SQRT(RMS/FMU)
C    reordering and adding ones of FKS=0 and F1 
C    inner loop   ->  outer loop
C old one   (L=J-I, J+I), (alpha, gamma), (wave number), (n-p I) 
C new one   (wave number), (L=J-I, J+I), (ell=I-1, I+1), (n-p I)
C   FKS modification --> EDCM(*) and  T-matrix --> DTM (*)
      DO 38 NP=NPN, 1, -1
      II=IIS(NP)
      NK=NKB(NP)
      IK=ISK(NP)
      I1=IP1(NP)
      ML=(2*II+1)*IK
      IP1(NP)=M
      DO 37 I= 1, IK
      I2=I1
      DO 36 L=-II, II
      I3=I2
C           (FKS)max = F1
      EDCM(M)=FSX
      STX (M)=0
      DO 32 JT=0, JTMAX
      DO 32 IN=1, 3
   32 DTM(M,IN,JT)=0
      M=M-1
C            FKS given by input table
      DO 34 N=1, NK
      EDCM(M)=FKS(I3)
      STX (M)=FKCM(I3)
      DO 33 JT=0, JTMAX
      DO 33 IN=1, 3
   33 DTM(M,IN,JT)=TMT(I3,IN,JT)
      M=M-1
   34 I3=I3-ML
C           (FKS)min = 0
      EDCM(M)=0
      STX (M)=FLX
      DO 35 JT=0, JTMAX
      DO 35 IN=1, 3
   35 DTM(M,IN,JT)=0
      M=M-1
   36 I2=I2-1
   37 I1=I1-(2*II+1)
   38 IP0(NP)=M+1
      DO 39 M=1, NCX
      FKCM(M)=STX(M)
   39 FKS(M)=EDCM(M)
C      WRITE(6,334)(M,FKCM(M),FKS(M),M=1,NCX)
  334 FORMAT(9X,'FKCM',14X,'FKS'/(I4,1P2E14.5))
C      IF(NCX .GT. -10) STOP 'NCX'
C       readjust NPN if ISK == 2
      M=0
      DO 41 NP=1, NPN
   41 M=M+ISK(NP)     
      NCCX=M
      IF(NCCX .GT. NPMAX) GOTO 89
      DO 43 NP=NPN, 1, -1
      IK=ISK(NP)
      DO 42 K=1, IK
      NKB(M)=NKB(NP)+2
      IIS(M)=IIS(NP)
      ILS(M)=ILS(NP)
      IP0(M)=IP0(NP)
      IP1(M)=IP1(NP)
   42 M=M-1
      IF(IK .EQ. 1) GOTO 43 
      ILS(M+2)=ILS(NP)+2
      IP1(M+1)=(IP0(M+1)+IP1(M+2))/2
      IP0(M+2)=IP1(M+1)+1
   43 CONTINUE
      NPN=NCCX
C
      WRITE(6,46)(M,IIS(M),ILS(M),NKB(M),IP0(M),IP1(M),M=1,NPN)
   46 FORMAT(/1H ,12X,'n-p parameters modified ( ISkpl => 1)'/
     +        1H ,10X,'N',5X,'I',5X,'L',10X,'Nk',3X,'IP0',3X,'IP1',
     +      /(1H , 5X,3I6,6X,3I6))
      WRITE(6,47)IIMAX,LSMAX,LLMAX,NPN,JTMAX
   47 FORMAT(/1H ,6X,'IImax=',I2,4X,'LSmax=',I2,4X,'LLmax=',I3,
     +             4X,'NPN=',I3,4X,'JTmax=',I3)
      WRITE(6,48)EDL
   48 FORMAT(/1H ,3X,'Ed(Lab)=',F8.4,'MeV')
C
      JTP=25
      INP=2
      IF(JTP.LT.0 .OR. JTP.GT. JTMAX) GOTO 50
      IF(INP.LT.1 .OR. INP.GT.     3) GOTO 50
C      WRITE(6,49)JTP,INP,(FKCM(I),FKS(I),DTM(I,INP,JTP),I=1,NCX)
   49 FORMAT('Jt=',I3,2X,'In=',I2/
     &      3X,'K(p+n)',5X,'k(p-n)',10X,'T'/(3X,0P2F9.5,1p2E15.7))
   50 RETURN
C      error messages
   81 WRITE(6,91)JTMAX,JJMAX
   91 FORMAT(1H ,'(SGET 81) your JTMAX=',I3,'>JJMAX=',I3)
      STOP   
   82 WRITE(6,92)NCC, NCCMAX
   92 FORMAT(1H ,'(SGET 82) your NCC=',I3,' while NCCMAX=',I4)
      STOP  
   83  WRITE(6,93)N,NPMAX
   93 FORMAT(1H ,'(SGET 83) at  N=',I3,' NPN >',I2,'!')
      STOP
   84 WRITE(6,94)NP
   94 FORMAT(1H ,'(SGET 84) Your K-bin too coarse ! for NP=',I2)
      STOP
   85 WRITE(6,95)ICX
   95 FORMAT(1H ,'(SGET 85) increase size of CC at least ',I5)
      STOP
   86 WRITE(6,96)JT, IN
   96 FORMAT(1H ,'(SGET 86) EOF or read error for S-matrix JT IN=',2I4)
      STOP   
   87 WRITE(6,97)JT, IN, JJ, INIT, F1
   97 FORMAT(1H ,'(SGET 87) at JT and IN=',2I3/
     +       1H ,3X,'JJ INIT DIF=',2I3,1PE12.3)
      STOP
   88 WRITE(6,98)M,NCCMAX
   98 FORMAT(1H ,'(SGET 88) M=',I4,' max. allowed is ',I4,' !')
      STOP  
   89 WRITE(6,99)MK
   99 FORMAT(1H ,'(SGET 89) failed to redefine FKCM incease -->',I3)
      STOP 
      END
      SUBROUTINE PREP
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FUND/EMP, EMN, EMD, EMT, EDL, QVAL, HBARC, PI
      COMMON /SMT/ TMT(500,3,0:450), DTM(500,3,0:450), FKCM(500),
     +    FKS(500), ILS(20), IIS(20), NKB(20), IP0(20), IP1(20),      
     +             JTMAX, NPN, IIMAX, LSMAX, LLMAX, MMAX
      COMPLEX*16 TMT, DTM
      COMMON /VCT/ CT(3000), VCTAB(120000), IPV(0:3)
      COMPLEX*16 CT
      COMMON /VCC/ F(0:1000), IFMAX
C            upper limits==  MMAX  CT   VCTAB
      DATA MX, ICMAX, IVMAX/  4,  3000, 120000/
C             check memory size of CT: 
      ICX=(2*IIMAX+1)*(JTMAX+1)
      IF(ICX .GT. ICMAX) GOTO 91
C           I0=1 is the incident deuteron spin
      I0=1
      MMAX=IIMAX+I0
      IF(MMAX .GT. MX) GOTO 93
C
C    (2*Pi)**3*sqrt((2*L0+1)/(4*Pi))<I0, M0, L0, 0; J, M0>*T(L0) 
C              ==> TMT(J, M0)
C     
      NCC=IP1(NPN)
      FAC=(2*PI)**3/SQRT(4*PI)
      DO 12 J = 0, JTMAX
      DO 12 M0=-1, 1
      MM=M0+2
      DO 11 IN=1,3
      L0=J+IN-2
      IF(L0 .LT. 0)F(IN)=0
   11 IF(L0 .GE. 0)F(IN)=(-1)**(L0+1-J)*SQRT(2*L0+1.0D0)*
     +                       CLEBI1(L0, 0, I0, M0, J)*FAC
      DO 12 N =1, NCC
   12 TMT(N,MM,J)=F(1)*DTM(N,1,J)+F(2)*DTM(N,2,J)+F(3)*DTM(N,3,J)     
C
C prepare interpolation table (2nd der.)/6 --> DTM
C
      DO 14 NP=1, NPN
      I0=IP0(NP)
      NKM=NKB(NP)-1
      ML=2*IIS(NP)+1
      DO 14 MM=1, ML
      DO 13 J=0, JTMAX
      DO 13 M=1, 3
   13 CALL PSPL3(NKM, FKS(I0), TMT(I0, M, J), DTM(I0, M, J), F)
   14 I0=I0+NKB(NP)
C              VCC table for final states
C           IS=1 is the spin of n-p pair and Nu its z component
C       <1/2, Np, 1/2, Nu; 1, Nu><Ls, Ml, 1, Nu; I, Mu>
C       <1/2, Np, 1/2, Nn; 1, Nu>=1/sqrt(2) if Nu=0 and 1 otherwise
      S2=1/SQRT(2.0D0)
      IS=1
      IV=0
      DO 21 NP=1, NPN
      II=IIS(NP)
      LS=ILS(NP)
      DO 21 NU=-IS, IS
      FAC=1
      IF(NU .EQ. 0)FAC=S2
      DO 21 MU=-II, II
      ML=MU-NU
      IF(IABS(ML) .GT. LS) GOTO 21
      IV=IV+1
      VCTAB(IV)=FAC*CLEBI1(LS, ML, IS, NU, II)
   21 CONTINUE   
C         count the necessary size of VCTAB
      DO 25 II= 0, IIMAX
   25 IPV(II)= 0
      M=IV
      DO 26 NP=1, NPN
      II=IIS(NP)
      IF(IPV(II) .GT. 0) GOTO 26
      M=M+3*(2*II+1)*((2*II+1)*(JTMAX+1)-II*(II+1))
      IPV(II)=1
   26 CONTINUE
      DO 27 II=0, IIMAX
   27 IPV(II)=0     
      IF(M .GT. IVMAX) GOTO 95
      WRITE(6,28)ICX,IV,M
   28 FORMAT(/1H ,10X,'(PREP) ICX for CT=',I5,2X,'VCTAB (S=1)=',I4,
     +             2X,'total=',I8/)  
C
C             F(n)=n!/256**n
C
      IFMAX=1000
      F(0)=1
      DO 29 N=1, IFMAX
   29 F(N)=(N*F(N-1))/256
C         VCC table for partial waves <I, MU, L, M; J, M0>
C         
      DO 32 NP= 1, NPN
      II=IIS(NP)
      IF(IPV(II) .GT. 0) GOTO 32
      IPV(II)=IV
      DO 31 M0=-1,  1
      DO 31 MU=-II, II
      M=M0-MU
      DO 31 J =0, JTMAX
      L0=J-II
      L1=J+II
      DO 31 L=L0, L1
      IV=IV+1
   31 VCTAB(IV)=CLEBR(II, MU, L, M, J)
   32 CONTINUE
      RETURN
   91 WRITE(6,92)ICX, ICMAX
   92 FORMAT(1H ,'(PREP) you requested ',I5,' for CT while ',I5,
     +           'is allocated !')
      STOP   
   93 WRITE(6,94)MMAX, MX
   94 FORMAT(1H ,'(PREP) your MMAX=',I2,' is larger than ',I2)
      STOP  
   95 WRITE(6,96)M, IVMAX
   96 FORMAT(1H ,'(PREP) your VCTAB size=',I7,'>',I7,2X,'error !!')
      STOP   
      END  
      SUBROUTINE TRIXSC(NEP, EPTAB, TX)
C        triple Xsec. for deuteron break-up reactions
C        z-axis along deuteron incident direction
C Input THETP, PHIP: proton dectection angles(polar and azimuthal )
C       THETN, PHIN: same as above for neutron.
C                    angles in radian
C       NEP        : number of proton energy bin 
C Output EPTAB(NEP): proton energy table
C        TX   (NEP): triple differential cross sections (mb/(MeV,sr**2))
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FUND/EMP, EMN, EMD, EMT, EDL, QVAL, HBARC, PI
      COMMON /SLIT/ISC(2), SLTR(2), SLTX(2), SLTY(2),SOL(2),
     +             THETA(2), PHI(2), RR(3,3,2)
C                               Sz , Iz    of deuteron
      DIMENSION EPTAB(NEP), TX(-1:1, -1:1, NEP), XPN(-1:1, -1:1)
      DIMENSION XSC(-1:1)
C
      WRITE(6,101)
  101 FORMAT('#    TRIXSC entered')
C        recover angles
      THETP=THETA(1)
      THETN=THETA(2)
      PHIP =PHI  (1)
      PHIN =PHI  (2)
C  deuteron momentum. center of mass momentum 
      PD=SQRT(2*EMD*EDL)
      PG=EMD*PD/(EMD+EMT)
C         some parameters, which are indep. of vector q
      CP=COS(THETP)
      SP=SIN(THETP)
      CAP=COS(PHIP)
      SAP=SIN(PHIP)
      ENX=SIN(THETN)*COS(PHIN)
      ENY=SIN(THETN)*SIN(PHIN)
      ENZ=COS(THETN)
      EMSUM=EMN+EMT
      RFAC=EMN/EMSUM
      EMNT=RFAC*EMT
      EMPN=EMP+EMN
C        Xsec factor 2*Pi/(hbar*velocity) and fm**2 -> mb
      DEN0=EMP*EMN*EMT/(2*PI*HBARC)**6
      DEN0=10*DEN0*2*PI*EMD/(HBARC*PD)
C        calculate max. proton momentum for given ThetaP
      A=1/EMP+1/EMSUM
      B=PD*CP/EMSUM
      C=(1-EMD/EMSUM)*EDL+QVAL
      IF(C .LT. 0) GOTO 91
      D=B**2+2*A*C
      IF(D .LT. 0) GOTO 93
      IF(B .GE. 0) PPMAX=(B+SQRT(D))/A
      IF(B .LT. 0) PPMAX=-2*C/(B-SQRT(D))
      EPMAX=PPMAX**2/(2*EMP)
C         mesh size of proton energy and momentum
      DEP=EPMAX/NEP
      IF(DEP .LT. 0.05) DEP=0.05
      NEX=EPMAX/DEP+0.01
      EP=DEP/2
C
      WRITE(6,10)(I,I=-1,1)
   10 FORMAT(/'#',4X,'triple diff. Xsec (mb/(sr(p) sr(n) Ep(MeV)))'/
     +       '# Ep(MeV)',3(4X,'Md=',I2,4X),4X,'aver.')
C         loop for proton energies
      DO 20 NE=1, NEX
      PP=SQRT(2*EP*EMP)
      PPX=PP*SP*CAP
      PPY=PP*SP*SAP
      PPZ=PP*CP
      PLZ=PD-PPZ
      PL2=PPX**2+PPY**2+PLZ**2
      Q2=2*EMNT*(EDL+QVAL-EP-PL2/(2*EMSUM))
      R2=PL2*RFAC**2
      RN=RFAC*(-PPX*ENX-PPY*ENY+PLZ*ENZ)
      RP2=R2-RN**2
      EPTAB(NE)=EP
      DO 11 MU=-1,1
      DO 11 NU=-1,1
   11 TX (NU,MU,NE)=0
      IF(RP2 .GT. Q2) GOTO 20
      ADD=SQRT(Q2-RP2)
      DO 15 IS=-1, 1, 2
      PN=RN+IS*ADD
      IF(PN .LT. 0) GOTO 15
      PNX=PN*ENX
      PNY=PN*ENY
      PNZ=PN*ENZ
C         CM wave number and angles of p+n system
      FPX=PPX+PNX
      FPY=PPY+PNY
      FPZ=PPZ+PNZ-PG
      FPXY=FPX**2+FPY**2
      THELP=ATAN2(SQRT(FPXY), FPZ)
      PHILP=0
      IF(ABS(FPX) .GT. 1.0E-6) PHILP=ATAN2(FPY, FPX)
C        wave number and angles of p-n system
      FKX=(EMP*PNX-EMN*PPX)/EMPN
      FKY=(EMP*PNY-EMN*PPY)/EMPN
      FKZ=(EMP*PNZ-EMN*PPZ)/EMPN
      FKXY=FKX**2+FKY**2
      THESK=0
      PHISK=0
      IF(ABS(FKZ) .GT. 1.0E-6) THESK=ATAN2(SQRT(FKXY), FKZ)
      IF(ABS(FKX) .GT. 1.0E-6) PHISK=ATAN2(     FKY,   FKX)
      FKS=SQRT(FKXY+FKZ**2)/HBARC
C
      CALL XPNCAL(FKS, THELP, PHILP, THESK, PHISK, XPN)
C        10*( state density ): fm --> mb
      DENS=DEN0*PP*PN/(EMSUM+EMN*(ENX*PPX+ENY*PPY-ENZ*PLZ)/PN)
      DO 12 MU=-1,1
      DO 12 NU=-1,1
   12 TX(NU,MU,NE)=TX(NU,MU,NE)+XPN(NU,MU)*DENS
   15 CONTINUE
C            summing up 
      DO 17 MU=-1,1
C        Nu=0 comes from (Np,Nn)=(1/2,-1/2) and (-1/2,1/2)
C        but S=0 contribution should not be taken into account
      SUM=0
      DO 16 NU=-1,1
   16 SUM=SUM+TX(NU,MU,NE)
   17 XSC(MU)=SUM  
      SUM=(XSC(-1)+XSC(0)+XSC(1))/3
      WRITE(6,18)EP,XSC,SUM
   18 FORMAT(0PF7.3,1P4E14.5)
   20 EP=EP+DEP     
C******** print TX *************
      DO 30 MU=-1,1
      WRITE(6,21)MU
   21 FORMAT('# TRIXSC Mu=',I2/
     +       '# Ep(MeV)',3X,'NU=-1',5X,'NU=0',5X,'NU=1')
      DO 23 NE=1,NEX
      WRITE(6,22)EPTAB(NE),(TX(NU,MU,NE),NU=-1,1)
   22 FORMAT(0PF8.4,1P3E14.5)
   23 CONTINUE
   30 CONTINUE
      RETURN
C           error messages
   91 WRITE(6,92)EDL
   92 FORMAT(1H ,'your Ed=',F8.4,' too small !')
      STOP  
   93 WRITE(6,94)A,B,C,D
   94 FORMAT(1H ,'A B C D=',1p4E12.3,2X,'Neg. sqrt !'  )
      STOP
      END
      SUBROUTINE XPNCAL(FK, TL, PL, TS, PS, XPN)
C returns T(NU, M0)*CONJG(T(NU, M0))
C Input FK: magnitude of wave number of p-n relative motion
C       TL, PL: polar and azimuthal angle of CM wave number
C       TS, PS: same as above for n-p relative motion
C Output XPN(NU, M0)=T(NU,M0)*CONJG(T(NU, M0))  
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /SMT/ TMT(500,3,0:450), DTM(500,3,0:450), FKCM(500),
     +    FKS(500), ILS(20), IIS(20), NKB(20), IP0(20), IP1(20),      
     +             JTMAX, NPN, IIMAX, LSMAX, LLMAX, MMAX
      COMPLEX*16 TMT, DTM
C   0:3 in IPV, -3:3 in (CI and TF), 0:4 in (CML, CMS and YLM0) are
C           due to IIMAX=3
      COMMON /VCT/ CT(3000), VCTAB(120000), IPV(0:3)
      COMPLEX*16 CT
      COMPLEX*16 CML(0:4), CMS(0:4), CF(-3:3,-1:1), TFI(-1:1, -1:1),
     +           C1, C2
      DIMENSION  XPN(-1:1, -1:1), YLML0(0:405,0:4), YLMS0(0:3,0:3)
C           memory size of YLM0
      DATA LSX, MSX, LLX, MLX/ 3, 3, 405, 4/
C         spin of incident deuteron = 1
C        exp(i*M*(phi)) should later be multiplied 
      IF(LSMAX .GT. LSX) GOTO 91
      IF(LLMAX .GT. LLX .OR. MMAX .GT. MLX) GOTO 93
      CALL YLM0TB(TS, LSX, MSX, YLMS0)  
      CALL YLM0TB(TL, LLX, MLX, YLML0)
C         exp(i*m*(azimuthal angle))
      DO 11 M=0, MMAX
      FAC=M*PL
      CML(M)=DCMPLX(COS(FAC), SIN(FAC))
      FAC=M*PS
   11 CMS(M)=DCMPLX(COS(FAC), SIN(FAC))
C      
      DO 12 M0=-1,1
      DO 12 NU=-1,1
   12 TFI(NU,M0)=0
C          summing up 
      IVF=0
      DO 24 NP=1, NPN
      II=IIS(NP)
      LS=ILS(NP)
C          final state information 
      DO 21 NU= -1, 1
      DO 21 MU=-II,II
      M =MU-NU
      MA=IABS(M)
      CF(MU,NU)=0
      IF(MA .GT. LS) GOTO 21
      YLM=YLMS0(LS,MA)
      IF(M .GT. 0) YLM=(-1)**M*YLM
      C1=CMS(MA)
      IF(M .LT. 0) C1=CONJG(C1)
      IVF=IVF+1
      CF(MU,NU)=VCTAB(IVF)*YLM*C1
   21 CONTINUE  
C         evaluate Cp
      IV=IPV(II)
      DO 24 M0=-1,1
      MM=M0+2
      CALL TEVAL(MM, NP, FK, CT)
      DO 24 MU=-II,II
      M =M0-MU
      MA=IABS(M)
      C1=CML(MA)
      IF(M .LT. 0) C1=CONJG(C1)
      IF(M .GT. 0) C1=(-1)**M*C1
C       sum up partial wave contributions
      C2=0
      IC=0
      DO 22 J=0, JTMAX
      L0=J-II
      L1=J+II
      DO 22 L=L0, L1
      IC=IC+1
      IV=IV+1
   22 C2=C2+VCTAB(IV)*YLML0(L,MA)*CT(IC) 
      C2=C1*C2
C          spin representation
      DO 23 NU=-1,1
   23 TFI(NU,M0)=TFI(NU,M0)+C2*CF(MU,NU)
   24 CONTINUE  
C         absolute square of TFI
      DO 31 M0=-1,1
      DO 31 NU=-1,1
   31 XPN(NU,M0)=TFI(NU,M0)*CONJG(TFI(NU,M0))     
      RETURN
C
   91 WRITE(6,92)LSMAX, LSX
   92 FORMAT(1H ,'(XPNCAL) your LSMAX=',I2,'> ',I2,2X,'error !')
      STOP  
   93 WRITE(6,94)LLMAX, MMAX, LLX, MLX  
   94 FORMAT(1H ,'(XPNCAL)  your (LLMAX MMAX)=(',I3,',',I2,') while'/
     +       1H ,28X,'(',I3,',',I2,') allocated.   Error !')
      STOP 
      END
      SUBROUTINE PSPL3(N, X, Y, DY, P)
C  3rd order P-spline.       returns (2nd derivative)/6
C Input N: define size of the problem
C       X(0:N): abscisae of nodes
C       Y(0:N): ordinates of nodes
C Output DY(0:N, M): (2nd derivative)/6
C working area P(0:N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(0:N), Y(0:N), DY(0:N), P(0:N)
      COMPLEX*16 Y, DY, YU, YV
C
      U=  X(1)-X(0)
      YU=(Y(1)-Y(0))/U
      DO 1 I=1,N-1
      IP=I+1
      V =U
      YV=YU
      U=  X(IP)-X(I)
      YU=(Y(IP)-Y(I))/U
      W=1/(2*(X(IP)-X(I-1)))
      P(I)=V*W
    1 DY(I)=(YU-YV)*W
C
      DY(0)=0
      DY(N)=0
      P(0)=-1
      DO 2 I=1,N-1
      V=1/(1-P(I)*P(I-1))
      DY(I)=(DY(I)-P(I)*DY(I-1))*V
    2 P(I)=(0.5D0-P(I))*V
C       define DY(N) for P-spline
      DY(N)=DY(N-1)/(1+P(N-1))
      DO 3 I=N-1,0,-1
    3 DY(I)=DY(I)-P(I)*DY(I+1)
      RETURN
      END
      SUBROUTINE TEVAL(MM, NP, FK, CT)
C        interpolate TMT and store them to CT
C Input MM: M0, 2nd suffix of TMT. Z comp. of spin of inc. deuteron
C       NP: n-p channel identifier
C       FK: wave number of n-p relative motion
C Output CT(*): interpolated values
C               size of CT was checked in PREP
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /SMT/ TMT(500,3,0:450), DTM(500,3,0:450), FKCM(500),
     +    FKS(500), ILS(20), IIS(20), NKB(20), IP0(20), IP1(20),      
     +             JTMAX, NPN, IIMAX, LSMAX, LLMAX, MMAX
      COMPLEX*16 TMT, DTM
      COMPLEX*16 CT(*)
C
      II=IIS(NP)
      NK=NKB(NP)
      I0=IP0(NP)
      I1=I0+NK-1
      DO 1 I=I0+1, I1
      IF((FK-FKS(I-1))*(FK-FKS(I)) .LE. 0) GOTO 2
    1 CONTINUE
      GOTO 91
C        sandwitched FKS
    2 ML=(2*II+1)*(JTMAX+1)
      DO 3 IC=1, ML
    3 CT(IC)=0      
      IS=I-1
      IX=IS
      H = FKS(I)-FKS(IS)
      S =(FK    -FKS(IS))/H
      T =1-S
      H2=H**2
      SS=S*(S**2-1)*H2
      TT=T*(T**2-1)*H2
      IC=0
      DO 5 J=0, JTMAX
      L0=J-II
      L1=J+II
      LMN=IABS(L0)
      DO 4 L=L0, L1
      IC=IC+1
      IF(L .LT. LMN) GOTO 4
      IT=IS+1
      CT(IC)=TMT(IS,MM,J)*T +TMT(IT,MM,J)*S
     +      +DTM(IS,MM,J)*TT+DTM(IT,MM,J)*SS
    4 IS=IS+NK
    5 IS=IX
      RETURN
C
   91 WRITE(6,92)FK, FKS(I0), FKS(I1)
   92 FORMAT(1H ,'(TEVAL) your FKS=',1PE15.7,' is out of [',
     +           1PE10.3,',',1PE10.3,'] !')
      STOP
C      RETURN
      END
      REAL*8 FUNCTION CLEBR(J1, M1, J2, M2, J3)
C         Clebsch-Gordan coeff. by Racah's expression
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /VCC/F(0:1000), IFMAX
      CLEBR=0
      M3=M1+M2
      IF(IABS(M1).GT.J1 .OR. IABS(M2).GT.J2 .OR. IABS(M3).GT.J3 
     +  .OR. IABS(J1-J2).GT.J3 .OR. J1+J2.LT.J3) RETURN
      IF(J1+J2+J3+1 .GT. IFMAX) GOTO 91
C        make J2 the smallest
      I1=J1
      I2=J2
      I3=J3
      N1=M1
      N2=M2
      N3=M3
      FAC=1
C
      IF(I1 .GE. I2) GOTO 1
      IX=I1
      I1=I2
      I2=IX
      IX=N1
      N1=N2
      N2=IX
      FAC=(-1)**(I1+I2-I3)
C
    1 IF(I3 .GE. I2) GOTO 2
      FAC=FAC*(-1)**(I1-N1)*SQRT((2*I3+1.0D0)/(2*I2+1.0D0))
      IX=I3
      I3=I2
      I2=IX
      IX=N3
      N3=-N2
      N2=-IX
C
    2 K1=I1-N1
      K2=I2+N2
      K3=I3-N3
      K4=I1+I2-I3
      FAC=FAC*SQRT((2*I3+1)*(F(I1-I2+I3)/F(I1+I2+I3+1))*
     *  (F(I2+I3-I1)/F(K4))*(F(I1+N1)   /F(K1))*
     *  (F(I2-N2   )/F(K2))*(F(I3+N3)   /F(K3)))/16
      K5=I2-I3-N1
      K6=I1+N2-I3
      NUMIN=MAX(0,  K5, K6)
      NUMAX=MIN(K1, K2, K4)
      IF(NUMIN .GT. NUMAX) RETURN
      FAC=(-1)**NUMIN*FAC
      DO 3 NU=NUMIN, NUMAX
      CLEBR=CLEBR+FAC*(F(K1)/F(K1-NU))*(F(K2)/F(K2-NU))
     *               *(F(K4)/F(K4-NU))*(F(K3)/F(NU-K5))/(F(NU)*F(NU-K6))
    3 FAC=-FAC
      RETURN
   91 WRITE(6,92)IFMAX,J1,M1,J2,M2,J3,M3
   92 FORMAT(1H ,'(CLEBR) F(',I5,') pun !! for  <',3(I4,','),I4,';',
     +           I4,',',I4,'>')
      STOP
      END   
      REAL*8 FUNCTION CLEBI1(L, ML, IS, MS, J)
C        Clebsch-Gordan coeff. for spin 1.
C        IS=1 always 
      IMPLICIT REAL*8 (A-H,O-Z)
      CLEBI1=0
      MJ=ML+MS
      IF(IS .NE. 1) THEN
         WRITE(6,91)IS
   91    FORMAT(1H ,'(ClebI1) your IS !=',I2,' !!')
         STOP
      END IF
      IF(IABS(ML) .GT. L .OR. IABS(MS) .GT. IS .OR.
     +   IABS(MJ) .GT. J) RETURN
      IF(IABS(L-IS) .GT. J .OR. L+IS .LT. J) RETURN
      LMM=L-MJ
      LPM=L+MJ
      L2=L+L
      FL2=L2+1.0D0
      ID=(J+1-L)*3+(MS+2)
      GOTO(1,2,3,4,5,6,7,8,9),ID
C       J=L-1, MS=-1
    1 CLEBI1=SQRT(LPM*(LPM+1.0D0)/(L2*FL2))  
      RETURN
C       J=L-1, MS=0
    2 CLEBI1=-SQRT(LMM*LPM/(L*FL2))
      RETURN
C       J=L-1,  MS=1
    3 CLEBI1=SQRT(LMM*(LMM+1.0D0)/(L2*FL2))
      RETURN
C       J=L  MS=-1
    4 CLEBI1=SQRT(LMM*(LPM+1.0D0)/(L2*(L+1.0D0)))
      RETURN
C       J=L,  MS=0
    5 CLEBI1=MJ/SQRT(L*(L+1.0D0))
      RETURN
C       J=L,  MS=1
    6 CLEBI1=-SQRT(LPM*(LMM+1.0D0)/(L2*(L+1.0D0)))
      RETURN
C       J=L+1,  MS=-1
    7 CLEBI1=SQRT(LMM*(LMM+1.0D0)/(FL2*(FL2+1.0D0)))
      RETURN
C       J=L+1,   MS=0
    8 CLEBI1=SQRT((LMM+1.0D0)*(LPM+1.0D0)/(FL2*(L+1.0D0)))
      RETURN
C       J=L+1,   MS=1
    9 CLEBI1=SQRT(LPM*(LPM+1.0D0)/(FL2*(FL2+1.0D0)))
      RETURN
      END
      SUBROUTINE YLM0TB(THETA, LMAX, MMAX, YLM0)
C        returns spherical harmonics at 0 azimuthal angle
C Input THETA: angle in radian
C       LMAX, MMAX: Lmax and Mmax
C Output YLM0(LPLUS, MPLUS)
C       YLM0=sqrt((2*L+1)*(L-abs(M))!/(4*PI*(L+abs(M))!)
C                        *P(L, abs(M), cos(Theta))
C      zero and negative M only
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION  YLM0(0:LMAX, 0:MMAX)
      IF(LMAX .GT. 405 .OR. MMAX .GT. 4) GOTO 91
      IF(LMAX .LT. MMAX) GOTO 93
C
      X=COS(THETA)
      S=SIN(THETA)
      WFAC=1/SQRT(4*3.141592653589793238D0)
C      WFAC=1  <--- for Legendre functions
      DO 12 M=0, MMAX
      DO 11 L=0,M-1
   11 YLM0(L,M)=0
      F0=M+M
      F1=F0+1
      F2=1
      P0=0
      P1=WFAC
      WFAC=WFAC*F1*S
      YLM0(M,M)=P1
      DO 12 L=M+1, LMAX
      P2=(F1*X*P1-F0*P0)/F2
      F0=F0+1
      F1=F1+2
      F2=F2+1
      YLM0(L,M)=P2
      P0=P1
   12 P1=P2
C  -------  return if Legendre function table is in order -------
C        weight using factorial
      DO 14 M=0, MMAX
      F1=1
      DO 13 L=2,2*M
   13 F1=F1*L
      WFAC=1/F1
      F0=0
      F1=2*M
      F2=F1+1
      DO 14 L=M,LMAX
      YLM0(L,M)=YLM0(L,M)*SQRT(F2*WFAC)
      F0=F0+1
      F1=F1+1
      F2=F2+2
   14 WFAC=WFAC*F0/F1
      RETURN
   91 WRITE(6,92)LMAX, MMAX
   92 FORMAT(1H ,'(YLM0TB) your LMAX=',I3,' MMAX=',I2,' are more than',
     +           ' accepted')
      STOP
   93 WRITE(6,94)LMAX, MMAX
   94 FORMAT(1H ,'(YLM0TB) your LMAX(',I3,') < ','MMAX(',I3,') !')  
      STOP
      END
      SUBROUTINE CPC(LMAX, ETA, ESIG)
C  SIGCAL ץ˴ؤ
C    ѥ᡼ ETA Ϳơ$\exp{i\sigma_L}$ ɽ֤
C    դơ      
C    LMAX 絰ƻѱư      
C    ETA  ѥ᡼
C    ESIG(L) $\exp{i\sigma_L}$
C        returns exp(i*simga_L))
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 ESIG(0:LMAX)
C
      LL=MAX(INT(ETA+0.5), LMAX)+2
      FL=LL+1
      CX=FL**2+ETA**2
      SX=SQRT(CX)
      C0=ATAN2(ETA, FL)
      S0=(FL-0.5D0)*C0+ETA*LOG(SX)-ETA
     +   +(((((691*SIN(11*C0)/360360    -SIN( 9*C0)/1188)/CX
     +   +         SIN( 7*C0)/  1680)/CX-SIN( 5*C0)/1260)/CX
     +   +         SIN( 3*C0)/   360)/CX-SIN(   C0)/  12)/SX
      C1=COS(S0)
      S1=SIN(S0)
      L1=LMAX+1
      DO 15 L=LL,1,-1
      T=ETA/L
      CX=1/SQRT(1+T*T)
      SX=T*CX
      C0= CX*C1+SX*S1
      S1=-SX*C1+CX*S1
      C1=C0
      IF(L .LE. L1) ESIG(L-1)=DCMPLX(C1, S1)
   15 CONTINUE
      RETURN
      END
      SUBROUTINE ACOEF(LS, JS, FK, CA)
C  returns Blatt-Biedenharn phase shift of triplet p-n states 
C  quantum numbers (LS, JS, FK): LS=0,1,2,3: JS=0,1,3 are allowed
C                               0 < fk  < 1.2/fm
C     CA(1)=exp(i*delta)*Qfac for uncouppled states
C              for coupled states
C     CA   =|  cos(eps)*exp(i*del-a),  sin(eps)*exp(i*del-a) |
C           | -sin(eps)*exp(i*del-g),  cos(eps)*exp(i*del-g) |*Qfac
C              ID=2*L+J
C   ID=1(3S1), ID=2(3P0), ID=3(3P1), ID=4(3P2)
C   ID=5(3D1), ID=6(3D2), ID=7(3D3), ID=8(3F2)
C     Qfac=sqrt(2*Pi)**3/(wave number)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /AGE/ V(7,8), W(7,2)
      COMPLEX*16 CA(*), C1, C2, CW
C                imaginary unit, (2*Pi)**(3/2)      
      DATA CW , SQ3P/(0,1),      15.74960994572242D0/
C
      IF(IABS(JS-1) .GT. LS .OR. JS+1 .LT. LS) GOTO 91
C
      ID=2*LS+JS
      IF(ID .LE. 0   .OR. ID .GE. 9    ) GOTO 93
      IF(FK .LT. 0.0 .OR. FK .GT. 1.2D0) GOTO 93
      QFAC=SQ3P/FK
C       coupled states ?
      IF(ID.EQ.1 .OR. ID.EQ.4 .OR. ID.EQ.5 .OR. ID.EQ.8) GOTO 2
C           here for UNcoupled states
      P=V(1,ID)
      X=FK
      DO 1 I=2,7
      P=P+X*V(I,ID)
    1 X=X*FK
C          divided by wave number  6/16
      CA(1)=EXP(CW*P)*QFAC
      RETURN
C           here for COUPLED states
    2 I1=1
      I2=5
      I3=1
      IF(JS .EQ. 2) THEN
        I1=4
        I2=8
        I3=2
      END IF
      P=V(1,I1)
      Q=V(1,I2)
      R=W(1,I3)
      X=FK
      DO 3 I=2,7
      P=P+X*V(I,I1)
      Q=Q+X*V(I,I2)
      R=R+X*W(I,I3)
    3 X=X*FK
C        P for alpha, Q for gamma and R for epsilon 
      C1=EXP(CW*P)
      C2=EXP(CW*Q)
      C=COS(R)*QFAC
      S=SIN(R)*QFAC
      CA(1)= C*C1
      CA(2)=-S*C2
      CA(3)= S*C1
      CA(4)= C*C2
      RETURN
C       error messages
   91 WRITE(6,92)LS,JS  
   92 FORMAT(1H ,'(ACOEF) LS=',I2,2X,'JS=',I2,' NOT triplet !!')  
      STOP
   93 WRITE(6,94)ID, LS, JS, FK
   94 FORMAT(1H ,'(ACOEF) your ID LS JS =',3I5,' FK=',1PE12.3,
     +       2X,'NOT available !!')
      STOP
      END
      BLOCK DATA 
C  p-n phase shift and mixing angle (Blatt-Biedenharn)
C       define expansion coefficients of phase shift and mixing angles
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /AGE/V(7,8), W(7,2)
C        fundamental values
      COMMON /FUND/EMP, EMN, EMD, EMT, EDL, QVAL, HBARC, PI
      DATA  EMP, EMN, QVAL / 938.27231D0, 939.56563D0,-2.224600D0/
      DATA HBARC, PI /197.327053D0, 3.14159265358979D0/
C         phase shift
      DATA V/
C        3S1 phase shift
     +         3.15600E+0,  -6.06932E+0,   7.90549E+0,  -4.66650E+0,    
     +        -1.99277E+0,   3.78284E+0,  -1.28733E+0,
C        3P0 phase shift
     +         1.51286E-3,  -5.34715E-2,   3.97718E-1,   2.52385E+0,    
     +        -6.08080E+0,   4.64035E+0,  -1.22156E+0,
C        3P1 phase shift
     +        -1.43718E-3,   5.72722E-2,  -5.71887E-1,   3.97542E-1,    
     +         1.19178E-1,  -3.43042E-1,   1.37656E-1,
C        3P2 phase shift June:2001
     + -2.8351324e-04,  1.2527534e-02, -1.4025071e-01,  8.2164162e-01,
     + -6.5313757e-01,  1.2457174e-01,  1.7760255e-02,
C        3D1 phase shift : 2001/June
     +  7.7560151e-04, -3.6125774e-02, 4.3315556e-01, -1.9236123e+00,
     +  2.2595768e+00, -1.1465772e+00, 2.2264086e-01,
C        3D2 phase shift
     +        -9.04806E-4,   4.17399E-2,  -4.81404E-1,   1.98753E+0,    
     +        -1.64705E+0,   3.24774E-1,   5.93235E-2,
C        3D3 phase shift
     +         2.02019E-5,  -8.05774E-4,   8.29753E-3,  -3.48900E-2,    
     +         6.82650E-2,  -2.47536E-2,  -3.16763E-4,
C        3F2 phase shift  2001/June
     +  8.3908023e-05, -4.4965497e-03,  5.9621552e-02,  -2.8332504e-01,
     +  4.6301886e-01, -3.0664974e-01,  7.5341522e-02/
C  mixing angle epsilon 
      DATA W/
C        3S1-3D1 mixing angle epsilon   2001/June
     +  2.1267205e-04, -1.2909769e-02, 5.2476748e-01,  -1.3700226e+00,
     +  1.6279772e+00, -9.0961833e-01, 2.0115580e-01,
C        3P2-3F2 mixing angle  2001/June/18
     +  1.7261595e-02,  -5.6215154e-01, -5.6752727e+00,  2.3229221e+01,
     + -3.4628587e+01,   2.3309079e+01, -5.9402889e+00/
      END
      SUBROUTINE GLITAB
C define Gauss-Legendre integration parameters frm N=2,4 to NLX=20
      IMPLICIT REAL*8 (A-H,O-Z)
C        210=NLX*(NLX+1)/2
      COMMON /GLI/XL(210), WL(210), NLX
C
      DATA PI, CONV/3.14159265358979D0, 1.0D-15/
C      NLX=20
      K=1
      DO 5 N=1,NLX
      NN=N+N
      DO 4 I=1,N
      X=SIN((NN+1-2*I)*(PI/(2*NN+1)))
      DO 2 J=1,5
      P0=1
      P1=X
      DO 1 L=2,NN
      P2=((2*L-1)*X*P1-(L-1)*P0)/L
      P0=P1
    1 P1=P2
      X2=1-X*X
      P1=P2*X2/(NN*(P0-X*P2))
      X=X-P1
      IF(ABS(P1).LE.CONV)GOTO 3
    2 CONTINUE
      GOTO 91
    3 XL(K)=X
      WL(K)=2*X2/(NN*P0)**2
    4 K=K+1
    5 CONTINUE
      RETURN
C
   91 WRITE(6,92)N,I,X
   92 FORMAT('(GLITAB) No conv. for N=',I3,2X,'I=',I3,2X,'X=',F8.3)
      STOP
      END
      SUBROUTINE RMAT(THETA, PHI, RR)
C       rotation from z axis to (Theta, Phi)
C      angles are in radian
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TR(3,3), PR(3,3), RR(3,3)
C        rotation of Theta around the y axis
      CT=COS(THETA)
      ST=SIN(THETA)
      TR(1,1)=CT
      TR(1,2)=0
      TR(1,3)=ST
      TR(2,1)=0
      TR(2,2)=1
      TR(2,3)=0
      TR(3,1)=-ST
      TR(3,2)=0
      TR(3,3)=CT
C        rotate Phi around z axis
      CP=COS(PHI)
      SP=SIN(PHI)
      PR(1,1)=CP
      PR(1,2)=-SP
      PR(1,3)=0
      PR(2,1)=SP
      PR(2,2)=CP
      PR(2,3)=0
      PR(3,1)=0
      PR(3,2)=0
      PR(3,3)=1
C matrix product
      DO 2 I=1,3
      DO 2 J=1,3
      S=0
      DO 1 K=1,3
    1 S=S+PR(I,K)*TR(K,J)
    2 RR(I,J)=S
      RETURN
      END
      SUBROUTINE AVR3DX(NEP, EPTAB, CONV, TX)
C        triple Xsec. for deuteron break-up reactions
C        average over rectangular slit of 2*SLTX, 2*SLTY, or
C                     circular slit of half apex angle SLTX,
C        which are located SLTR from the origin
C        z-axis along deuteron incident direction
C Input THETP, PHIP: proton dectection angles(polar and azimuthal )
C       THETN, PHIN: same as above for neutron.(slit center)
C                    angles in radian
C       SLTX, SLTY: half size of slit (may be im mm)
C       SLTR     : slit disance from the origin( may be in mm)      
C       NEP        : number of proton energy bin 
C Output EPTAB(NEP): proton energy table
C        TX   (NEP): triple differential cross sections (mb/(MeV,sr**2))
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FUND/EMP, EMN, EMD, EMT, EDL, QVAL, HBARC, PI
      COMMON /SLIT/ISC(2), SLTR(2), SLTX(2), SLTY(2),SOL(2),
     +             THETA(2), PHI(2), RR(3,3,2)
C define Gauss-Legendre integration parameters frm N=2,4 to NLX=20
C        210=NLX*(NLX+1)/2 for NLX=20
      COMMON /GLI/XGL(210), WGL(210), NLX
C                               Sz , Iz    of deuteron
      DIMENSION EPTAB(NEP), TX(-1:1, -1:1, NEP), XSC(-1:1)
      DIMENSION XS(4), XL(4), RS2(2), XPN(-1:1, -1:1, 4),
     +                                XP (-1:1, -1:1)
      DIMENSION IMIN(4)
      EQUIVALENCE (IMIN(1),I1MIN),(IMIN(2),I2MIN),
     +            (IMIN(3),I3MIN),(IMIN(4),I4MIN) 
      LOOP=0
C         prepare Gauss Legendre integration parameters
      NLX=20
      CALL GLITAB
C         solid angle of the slits
      DO 1 I=1,2
      SOL(I)=1
      K=I+I
      J=K-1
      IF(ABS(SLTR(I)).LT.0.1) SLTR(I)=1
      RS2(I)=SLTR(I)*SLTR(I)
      IMIN(K)=1
      IMIN(J)=1
C        rotation matrix of I-th slit
      CALL RMAT(THETA(I), PHI(I), RR(1,1,I))
C        rectangular slit 
      IF(ISC(I).EQ.0) THEN
         ZZ=SLTR(I)*SQRT(RS2(I)+SLTX(I)**2+SLTY(I)**2)
         SOL(I)=4*ATAN2(SLTX(I)*SLTY(I), ZZ)
C        integration range
         XS(J)=SLTX(I)
         XL(J)= 0
         XS(K)=SLTY(I)
         XL(K)= 0
         GOTO 1
      END IF
C        circular slit
      IF(ISC(I).EQ.1)THEN
         ZZ=ATAN2(SLTX(I), SLTR(I))/2
         SOL(I)=4*PI*SIN(ZZ)**2
C        integration range
         XS(J)=SLTX(I)/2
         XL(J)=XS(J)
         XS(K)= PI
         XL(K)= 0
         GOTO 1
      END IF
C         over the whole solid angle
      IF(ISC(I).EQ.2)THEN
         SOL(I)=4*PI
         XS(J)=PI/2
         XL(J)=PI/2
         XS(K)= PI
         XL(K)= 0
         IMIN(J)=3
         IMIN(K)=4
         GOTO 1
      END IF
      GOTO 91
    1 CONTINUE
      WRITE(6,2)(I,ISC(I),SLTR(I),SLTX(I),SLTY(I),SOL(I),I=1,2)
    2 FORMAT(('#ISC(',I1,')=',I2,2X,'R,X,Y=',0P3F8.3,2X,'Sol=',
     +        1PE13.4,'sr'))
C  deuteron momentum. center of mass momentum 
      PD=SQRT(2*EMD*EDL)
      PG=EMD*PD/(EMD+EMT)
C         somemass  parameters
      EMSUM=EMN+EMT
      RFAC=EMN/EMSUM
      EMNT=RFAC*EMT
      EMPN=EMP+EMN
C        calculate max. proton momentum for given ThetaP
      A=1/EMP+1/EMSUM
      B=PD*COS(THETA(1))/EMSUM
      C=(1-EMD/EMSUM)*EDL+QVAL
      IF(C .LT. 0) GOTO 93
      D=B**2+2*A*C
      IF(D .LT. 0) GOTO 95
      IF(B .GE. 0) PPMAX=(B+SQRT(D))/A
      IF(B .LT. 0) PPMAX=-2*C/(B-SQRT(D))
      EPMAX=PPMAX**2/(2*EMP)
C         mesh size of proton energy and momentum
      DEP=EPMAX/NEP
      IF(DEP .LT. 0.05) DEP=0.05
      NEX=EPMAX/DEP+0.01
      EP=DEP/2
      DO 11 NE=1, NEX
      DO 11 MU=-1,1
      DO 11 NU=-1,1
   11 TX(NU,MU,NE)=0
C       (Xsec factor)*(2*Pi)/(hbar*velocity) and fm**2 -> mb
      DEN0=EMP*EMN*EMT/(2*PI*HBARC)**6
      DEN0=10*DEN0*2*PI*EMD/(HBARC*PD)
C         loop for proton energies
      DO 70 NE=1, NEX
      PP=SQRT(2*EP*EMP)
      EPTAB(NE)=EP
C  start of integration      
C      X direction
      S1=-1
      DO 65 I1=I1MIN,NLX
      J1=I1*(I1-1)/2+1
      DO 21 MU=-1,1
      DO 21 NU=-1,1
   21 XPN(NU,MU,1)=0
      DO 63 K1=1,I1
      W1=WGL(J1)
      XX1=XGL(J1)*XS(1)
      X1D=XX1*XX1
      DO 62 L1=-1,1,2
      X1L=XX1*L1+XL(1)
      IF(ISC(1).EQ.1) W1SL=SLTR(1)*X1L/(RS2(1)+X1L*X1L)**1.5D0
      IF(ISC(1).EQ.2) THEN
         W1SL=SIN(X1L)
         THET1=X1L
      END IF
C           Y direction
      S2=-1
      DO 55 I2=I2MIN,NLX
      J2=I2*(I2-1)/2+1
      DO 22 MU=-1,1
      DO 22 NU=-1,1
   22 XPN(NU,MU,2)=0
      DO 53 K2=1,I2
      XX2=XGL(J2)*XS(2)
C       weight due to slit area and inclination
      IF(ISC(1).EQ.0) W1SL=SLTR(1)/(RS2(1)+X1D+XX2*XX2)**1.5D0
      W2=WGL(J2)*W1SL
      DO 52 L2=-1,1,2
      X2L=XX2*L2+XL(2)
      IF(ISC(1).EQ.2) PHI1=X2L
C        polar to Cartesian transform
      IF(ISC(1).EQ.1) THEN
         ZZ =X1L*SIN(X2L)
         X1L=X1L*COS(X2L)
         X2L=ZZ
      END IF
      IF(ISC(1).NE.2) THEN
C         rotate proton slit: slit(1)
         X1=RR(1,1,1)*X1L+RR(1,2,1)*X2L+RR(1,3,1)*SLTR(1)
         Y1=RR(2,1,1)*X1L+RR(2,2,1)*X2L+RR(2,3,1)*SLTR(1)
         Z1=RR(3,1,1)*X1L+RR(3,2,1)*X2L+RR(3,3,1)*SLTR(1)
         THET1=ATAN2(SQRT(X1*X1+Y1*Y1), Z1)
         PHI1 =0
         IF(ABS(X1).GT.1.0E-6) PHI1 =ATAN2(Y1, X1)
      END IF
C       polar and azumuthal angles of proton: (1)
      STP=       SIN(THET1)
      PPX=PP*STP*COS(PHI1 )
      PPY=PP*STP*SIN(PHI1 )
      PPZ=PP*    COS(THET1)
      PLZ=PD-PPZ
      PL2=PPX**2+PPY**2+PLZ**2
      Q2=2*EMNT*(EDL+QVAL-EP-PL2/(2*EMSUM))
      R2=PL2*RFAC**2
C integrate over 2nd slit
C               X2 direction
      S3=-1
      DO 45 I3=I3MIN,NLX
      J3=I3*(I3-1)/2+1
      DO 23 MU=-1,1
      DO 23 NU=-1,1
   23 XPN(NU,MU,3)=0
      DO 43 K3=1,I3
      W3=WGL(J3)
      XX3=XGL(J3)*XS(3)
      X3D=XX3*XX3
      DO 42 L3=-1,1,2
      X3L=XX3*L3+XL(3)
      IF(ISC(2).EQ.1) W2SL=SLTR(2)*X3L/(RS2(2)+X3L*X3L)**1.5D0
      IF(ISC(2).EQ.2) THEN
         W2SL=SIN(X3L)
         THET2=X3L
      END IF
C         Y2 direction
      S4=-1
      DO 35 I4=I4MIN,NLX
      J4=I4*(I4-1)/2+1
      DO 24 MU=-1,1
      DO 24 NU=-1,1
   24 XPN(NU,MU,4)=0
      DO 33 K4=1,I4
      XX4=XGL(J4)*XS(4)
      IF(ISC(2).EQ.0) W2SL=SLTR(2)/(RS2(2)+X3D+XX4*XX4)**1.5D0
      W4=WGL(J4)*W2SL
      DO 32 L4=-1,1,2
      X4L=XX4*L4+XL(4)
C         polar to Cartesian transform
      IF(ISC(2).EQ.2) PHI2=X4L
      IF(ISC(2).EQ.1) THEN
         ZZ =X3L*SIN(X4L)
         X3L=X3L*COS(X4L)
         X4L=ZZ
      END IF
      IF(ISC(2).NE.2) THEN
C        rotate Y slit: slit(2)      
         X2=RR(1,1,2)*X3L+RR(1,2,2)*X4L+RR(1,3,2)*SLTR(2)
         Y2=RR(2,1,2)*X3L+RR(2,2,2)*X4L+RR(2,3,2)*SLTR(2)
         Z2=RR(3,1,2)*X3L+RR(3,2,2)*X4L+RR(3,3,2)*SLTR(2)
C       polar and azumuthal angles of neutron: (2)
         THET2=ATAN2(SQRT(X2*X2+Y2*Y2), Z2)
         PHI2 =0
         IF(ABS(X2).GT.1.0E-6) PHI2 =ATAN2(Y2, X2)
      END IF
      STN=SIN(THET2)
      ENX=STN*COS(PHI2)
      ENY=STN*SIN(PHI2)
      ENZ=COS(THET2)
      RN=RFAC*(-PPX*ENX-PPY*ENY+PLZ*ENZ)
      RP2=R2-RN**2
      IF(RP2 .GT. Q2) GOTO 32
      ADD=SQRT(Q2-RP2)
      DO 31 IS=-1, 1, 2
      PN=RN+IS*ADD
      IF(PN .LT. 0) GOTO 31
      PNX=PN*ENX
      PNY=PN*ENY
      PNZ=PN*ENZ
C         CM wave number of n+p system
      FPX=PPX+PNX
      FPY=PPY+PNY
      FPZ=PPZ+PNZ-PG
      FPXY=FPX**2+FPY**2
      THELP=0
      PHILP=0
      IF(ABS(FPZ).GT.1.0E-6)THELP=ATAN2(SQRT(FPXY), FPZ)
      IF(ABS(FPX).GT.1.0E-6)PHILP=ATAN2(FPY, FPX)
C        relative motion
      FKX=(EMP*PNX-EMN*PPX)/EMPN
      FKY=(EMP*PNY-EMN*PPY)/EMPN
      FKZ=(EMP*PNZ-EMN*PPZ)/EMPN
      FKXY=FKX**2+FKY**2
      THESK=0
      PHISK=0
      IF(ABS(FKZ).GT. 1.0E-6)THESK=ATAN2(SQRT(FKXY), FKZ)
      IF(ABS(FKX).GT. 1.0E-6)PHISK=ATAN2(FKY, FKX)
      FKS2=FKXY+FKZ**2
      FKS=SQRT(FKS2)/HBARC
C       now all the independent parameters are virtually fixed
      CALL XPNCAL(FKS, THELP, PHILP, THESK, PHISK, XP)
C        10*( state density ): fm --> mb/(sr**2*Ep(MeV))
      DENS=DEN0*PP*PN/(EMSUM+EMN*(ENX*PPX+ENY*PPY-ENZ*PLZ)/PN)
C
      A=W4*DENS
      DO 28 MU=-1,1
      DO 28 NU=-1,1
   28 XPN(NU,MU,4)=XPN(NU,MU,4)+A*XP(NU,MU)
   31 CONTINUE
   32 CONTINUE
   33 J4=J4+1
      T4=0
      DO 34 MU=-1,1
      DO 34 NU=-1,1
   34 T4=T4+XPN(NU,MU,4)
      IF(ABS(S4-T4).LT.CONV) GOTO 40
   35 S4=T4
      J=4
      GOTO 97
   40 M4=I4
      DO 41 MU=-1,1
      DO 41 NU=-1,1
   41 XPN(NU,MU,3)=XPN(NU,MU,3)+W3*XPN(NU,MU,4)
   42 CONTINUE
   43 J3=J3+1
      T3=0
      DO 44 MU=-1,1
      DO 44 NU=-1,1
   44 T3=T3+XPN(NU,MU,3)
      IF(ABS(S3-T3).LT.CONV) GOTO 50
   45 S3=T3
      J=3
      GOTO 97
   50 M3=I3
      DO 51 MU=-1,1
      DO 51 NU=-1,1
   51 XPN(NU,MU,2)=XPN(NU,MU,2)+W2*XPN(NU,MU,3)
   52 CONTINUE
   53 J2=J2+1
      T2=0
      DO 54 MU=-1,1
      DO 54 NU=-1,1
   54 T2=T2+XPN(NU,MU,2)
      IF(ABS(S2-T2).LT.CONV)GOTO 60
   55 S2=T2
      J=2
      GOTO 97
   60 M2=I2
      DO 61 MU=-1,1
      DO 61 NU=-1,1
   61 XPN(NU,MU,1)=XPN(NU,MU,1)+W1*XPN(NU,MU,2)
   62 CONTINUE
   63 J1=J1+1
      T1=0
      DO 64 MU=-1,1
      DO 64 NU=-1,1
   64 T1=T1+XPN(NU,MU,1)
      IF(ABS(S1-T1).LT.CONV) GOTO 68
   65 S1=T1
      J=1
      GOTO 97
C         integration converged
   68 EP=EP+DEP
C         normalize the result
      SFAC=XS(1)*XS(2)*XS(3)*XS(4)/(SOL(1)*SOL(2))
      DO 69 MU=-1,1
      DO 69 NU=-1,1
   69 TX(NU,MU,NE)=XPN(NU,MU,1)*SFAC
   70 M1=I1
      WRITE(6,71)M1,M2,M3,M4
   71 FORMAT('#(AVR3DX) Conv. order M=',4I4)
C
      WRITE(6,72)(I,I=-1,1)
   72 FORMAT(/'#',4X,'triple diff. Xsec (mb/(sr(p) sr(n) Ep(MeV)))'/
     +       '# Ep(MeV)',3(4X,'Md=',I2,4X),4X,'aver.')
      DO 76 NE=1,NEX
      DO 74 MU=-1,1
C        Nu=0 comes from (Np,Nn)=(1/2,-1/2) and (-1/2,1/2)
C        but S=0 contribution should not be taken into account
      SUM=0
      DO 73 NU=-1,1
   73 SUM=SUM+TX(NU,MU,NE)
   74 XSC(MU)=SUM  
      SUM=(XSC(-1)+XSC(0)+XSC(1))/3
      WRITE(6,75)EPTAB(NE),XSC,SUM
   75 FORMAT(0PF7.3,1P4E14.5)
   76 CONTINUE
      RETURN
C      
C error messages
   91 WRITE(6,92)ISC
   92 FORMAT('AVRSLT your ISC=',2I2,' out of range !')
      STOP
   93 WRITE(6,94)EDL
   94 FORMAT(1H ,'your Ed=',F8.4,' too small !')
      STOP  
   95 WRITE(6,96)A,B,C,D
   96 FORMAT(1H ,'A B C D=',1p4E12.3,2X,'Neg. sqrt !'  )
      STOP
   97 WRITE(6,98)J
   98 FORMAT('No conv at ',I1,'-th integral !')
      STOP
      END
      SUBROUTINE DATIME
C      SUBROUTINE DATIME(IDATE)
      DIMENSION IDATE(6)
      DIMENSION MON(12), IDEF(6)
C         1970/01/1/09:00:00
      DATA IDEF/1970, 1, 1, 9, 0, 0/
      DATA MON/31,28,31,30,31,30,31,31,30,31,30,31/
C
      CALL CURTIM(IT)
      IDAY=24*60*60
C        remove some days in 1970
      IT=IT+IDAY*(IDEF(3)-1)+3600*IDEF(4)+60*IDEF(5)+IDEF(6)
C        positive II is assumed
C        count up years
      IY0=IDEF(1)
      IY1=2100
      DO 1 IY=IY0,IY1
      II=365
      IF(INT(IY/4)*4 .EQ. IY) II=366
      IF(INT(IY/100)*100 .EQ. IY .AND. INT(IY/400)*400 .NE. IY)II=365
      JJ=II*IDAY
      IF(IT-JJ .LT. 0) GOTO 2
    1 IT=IT-JJ
    2 IDATE(1)=IY
C         count up Months
      IF(II .EQ. 366) MON(2)=29
      DO 3 M=1,12
      JJ=MON(M)*IDAY
      IF(IT-JJ .LT. 0) GOTO 4
    3 IT=IT-JJ
    4 IDATE(2)=M
      MON(2)=28
C         count up Days, Hours, Minutes and Seconds
      JJ=IT/IDAY
      IT=IT-IDAY*JJ
      IDATE(3)=JJ+1
      JJ=IT/3600
      IDATE(4)=JJ
      IT=IT-3600*JJ
      JJ=IT/60
      IDATE(5)=JJ
      IDATE(6)=IT-JJ*60
      WRITE(6,10)IDATE
   10 FORMAT(1H ,50X,'date=',I4,'/',I2,'/',I2,'/',I2,':',I2,':',I2)
      RETURN
      END
