C      CTAK program   1998 Dec. 10  1-way coupling 
C      RSCPHS modified 2000/11/18
C      WJPX table renewed 2002/04/29:  Drho ==> 0.1 fm
C      DMAS defined       2001/02/16
C      GSORTH rewritten   2001/05/04
C      Smat(break-up)--> divided by sqrt(DKbin)   2001/05/25
C      CDC14 added and CDC16 simplified       2001/07/08
C      CDC24 split and CDC23 introduced.
C      CDC30 make and print distorted waves   2001/12/15
C      PNBOUN  exponential tail added         2002/04/04
C      COUEXP replaced by a faster one        2002/04/06
C      NSPL3 may be improved                  2002/04/15
C      COU replaced by CWF                    2002/11/16
C      W9J replaced by a faster one           2003/01/04
C      CDC27 removed                          2003/02/04
C      array DCC removed                      2003/02/04
C      VCINT save command                     2003/03/18
C     controle routine  
C   KNTL( 1) = NPN,  number of p-n (L S J) pair
C   KNTL( 2) = NPOT, number of nucleon potential parameters
C   KNTL( 3) = 1     add Coulomb break up
C            = 2     vac. pol. correction for diag. elements
C            = 3     both
C   KNTL( 4) =       Not used
C   KNTL( 5) = 1
C   KNTL( 6) = 1,    print p-n pair wave functions
C   KNTL( 7) = 1,    print form-factor quantum numbers
C   KNTL( 8) = 1,    print matrix elements
C   KNTL( 9) = 1,    print S-matrix elements
C            = 2,    print S-matrix elemtnts onto file(smat.out)
C            = 3,    both
C   KNTL(10) = 1,    print indep. solutions in formatted form
C            = 2,    print indep. solutions in unformatted form  
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
      COMMON /FF1/ CPOT(0:150), RFFTAB(0:150), DRHO,  DR, DRFF, DRDW,
     +             TMAS, TZ, RMASS, EFACT, ETOT,
     +             NRHOMX, NRMAX, NRFFMX, NRDWMX, NFF,
     +             JTMIN, JTMAX, JTINC
C             NCCMAX is referenced
      COMMON /QCM/EDCM(324),  FKCM (324), ETACM(324),
     +            LCM (324), ISOPEN(324),IDPNWF(324), IDCC(324),
     +            LCC (324), IDCWF (324), ISOCC(10),   NCC, ISOMAX
      COMMON /VCC/FCT(0:1000), IVFMAX
      COMMON /CNST/AMU,DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
C                    NFFMAX is referenced
      DIMENSION  IPFF(32700), LTRFF(32700), IDFF(32700),
C                    MAXFFT       NFSZMX*2 are referenced
     +         FFTAB(4573380), FCC(10268160),
C                NCOUL is referenced
     +         F(18600), FP(18600), G(18600), GP(18600), 
C                  NVUMAX(=8*KCC**2) and    NUMAX(=5*KCC**2)
     +         VUR(292000), VUI(292000), UR(183000), UI(183000),
C                  ISMAX should be more than 3*NCC
     +          SR (1000),  SI (1000)
      DIMENSION ER(324), EI(324), WR(324), WI(324), IW(324), WX(324)
      CHARACTER*50 TITLE
C             table size defined
      NPNMAX=    10
      NWFMAX=   122
      NRFMAX=   150
      NCCMAX=   324
C        KCCMAX may be less than NCCMAX      
      KCCMAX=   324
      IVFMAX=  1000
      NFFMAX= 32700
      MAXFFT=4573380
C          half the size of FCC
      NFSZMX=5134080 
      NCOUL = 18600
      NUMAX= 183000
      NVUMAX=292000
C          memory size of S-matrix elements
      ISMAX =  1000
C       define I/O files of basic data
      OPEN(5,FILE='ctak.in',STATUS='OLD')
      OPEN(6,FILE='ctak.out',STATUS='OLD')
      READ(5,10)TITLE
   10 FORMAT(A50)  
      READ(5, 11)KNTL, TITLE
   11 FORMAT(10I2, A50)
      WRITE(6,12)KNTL, TITLE
   12 FORMAT(1H ,6X,'   2   4   6   8  10',25X,'CTAK Dec. 2001'/
     +       1H ,2X,'KNTL',10I2,2X,A50)
      CALL DATIME
C         read all the necessary data
      CALL CDC10(ELAB, LSPOT, R0C, IMAX)
      CLOSE (5)
      IF(NRFFMX .GT. NRFMAX) GOTO 907
      NPN=KNTL(1)
      IF(NPN .GT. 10) GOTO 901
      NGMX=(IMAX+1)**2
      IF(NGMX  .GT. KCCMAX) GOTO 913
      RMASS=DMAS*TMAS/(DMAS+TMAS)
      ETOT=ELAB*RMASS/DMAS
C            prepare p-n wave function table--> FCC=PNWF
C            work area is assigned to be FFTAB
      IPNWFX=2*NFSZMX
      CALL CDC12(IPNWFX, FCC, MAXFFT, FFTAB)
C            prepare potential table --> UR
      NPOT=KNTL(2)
      CALL CDC14(NRMAX, DR, TMAS, NPN, NPOT, UR)
C            radial matrix elements
      MAXFF=MAXFFT/(NRFFMX+1)
      IF(NFFMAX .GT. MAXFF) NFFMAX=MAXFF
      RC=R0C*TMAS**0.333333333
      CALL CDC16(FCC, RC, NPOT, UR, UI, NFFMAX, FFTAB, 
     +           LTRFF, IDFF, IPFF)
      CALL DATIME
C        "deuteron" and  "target nucleus" interact now
      EFACT=(2*RMASS*AMU)/HBARC**2
      KNTL9=KNTL(9)
      IF(KNTL9 .GT. 0) OPEN(7,FILE='smat.out',STATUS='OLD')
C        table for scattering state ID's and
C        prepare Coulomb potential table and
C        factorial table
      CALL CDC20( NCCMAX, RC)
C        check storage of S-matrix
      IF(ISMAX .LT. NCC*3) GOTO 905
C        LMAX = (max. of orbital angular momentum) +1
      JSX=0
      DO 21 I=1, NPN
      IF(JSX .LT. JJ(I)) JSX=JJ(I)
   21 CONTINUE
      LMAX=JTMAX+JSX+1
      NCWF=NCOUL/LMAX
C         Coulomb wave functions
C               define matching point
      RM=(NRDWMX-2)*DRDW
      CALL CDC22(NCC, FKCM, ETACM, RM, LMAX, IDCWF, NCWF,
     +           F, FP, G, GP)
      CALL DATIME
      FK0=FKCM(1)
      K10=KNTL(10)
      IF(K10. LE. 0) GOTO 24
      OPEN(8,FILE='ctak.dw',FORM='FORMATTED', STATUS='UNKNOWN')
      NRDWP=NRDWMX+1
      WRITE(8,23) JTMIN, JTMAX, JTINC, NRDWP, DRDW, ETACM(1), FK0
   23 FORMAT('#',4I5, 19X,'/JTMIN JTMAX JTINC NRDWMX+1'/ 
     +       '#',0P3F13.9,'/DRDW ETA FK')
   24 CONTINUE
C           loop for JTOT and parity
      DO 50 JTOT=JTMIN, JTMAX, JTINC
C           clear S-matrix storage
      NS=ISOMAX*NCC
      DO 25 ISX=1, NS
      SR(ISX)=0
   25 SI(ISX)=0     
      DO 40 JPAR=1, -1, -2
C        form-factor is to be prepared and their (2nd der./6)
      KCC=0
      CALL CDC23(JTOT, JPAR, KCCMAX, KCC, MCC, NFSZMX, NRFFMX)
      IF(KCC .LE. 0) GOTO 40
      MC4=4*MCC
      CALL CDC24(JTOT, JPAR, FFTAB, NRFFMX, NFF, LTRFF, IDFF, 
     +           LSPOT, CPOT, IPFF, KCC, MC4, VUR, RFFTAB,
     +           FCC, UR, IW)
      IF(NFSZMX .LT. MCC*(NRFFMX+1)) GOTO 903
C                NWM, number of incident channels
      NWM=0
      DO 31 I=1, KCC
      ID=IDCC(I)
      IF(ISOPEN(ID) .LE. 0) GOTO 31
      NWM=NWM+1
      ISOCC(NWM)=ID
   31 CONTINUE
C       check storage size of integration buffer
      IF(NUMAX .LT. KCC**2*5 .OR. NVUMAX .LT. KCC**2*8) GOTO 909
      IF(K10.GT.0) OPEN(1,FORM='UNFORMATTED', STATUS='SCRATCH')
C        integrate coupled equations
      CALL CDC26(KCC, DRDW, NRDWMX, LCC, MC4, FCC, NRFFMX, 
     +           RFFTAB, EFACT, ER, EI, UR, UI, VUR, VUI, JTOT,
     +           FK0, NS0, K10, NWM)
      IF(NS0 .GT. NRDWMX-8) GOTO 911
C        evaluate S-matrix
      IDV=KCC**2+1
      CALL CDC28(KCC, UR, UI, UR(IDV), UI(IDV), ISOMAX, NWM, 
     +           NCWF, LMAX, F, FP, G, GP, ER,
     +           SR, SI, WR, WI, IW, WX, CNUM, K10)
      WRITE(6,35)JTOT, JPAR, KCC,NWM,NS0,CNUM
   35 FORMAT(1H ,'JTOT=',I3,2X,'JPAR=',I2,2X,'KCC=',I4,2X,
     +           'NWM=',I2,2X,'NS0=',I4,2X,'Cnum=',1PE12.3)
      IF(K10 .LE. 0) GOTO 40
      NFCC=2*NFSZMX
      CALL CDC30(JTOT, JPAR, NRDWMX, NS0, DRDW, KCC, NWM,
     +           NUMAX, NFCC, UR, FCC, VUR)
      IF(K10.GT.0) CLOSE (1)
   40 CONTINUE
C        print S-matrix
      CALL CDC29( KNTL9, JTOT, NCC, SR, SI)
      CALL DATIME
   50 CONTINUE
      IF(K10   .GT. 0)WRITE(8,51)RM,(L-1,F(L),G(L),FP(L),GP(L),L=1,LMAX)
      IF(KNTL9 .GT. 0) CLOSE (7)
      IF(K10   .GT. 0) CLOSE (8)
      CLOSE (6)
      STOP
   51 FORMAT('#   Coul. wf. at R=',F9.5,/
     +        3X,'L',7X,'F',14X,'G',13X,'FK*FP',10X,'FK*GP'/
     +       (I4,1P4E15.7))
C      error message
C           p-n pair 
  901 WRITE(6,902)KNTL(1)
  902 FORMAT(1H ,'Number of NPN is limitted to 10. Your KNTL(1)=',I3)
      STOP
C           matrix element storage size pun!!
  903 WRITE(6,904) NRFFMX, MCC, NFSZMX
  904 FORMAT(1H ,'NRFFMX=',I5,2X,'MCC=',I9,' is over limit of ',I9)
      STOP
C         S-matrix storage size
  905 WRITE(6,906)NCC, ISMAX
  906 FORMAT(1H ,'(Main) S-mat. storage ISMAX=',I4,2X,
     +           'less than 3*',I4)
      STOP
C           R-table of form-factor 
  907 WRITE(6,908)NRFMAX, NRFFMX
  908 FORMAT(1H ,'(Main) NRFMAX=',I4,' while you requested ',I4/
     +       1H ,'error !')
      STOP 
C           storage for CDC26( wave function and potential)
  909  WRITE(6,910)KCC,NUMAX,NVUMAX
  910  FORMAT(1H ,'(Main) KCC=',I4,2X,'NUMAX=',I6,2X,'NVUMAX=',I6/
     +       1H ,'KCC**2*5 or KCC**2*8 are the requested values'/
     +       1H ,'memory for UR UI pun!!')
      STOP
C         S-matrix evaluation terminated
  911 X=FKCM(1)*DRDW*NRDWMX
      WRITE(6,912)JTMAX, X
      IF(KNTL9 .GT. 0) WRITE(7,912)JTMAX, X
  912 FORMAT(1H ,10('*'),' S-matrix eval. terminated !! ',10('*'),/
     +       1H ,' your JTMAX=',I4,2X,'(Kd)*(Rmax)=',F8.2)
      STOP
  913 WRITE(6,914)NGMX, KCCMAX
  914 FORMAT(1H ,'(Main) at GTCAL mamory of NGTAB pun !!'/
     +       1H ,'your request=',I4,' while allowed is',I4)
      STOP
      END
C      SUBROUTINE CURTIM(IT)
C      WRITE(6,10)
C   10 FORMAT(1H ,'CURTIM CALLED ')
C      IT=10
C      RETURN
C      END
      SUBROUTINE CDC10(ELAB, LSPOT, R0C, IMAX)
C Output LSPOT: =0 No spin orbit potential in Nucleon-Target potential
C        R0C  : Coulomb charge radius parameter
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
      COMMON /FF1/ CPOT(0:150), RFFTAB(0:150), DRHO,  DR, DRFF, DRDW,
     +             TMAS, TZ, RMASS, EFACT, ETOT,
     +             NRHOMX, NRMAX, NRFFMX, NRDWMX, NFF,
     +             JTMIN, JTMAX, JTINC
      DIMENSION DRF(10), RF(0:10)
      CHARACTER PNSPEC*60
C      specify p-n states to be used
      NPN=KNTL(1)
      IMAX=-1
      DO 15 N=1, NPN
      READ(5,11)PNSPEC
   11 FORMAT(A60)
      WRITE(6,12)PNSPEC
   12 FORMAT(1H ,'PNSPEC=',A50)
      CALL PNIN(PNSPEC, IT(N), JJ(N), IS(N), KOUPLE(N), ISBND(N),
     +                  NKBIN(N), FKMIN(N), FKMAX(N))
C      define ID number
C        3D3 is treated seperately
      IF(JJ(N) .EQ. 3 .AND. IS(N) .EQ. 1) THEN
         IDPN(N)=7
         KOUPLE(N)=0
         GOTO 15
      END IF
      IF(KOUPLE(N) .EQ. 1) GOTO 14
      DO 13 ID=1,6
      IF(IT(N) .NE. ITSTAT(ID)) GOTO 13
      IF(IS(N) .NE. ISSTAT(ID)) GOTO 13
      IF(JJ(N) .NE.  JSTAT(ID)) GOTO 13
      IDPN(N)=ID
      GOTO 15
   13 CONTINUE
      GOTO 903
   14 IDPN(N)=0
      IF(IT(N) .EQ. 0 .AND. JJ(N) .EQ. 1 .AND. IS(N) .EQ. 1) IDPN(N)=1
      IF(IT(N) .EQ. 1 .AND. JJ(N) .EQ. 2 .AND. IS(N) .EQ. 1) IDPN(N)=2
      IF(IDPN(N) .EQ. 0) GOTO 901
      IF(JJ(N) .GT. IMAX) IMAX=JJ(N)
   15 CONTINUE
C            reset ISBND
      ISOK=0
      IF(ISBND(1).NE.0)ISOK=1
      DO 16 NP=2, NPN
   16 ISBND(NP)=0
      IF(ISOK.EQ.0) GOTO 905
C            print input
      WRITE(6,17)
   17 FORMAT(/1H ,5X,'p-n bins specified '/
     +        1H ,2X,'N',2X,'T',2X,'S',2X,'J',2X,'K',2X,'B',2X,'ID',
     +            2X,'BIN',2X,'FKMIN', 3X,'FKMAX')
      DO 19 N=1, NPN
      WRITE(6,18)N,IT(N), IS(N), JJ(N), KOUPLE(N), ISBND(N), IDPN(N),
     +           NKBIN(N), FKMIN(N), FKMAX(N)
   18 FORMAT(1H ,6I3,2I4,2F8.3)
   19 CONTINUE
C       define potential parameters
      NPOT=KNTL(2)
      DO 20 N=1, NPOT
   20 READ(5,*)ISN(N), ISI(N), ISLS(N), (POTPRM(M,N),M=1,5)
C            count potential types. max. of 4
C            real/imag,  cent./L*S
      NRC=0
      NIC=0
      NRL=0
      NIL=0
      DO 21 N=1, NPOT      
      IF(ISN(N) .GT. 0) ISN(N)=1
      IF(ISN(N) .LE. 0) ISN(N)=0
      IF(ISI(N) .GT. 0) ISI(N)=1
      IF(ISI(N) .LE. 0) ISI(N)=0
      IF(ISLS(N).GT. 0) ISLS(N)=1
      IF(ISLS(N).LE. 0) ISLS(N)=0
      IF(ISI(N) .EQ. 0 .AND. ISLS(N) .EQ. 0) NRC=1
      IF(ISI(N) .NE. 0 .AND. ISLS(N) .EQ. 0) NIC=1
      IF(ISI(N) .EQ. 0 .AND. ISLS(N) .NE. 0) NRL=1
      IF(ISI(N) .NE. 0 .AND. ISLS(N) .NE. 0) NIL=1
   21 CONTINUE
      NPTYPE=NRC+NIC+NRL+NIL
C        define LSPOT flag
      LSPOT=MAX0(NRL, NIL)
      LLPMIN=100
      LLPMAX=-LLPMIN
      DO 22 N=1,NPOT
C        pick-up Coulomb charge radius
      IF(ISN(N) .EQ. 0 .AND. ISI(N) .EQ. 0 .AND. ISLS(N) .EQ. 0)
     +   R0C=POTPRM(5,N)
      LLPM=ISI(N)+2*(ISLS(N)+2*ISN(N))
      IF(LLPM .LT. LLPMIN) LLPMIN=LLPM
      IF(LLPM .GT. LLPMAX) LLPMAX=LLPM
   22 LLPN(N)=LLPM
C       reorder potential table i.e., LLPN: p/n;  r/i; cen/L*S 
      NN=1
      DO 26 LL=LLPMIN, LLPMAX
      DO 25 N =1, NPOT
      LLPM=LLPN(N)
      IF(LLPM .NE. LL) GOTO 25
C          swap X(N) <--> X(NN)
      IF(N .EQ. NN) GOTO 24
      II=ISI(N)
      ISI(N )=ISI(NN)
      ISI(NN)=II
      II=ISN(N)
      ISN(N )=ISN(NN)
      ISN(NN)=II
      II=ISLS(N)
      ISLS(N )=ISLS(NN)
      ISLS(NN)=II
      LLPN(N )=LLPN(NN)
      LLPN(NN)=LLPM
      DO 23 M=1, 5
      TEMP=POTPRM(M,N)
      POTPRM(M, N )=POTPRM(M,NN)
   23 POTPRM(M, NN)=TEMP
   24 NN=NN+1
   25 CONTINUE
   26 CONTINUE
C
      READ(5,*)LAMMIN, LAMMAX, TMAS, TZ, ELAB
C       define mesh size and number of meshes
      READ(5,*)DRHO, NRHOMX, DR, NRMAX
      READ(5,*)NRF,(DRF(M), RF(M), M=1, NRF)
      READ(5,*)DRDW
      READ(5,*)JTMIN, JTMAX, JTINC
C           define rtab of form factor
      IF(NRF .GT. 10) GOTO 907
      RF(0)=0
      RFFTAB(0)=0
      NRFFMX=0
      DO 27 M=1, NRF
      NR=(RF(M)-RF(M-1))/DRF(M)+0.1
      DRFF=DRF(M)   
      DO 27 I=1, NR
      NRFFMX=NRFFMX+1
   27 RFFTAB(NRFFMX)=RFFTAB(NRFFMX-1)+DRFF
      DRFF=DRF(1)
      NRDWMX=RFFTAB(NRFFMX)/DRDW+0.01
C
      IZ=TZ+0.1
      IA=TMAS+0.1
      WRITE(6,30)IZ, IA, ELAB
   30 FORMAT(/,2X,60('-')/3X,'target Z=',I4,2X,'mass number=',I5,
     +         3X,'incident Energy=',F8.3/
     +         2X,60('-'))  
      WRITE(6,31)
   31 FORMAT(/1H ,10X,'potential parameters '/
     +  1H ,3X,'p.ID  ISN  ISI ISLS  p.type',2X,'V(MeV)',3X,'R0(fm)',
     +      3X,'a(fm)',2X,'R0C or Csd')
      DO 33 N=1, NPOT
      WRITE(6,32)N,ISN(N), ISI(N),ISLS(N),(POTPRM(M,N),M=1,5)
   32 FORMAT(1H ,4I5,2X,F6.1,2X,F9.4,2F8.4,2X,F8.4)
   33 CONTINUE
C
      RHOMX=DRHO*NRHOMX
      RPMAX=DR*NRMAX
      RDWMX=DRDW*NRDWMX
      WRITE(6,34)DRHO, NRHOMX, RHOMX, DR, NRMAX, RPMAX, 
     +           DRDW, NRDWMX, RDWMX, NRFFMX
   34 FORMAT(/1H ,5X,'Rho   :  DRHO =',F8.5,3X,'NRHOMX=',I5,2X,
     +                        'RHOMX=',F8.2/
     +        1H ,5X,'Rp/Rn :  DR   =',F8.5,3X,'NRMAX =',I5,2X,
     +                        'RPMAX=',F8.2/
     +        1H ,5X,'Rwf   :  DRDW =',F8.5,3X,'NRDWMX=',I5,2X,
     +                        'RDWMX=',F8.2/
     +        1H ,5X,'form factors   ',11X,     'NRFFMX=',I5)
      WRITE(6,35)(DRF(M), RF(M),M=1, NRF)
   35 FORMAT(1H ,5X,'(DRFF RFF)=',4('(',F4.1,1X,F5.1,') ':)/
     +      (1H ,16X,4('(',F4.1,1X,F5.1,') ':)))
      IF(KNTL(3) .GT. 0 .AND. IZ .NE. 0) WRITE(6,36)
   36 FORMAT(/1H ,5X,'Coulomb break-up option is invoked ')  
      IF(KNTL(3) .GT. 0 .AND. IZ .EQ. 0)WRITE(6,37)
   37 FORMAT(1H ,5X,50('*')/
     +       1H ,10X,'Coulomb break-up for Neutral target !'/
     +       1H ,5X,50('*'))  
      IF(KNTL(4) .GT. 0) WRITE(6,38)
   38 FORMAT(1H ,5X,'One-way Coupling is used ')  
C           range of JTOT
      WRITE(6,39)JTMIN, JTMAX, JTINC
   39 FORMAT(/1H ,5X,'JT(min)=',I3,2X,'JT(max)=',I3,2X,'JT(inc)=',I2)
      RETURN
C       error message
  901 WRITE(6,902)PNSPEC
  902 FORMAT(1H ,'PNSPEC=',A60/
     +       1H ,'KOUPLE=1 NOT accepted for this spec !! ')
      STOP
  903 WRITE(6,904)N,IT(N),IS(N),JJ(N)
  904 FORMAT(1H ,'(CDC10) failed to set ID for N IT IS JJ =',4I3)
      STOP
  905 WRITE(6,906)
  906 FORMAT(1H ,'(CDC10) No bound deuteron !')
      STOP
  907 WRITE(6,908)NRF
  908 FORMAT(1H ,'(CDC10) NRF=',I2,' should be less that 10!')
      STOP  
      END
      SUBROUTINE PNIN(STR, IT, JJ, IS, KOUPLE, ISBND, NKBIN,
     +                FKMIN, FKMAX)
C      decipher an input line, which specifies the p-n state
C Input STR: character string
C Output IT: ispspin=0 or 1 for valid line and -1 for invalid line
C        JJ: total angular momentum of the state. 0-3 are allowed
C        IS: intrinsic spin 0 or 1 are allowd
C        KOUPLE=0 for uncoupled states and 1 for coupled states
C        ISBND: =1 for deuteron ground state
C        NKBIN: number of momentum bins
C        FKMIN, FKMAX: min. and max. of momentum span.
      IMPLICIT REAL*8(A-H, O-Z)
      CHARACTER*60 STR, LMOM(8)*1, CH*1, IFORM*4
      CHARACTER*1 Z10(10)
      DIMENSION NUM(4), LL(2)
      DATA LMOM /'s', 'S', 'p', 'P', 'd', 'D', 'f', 'F'/
      DATA Z10/'1', '2', '3', '4', '5', '6', '7', '8', '9', '0' /
      DATA IFORM /'(I1)'/
C               read One or two state identifiers
      DO 10 I=1,4
   10 NUM(I)=0
      LL(1)=0
      LL(2)=0
      K=0
      I0=1
   11 CONTINUE
      DO 12 I=I0, 60
      CH=STR(I:I)
      DO 12 J=1,8
      IF(CH .EQ. LMOM(J)) GOTO 13
   12 CONTINUE
      IF(K .EQ. 0) GOTO 901
      GOTO 20
C         hit it
   13 I1=I
      K=K+1
      LL(K)=(J+1)/2-1
C            S and J should appear
      I1=I-1
      K0=2*K-1
      DO 16 N=1,2
      CH=STR(I1:I1)
      DO 14 J=1,10
      IF(CH .EQ. Z10(J)) GOTO 15
   14 CONTINUE
      IF(K .EQ. 1) GOTO 903
      IF(K .EQ. 2) THEN
         K=1
         GOTO 20
      END IF
   15 NUM(K0)=J
      IF(J .EQ. 10) NUM(K0)=0
      K0=K0+1
   16 I1=I1+2
      I0=I+2
      IF(STR(I0:I0) .NE. '-')GOTO 20
      IF(K .EQ. 1) GOTO 11
C
   20 CONTINUE
      KOUPLE=0
      IF(K .EQ. 2) KOUPLE=1
      KP=1+KOUPLE
C            check triangular condition
      DO 21 K=1, KP
      L =LL(K)
      IS=(NUM(2*K-1)-1)/2
      JJ=NUM(2*K)
      IF(IABS(IS-L) .GT. JJ .OR. IS+L .LT. JJ) GOTO 905
   21 CONTINUE
C           read NKBIN, FKMIN, FKMAX
      DO 50 II=1, 3
      ISF=0
      FFF=0
      DO 40 I=I0, 60
C           looks for "="
      IF(STR(I:I) .NE. '=') GOTO 40
      I0=I+1
C           skip blank character
      DO 31 J=I0,60
      IF(STR(J:J) .NE. ' ') GOTO 32
   31 CONTINUE
      GOTO 907
C        read integer
   32 I0=J
      DO 34 K=I0, 60
      CH=STR(K:K)
      DO 33 J=1,10
      IF(CH .EQ. Z10(J)) GOTO 34
   33 CONTINUE
      GOTO 35
   34 CONTINUE
   35 I1=K-1
      L=I1-I0+1
      IF(L .LE. 0) GOTO 907
      IFORM(3:3)=Z10(L)
C         define integer NNN
      READ(STR(I0:I1),IFORM)NNN
      IF(II .EQ. 1) THEN
         NKBIN=NNN
         I0=I1+1
         GOTO 50
      END IF
C        define floating number
      IF(ISF .EQ. 0) FFF=NNN
      IF(ISF .EQ. 1) THEN
         FFF=FFF+FLOAT(NNN)/10**L
         GOTO 41
      END IF
      I0=I1+1
      IF( STR(I0:I0) .EQ. '.') THEN
         J=I0+1
         ISF=1
         GOTO 32
      END IF
      GOTO 41
   40 CONTINUE
   41 IF(II .EQ. 2) FKMIN=FFF
      IF(II .EQ. 3) FKMAX=FFF
   50 CONTINUE
C         JJ should be unique
      IF(KOUPLE .EQ. 1 .AND. NUM(2) .NE. NUM(4)) GOTO 909
C              define isospin
      IT=0
      K=IS+LL(1)
      IF((-1)**K .EQ. 1) IT=1
C              k-check
      IF(FKMIN .GE. FKMAX .AND. NKBIN .NE. 0) GOTO 911
C             define ISBND. just for 3S1-3D1 coupled state
      ISBND=0
      IF(KOUPLE .EQ. 1 .AND. LL(1) .EQ. 0 .AND. LL(2) .EQ. 2 .AND.
     +  JJ .EQ. 1) ISBND=1
      RETURN
C           error message !
  901 WRITE(6,902)
  902 FORMAT(1H ,'No state identifier !!')
      STOP
  903 WRITE(6,904)
  904 FORMAT(1H ,'S or J is not specified for given L !')
      STOP
  905 WRITE(6,906)LL(K), IS, JJ
  906 FORMAT(1H ,'triangle check L=',I2, 2X,'S=',I2,2X,'J=',I2)
      STOP
  907 WRITE(6,908)
  908 FORMAT(1H ,'No number is specified !')
      STOP
  909 WRITE(6,910)NUM(2), NUM(4)
  910 FORMAT(1H ,'JJ is redefined !! JJ1=',I2,2X,'JJ(2)=',I2)
      STOP
  911 WRITE(6,912)NKBIN,FKMIN, FKMAX
  912 FORMAT(1H ,'NKBIN=',I2,2X,'FKMIN=',1PE12.3,2X,'FKMAX=',1PE12.3/
     +       1H ,'***  inconsistent !! ***')
      STOP
      END
      SUBROUTINE CDC12(IPNWFX, PNWF, IWMAX, WORK)
C            wave function controller
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
      COMMON /FF1/ CPOT(0:150), RFFTAB(0:150), DRHO,  DR, DRFF, DRDW,
     +             TMAS, TZ, RMASS, EFACT, ETOT,
     +             NRHOMX, NRMAX, NRFFMX, NRDWMX, NFF,
     +             JTMIN, JTMAX, JTINC
      DIMENSION PNWF(*), WORK(*)
      NPN=KNTL(1)
      IP0=1
      NW=1
      DO 10 N=1, NPN
      ID=IDPN(N)
      KPL=KOUPLE(N)
      NKB=NKBIN(N)
      FMIN=FKMIN(N)
      FMAX=FKMAX(N)
      ISB=ISBND(N)
      IF(KPL .EQ. 0) NWF=  NKB
      IF(KPL .EQ. 1) NWF=4*NKB
      IF(ISB .NE. 0) NWF=NWF+2
      IPN=IP0+NWF*(NRHOMX+1)
      IF(IPN .GT. IPNWFX)GOTO 91
      IF(NW+NWF-1 .GT. NWFMAX) GOTO 93
      CALL RSCWF(ID, KPL, ISB, NKB, FMIN, FMAX, DRHO, NRHOMX, NWF,
     +           PNWF(IP0), WORK, IWMAX,
     +           FKPN(NW), DKPN(NW), LLPN(NW), ISPN(NW), JJPN(NW),
     +           KPLPN(NW), EPN(NW), PPN(NW), RPN(NW))
C        modify ETOT to allow for bound state
      IF(ISBND(N) .NE. 0) ETOT=ETOT+EPN(NW)
      NW=NW+NWF
   10 IP0=IPN
C          print wave functions
      NWF=NW-1
      CALL PRNTPN(NRHOMX, DRHO, PNWF, WORK)
C          check Ed(CM) is positive or not
      ISOK=1
      DO 12 N=1, NWF
      IF(FKPN(N) .LT. 0.0D0 .OR. ETOT .GT. EPN(N)) GOTO 12
      ISOK=-1
      ECM=ETOT-EPN(N)
      WRITE(6,11) N, EPN(N), ECM
   11 FORMAT(1H ,'(CDC12) Epn(',I2,')=',F8.3,3X,'E(CM)=',F8.3,'MeV')   
   12 CONTINUE  
      IF(ISOK .GT. 0) RETURN
      WRITE(6,13)
   13 FORMAT(1H ,'Negative CM energy NOT accepted !!  good bye' )
      STOP
C              error message
   91 WRITE(6,92)N, KPL, NKB, NWF, IPN, IPNWFX
   92 FORMAT(1H ,'(CDC12)N KPL NKB NWF IPN IPNWFX=',4I3,2I8/
     +       1H ,'       PNWF memory pun !!')
      STOP
   93 WRITE(6,94)N, NW, NWF, NWFMAX
   94 FORMAT(1H ,'(CDC12) at stage N=',I2,' NW and NWF=',2I3/
     +       1H ,7X, 'more than ',I3,' p-N wave function requested !')
      STOP
      END
      SUBROUTINE RSCWF(ID, KOUPLE, ISB, NKBIN, FKMIN, FKMAX, H, NRHOMX,
     +                 NWF, PNWF, WORK, IWMAX, FKPN, DKPN,
     +                 LLPN, ISPN, JJPN, KPLPN, EPN, PPN, RPN)
C         control routine to calculate scattering state wave func.
C         based on REID soft core pot.
C         exception is Gauss pot. for ID=7, KOUPLE=0
C   returns k-integrated radial wave function of "deuterons"
C Input ID: specifies quantum numbers of the p-n system
C       KOUPLE=0 for uncoupled states.  =1 for coupled states
C       ISB =1 for bound state deuteron      
C       NKBIN, FKMIN, FKMAX: define range of k-bin size
C                            (FKMAX-FKMIN)/NKBIN
C                   min. max. and step size of k-integration
C       H, NRHOMX  : define mesh size and number of meshes of the
C                   radial wave function
C       NWF       : number of radial wave functions to be returned
C                  =NKBIN for uncoupled states (KOUPLE=0)
C                  =4*NKBIN for 3P2-3F2 coupled states(ID=1 KOUPLE=1)
C                  =4*NKBIN+2 for 3S1-3D1 coupled states(ID=2 KOUPLE=1)
C Output PNWF(0: NRHOMX,*): scattering state wave function
C        LLPN(*), ISPN(*), JJPN(*): angulae momenta of the relative moti
C        EPN(*), FKPN(*): average energy and wave numbers of the p-N sys
C        KPLPN(*)=0 for uncoupled states,
C                =1 for alpha states,   =2 for gamma states
C        PPN(*): phase shift of the p-n system
C        RPN(*): sin(2*epsilon), mixing parameters
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      COMMON /CNST/AMU,DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
      DIMENSION PNWF(0:NRHOMX, NWF), LLPN(NWF), ISPN(NWF), JJPN(NWF),
     +          FKPN(NWF), KPLPN(NWF), EPN(NWF), PPN(NWF), RPN(NWF),
     +          DKPN(NWF)
      DIMENSION PSHIFT(2), WORK(*)
C        (step size)**2*(driving term )/12 should be less than XREF
      DATA  XREF / 200/
C            angular momentum quantum numbers of p-n states
C               for uncoupled states  (KOUPLE=0)
C                     ID=1    ID=2  ID=3   ID=4   ID=5   ID=6   ID=7
C (2*T+1),(2*S+1)L,J  1,1P1: 1,3D2; 3,1S0; 3,1D2; 3,3P0; 3,3P1; 3D3
C               for coupled states (KOUPLE=1)
C                     ID=1         ID=2
C               T=0 3S1-3D1      T=1 3P2-3F2
C              used for 3D3 states
      DATA  EMPC2, EMNC2 / 938.27231D0, 939.56563D0/
C
      NW0=1
C          bound states ?
      IF(ISB .EQ. 0) GOTO 20
      CALL PNBOUN(NRHOMX, H, PNWF, ED)
      DO 11 I=1,2
      EPN(NW0)=ED
      FKPN(NW0)=-1
      DKPN(NW0)=1
      PPN(NW0)=0
      RPN(NW0)=0
      LLPN(NW0)=0
      ISPN(NW0)=1
      JJPN(NW0)=1
      KPLPN(NW0)=1
   11 NW0=NW0+1
      LLPN(NW0-1)=2
      IF(NKBIN .LE. 0) RETURN
C
C  **********   scattering states   ************
C         define potential table
   20 CONTINUE
      IDSUB=KOUPLE+2
      IF(KOUPLE .NE. 0 .OR. ID .NE. 7) GOTO 22
C        special case of Gaussian pot. for 3D3
      IDSUB=1
      RMAS=EMPC2*EMNC2/(EMPC2+EMNC2)
      EFAC=2*RMAS/HBARC**2
      RANGE =  1.24D0
      VDEPTH=-38.00D0
      LL=2
      VFAC=VDEPTH*EFAC*H*H/12
      FLFAC=LL*(LL+1)/12.0D0
      DO 21 N=1, NRHOMX
      X=(N*H/RANGE)**2
      IF(X .GT. 30) X=30
   21 WORK(N)=1-VFAC*EXP(-X)-FLFAC/N**2
      IV1=NRHOMX
      GOTO 23
   22 KFAC=2*KOUPLE+1
      IP1=KFAC*NRHOMX
      IF(IP1 .GT. IWMAX) GOTO 905
      CALL RSCPOT(ID, KOUPLE, NRHOMX, H, WORK)
C         power series expansion of potentials
      NPMAX=50
      IV0=IP1+1
      IV1=IV0+KFAC*(NPMAX+2)
      IF(IV1 .GT. IWMAX) GOTO 905
      CALL POTSER(ID, KOUPLE, NPMAX, WORK(IV0))
C         solve radial Schroedinger eq.
   23 IW0=IV1+1
      IW1=IW0+(NRHOMX+2)*(1+3*KOUPLE)
      IF(IW1 .GT. IWMAX) GOTO 905
      HMU=H*PNMU
      NK= 100
      NKC=NK/2
      NK=2*NKC
      FKBIN=(FKMAX-FKMIN)/NKBIN
      DELK=FKBIN/NK
      WKFAC=DELK/(3*SQRT(FKBIN))
      DO 24 M=NW0, NWF
      DO 24 N=0, NRHOMX
   24 PNWF(N, M)=0
      DO 40 NKB=1, NKBIN
      FK0=FKMIN+(NKB-1)*FKBIN
      NW1=NW0+3*KOUPLE
C          k-integration loop
      IINT=2
      DO 36 N=0, NK
      WEIGHT=IINT*WKFAC
      IF(N .EQ. 0 .OR. N .EQ. NK) WEIGHT=WEIGHT/2
      IINT=6-IINT
      FK=FK0+DELK*N
      IF(FK .LT. 1.0D-3) GOTO 36
      HMU=H*PNMU
      PMIX=0
      GOTO (25, 26, 27), IDSUB
C            ****** here for 3D3 UNcoupled states ***
   25 CALL GSWF(FK, H, NRHOMX, LL, WORK, WORK(IW0), PSHIFT)
      GOTO 31
C            ****** here for UNcoupled states ******
   26 CALL REIDNC(ID, FK, HMU, NRHOMX, XREF, WORK(IV0), NPMAX,  WORK,
     +            WORK(IW0), PSHIFT)
      GOTO 31
C            ****** here for COUPLED states ******
   27 CALL REIDCC(ID, FK, HMU, NRHOMX, XREF, WORK(IV0), NPMAX,  WORK,
     +            WORK(IW0), PSHIFT, PMIX)
      GOTO 31
C          k-integration of scatt. wave functions
   31 IW=IW0
      DO 32 NN=NW0, NW1
      DO 32 M=0, NRHOMX
      PNWF(M,NN)=PNWF(M,NN)+WEIGHT*WORK(IW)
   32 IW=IW+1
      IF(N .NE. NKC) GOTO 36
      ED=(FK/PNMU)**2*(1+(FKBIN/FK)**2/12)/VIFAC
C         define EPN, FKPN
      TEMP=SQRT(ED*VIFAC)*PNMU
      DO 33 NN=NW0, NW1
      EPN(NN)=ED
      FKPN(NN)=TEMP
      DKPN(NN)=1/SQRT(FKBIN)
   33 RPN(NN)=PMIX
      NN=NW0
      JD=ID
      IF(KOUPLE .EQ. 1) JD=6+ID*2
C          define phase shift and angular momenta
      DO 35 M=1, 1+KOUPLE
      LD=JD
      DO 34 MM=1, 1+KOUPLE
      PPN(NN)=PSHIFT(M)
      LLPN(NN)=LLTAB(LD)
      ISPN(NN)=ISTAB(JD)
      JJPN(NN)=JJTAB(JD)
      KPLPN(NN)=M
      LD=LD+1
   34 NN=NN+1
   35 CONTINUE
      IF(KOUPLE .EQ. 0) KPLPN(NW0)=0
   36 CONTINUE
C        change sign for induced states
      IF(KOUPLE .EQ. 0)GOTO 40
      N1=NW0+1
      N2=NW0+2
      DO 37 M=0, NRHOMX
      PNWF(M,N1)=-PNWF(M,N1)
   37 PNWF(M,N2)=-PNWF(M,N2)
   40 NW0=NW1+1
      RETURN
C          error messages
  905 WRITE(6,906)IP1, IV1, IW1, IWMAX
  906 FORMAT(1H ,'(RSCWF) IP1 IV1 IW1=',3I6,' is more than ',I5)
      STOP
      END
      SUBROUTINE POTSER(ID, KOUPLE, NPMAX, VV)
C          power series expansion of Reid soft core potential
C Input ID: identifier of p-n states
C          for uncoupled states
C              ID=1   ID=2  ID=3  ID=4  ID=5  ID=6
C              1P1    3D2   1S0   1D2   3P0   3P1
C          for coupled states of p-n pair
C              ID=1      ID=2
C             3S1-3D1   3P2-3F2
C       KOUPLE: =1 for coupled states
C       NPMAX: max. power of seroes expansion max. of 50
C OUTPUT VV(-1: NRHOMX, 3)
C        VV(*,1): S,  VV(*,2): T and VV(*,3) for D matrices
      IMPLICIT REAL*8(A-H, O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      DIMENSION VV(-1:NPMAX, 3)
C
      IF(NPMAX .GT. 50) GOTO 91
      IF(ID .LT. 0 .OR. ID .GT. 6) GOTO 93
C            clear the memory
      DO 1 I=1,2*KOUPLE+1
      DO 1 N=-1, NPMAX
    1 VV(N,I)=0
      IF(KOUPLE .EQ. 1) GOTO 10
C        pointer of the potential parameter table
      IP0=1
      DO 2 M=1, ID-1
    2 IP0=IP0+NTERM(M)
      IP1=IP0+NTERM(ID)-1
C       power series expansion of potential
      DO 4 IP=IP0, IP1
      NN=NPOW(IP)
      N1=NPMAX-NN
      FAC=VDEP(IP)*VIFAC
      RANGE=IRPOT(IP)
      DO 3 N=0, N1
      IF(NN .GE. -1) VV(NN,1)=VV(NN,1)+FAC
      FAC=FAC*RANGE/(N+1)
    3 NN=NN+1
    4 CONTINUE
      RETURN
C          here for coupled states
   10 IF(KOUPLE .NE. 1 .OR. ID .LE. 0 .OR. ID .GT. 2) GOTO 93
      IOFF=(ID-1)*3
      IP=(ID-1)*(MTERM(1)+MTERM(2)+MTERM(3))
      DO 11 I=1,3
      DO 11 N=-1, NPMAX
   11 VV(N,I)=0
C          power series expansion
C     I=1 for central, I=2 for tensor and I=3 for L*S pot. here
      DO 20 I=1, 3
      NT=MTERM(I+IOFF)
      DO 13 MT=1, NT
      IP=IP+1
      FAC=UDEP(IP)*VIFAC
      RANGE=IURNG(IP)
      N0=MPOW(IP)
      NN=0
      DO 12 N=N0, NPMAX
      IF(N .GE. -1) VV(N,I)=VV(N,I)+FAC
      NN=NN+1
   12 FAC=FAC*RANGE/NN
   13 CONTINUE
   20 CONTINUE
C        making up S, T and D elements
C        I=1 for S, I=2 for T and I=3 for D matrix
      IP=2*ID+1
      UTS=-2*(ID-1.0D0)/IP
      UTD=-2*(ID+2.0D0)/IP
      ULS=  ID-1
      ULD=-(ID+2)
      UTT=6*SQRT(ID*(ID+1.0D0))/IP
      DO 30 N=-1, NPMAX
      S=VV(N,1)+UTS*VV(N,2)+ULS*VV(N,3)
      T=        UTT*VV(N,2)
      D=VV(N,1)+UTD*VV(N,2)+ULD*VV(N,3)
      VV(N,1)=S
      VV(N,2)=T
   30 VV(N,3)=D
      RETURN
C         error message
   91 WRITE(6,92)NPMAX
   92 FORMAT(1H ,'(POTSER)  NPMAX=',I5,' is NOT accepted !!')
      STOP
   93 WRITE(6,94)ID, KOUPLE
   94 FORMAT(1H ,'(POTSER) ID  and KOUPLE=',2I2,' NOT accepted !!')
      STOP
      END
      SUBROUTINE GSWF(FK, H, NMAX, LL, PTAB, WF, PSHIFT)
C           scattering wave function and phase shift
C           PTAB=(1-H*H*(nuclear potential +centrifugal pot.)/12)
C           ECM term is added in this routine
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PTAB(NMAX), WF(0:NMAX)
      DATA PI /3.14159365358979D0/
      FKFAC=(H*FK)**2/12
      U =1.0D-8
      G0=0
      G1=(PTAB(1)+FKFAC)*U
      WF(1)=U
      DO 10 N=2, NMAX
      G2=12*U-10*G1-G0
      U=G2/(PTAB(N)+FKFAC)
      WF(N)=U
      G0=G1
   10 G1=G2
C          logarithmic derivative
      N=NMAX
      FLDER=(WF(NMAX  )-WF(NMAX-6)-9*(WF(NMAX-1)-WF(NMAX-5))+
     +   45*(WF(NMAX-2)-WF(NMAX-4)))/(60*H*FK*   WF(NMAX-3))
      X=FK*H*(NMAX-3)
      CALL FJNCAL(LL, X, FJ, FJD, FN, FND)
C          phase shift in radian
      PSHIFT=ATAN((FLDER*FJ-FJD)/(FLDER*FN-FND))
      X=SQRT(2.0D0/PI)*(COS(PSHIFT)*FJ-SIN(PSHIFT)*FN)
     +                                 /WF(N-3)
      DO 11 N=1, NMAX
   11 WF(N)=X*WF(N)
      WF(0)=0
      RETURN
      END
      SUBROUTINE REIDNC(ID, FK, HMU, NRHOMX, XREF, VV, NPMAX, POT,
     +                  UWF, DELTA)
C       solves scattering state wave function
C Input ID: state ID
C       FK: wave number in 1/fm
C       HMU : step size scale by PNMU
C       NRHOMX: number of integration points. size of array UWF
C       XREF : convergence reference
C       VV(-1:NPMAX): power series expansion coeff. of potential
C       NPMAX: size of array VV
C       POT(r): potential scaled by VIFAC and HMU**2/12
C Output UWF(0:NRHOMX): wave function .
C                      actual wave function is UWF(r)/r
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      DIMENSION VV(-1: NPMAX), UWF(0:NRHOMX), POT(NRHOMX)
      DATA PI/ 3.14159265358979D0/
C       initial value
      FK2=FK*FK
      FK2MU=FK2/PNMU**2
      LL=LSTAT(ID)
C          expansion coeff. of power series
      VV0=VV(0)
      VV(0)=VV0-FK2MU
      DO 1 N=1, LL
    1 UWF(N)=0
      UWF(LL+1)=1.0D0
      FLL=LL*(LL+1)
      DO 3 N=LL+2, NPMAX
      TEMP=0
      IU=N-1
      IV0=-1
      IV1=MIN(NPMAX, N-LL-1)
      DO 2 IV=IV0, IV1
      TEMP=TEMP+VV(IV)*UWF(IU)
    2 IU=IU-1
    3 UWF(N)=TEMP/(N*(N-1)-FLL)
      VV(0)=VV0
C        pointer of the potential parameter table
      IP0=1
      DO 4 M=1, ID-1
    4 IP0=IP0+NTERM(M)
      IP1=IP0+NTERM(ID)-1
C        power series expansion of UWF at X=X1
      X1=HMU
      U1=0
      FAC=1
      DO 11 N=LL+1, NPMAX
      TEMP=FAC*UWF(N)
      U1=U1+TEMP
      IF( ABS(TEMP) .LT. 1.0D-6) GOTO 12
   11 FAC=FAC*X1
      GOTO 93
   12 U1=U1*X1**(LL+1)
C       evaluate potential at X1
      V1=POT(1)-FK2MU*HMU*HMU/12
C     store wave function
      UWF(1)=U1
      VQ=XREF*ABS(V1)
C          Need reducing step size ?
      HH=HMU
      IF(VQ .LT. 1.0D0) THEN
         V0=0
         V1=U1*(1-V1)
         IU=2
         H2=HH**2/12
         GOTO 30
      END IF
C        Halve the step size
      I0=1
      DO 14 N=1, 50
      HH=HH/2
      VQ=VQ/4
      I0=I0*2
      IF(VQ .LT. 1.0D0) GOTO 15
   14 CONTINUE
      GOTO 91
C       Integrate by using reduced step size
C        power series expansion of UWF at X=X0
   15 N4=N
      X0=HMU-HH
      U0=0
      FAC=1
      DO 16 N=LL+1, NPMAX
      TEMP=FAC*UWF(N)
      U0=U0+TEMP
      IF( ABS(TEMP) .LT. 1.0D-6) GOTO 17
   16 FAC=FAC*X0
C       evaluate potential at X0
   17 U0=U0*X0**(LL+1)
      H2=HH**2/12
      V0=0
      DO 18 IP=IP0, IP1
      XX=IRPOT(IP)*X0
      VP=VDEP(IP)
      NN=NPOW(IP)
   18 V0=V0+VP*EXP(XX)*X0**NN
      V0=(V0*VIFAC+FLL/X0**2-FK2MU)*H2
C        integration start
      UV0=U0*V0
      UV1=U1*V1/I0
      V0=U0-UV0
      V1=U1-UV1
      IU=2
      XNEXT=IU*HMU
      IADD=1
      DO 25 N=1, N4
   20 NSTEP=2
      I1=I0+IADD*NSTEP
      IF(INT(I1/(2*IADD))*(2*IADD) .NE. I1) NSTEP=3
      I1=I0+IADD*NSTEP
      DO 22 M=1, NSTEP
      V2=12*U1-10*V1-V0
C       evaluate potential at X2
      X2=X1+M*HH
      VQ=0
      DO 21 IP=IP0, IP1
      XX=IRPOT(IP)*X2
      VP=VDEP(IP)
      NN=NPOW(IP)
   21 VQ=VQ+VP*EXP(XX)*X2**NN
      VQ=(VQ*VIFAC+FLL/X2**2-FK2MU)*H2
      U1=V2/(1-VQ)
      VM=V0
      V0=V1
      V1=V2
      UVM=UV0
      UV0=UV1
      UV1=U1*VQ
C        store the result
      IF(ABS(X2-XNEXT) .LT. H2) THEN
          UWF(IU)=U1
          IU=IU+1
          XNEXT=HMU*IU
      END IF
   22 CONTINUE
      X1=X2
      I0=I1
C       increase step size ?
      IF(ABS(VQ)*XREF .GT. 1.0D0) GOTO 20
      HH=HH*2
      H2=HH**2/12
      V0=VM-2*UVM
      V1=V1-2*UV1
   24 IADD=IADD*2
   25 CONTINUE
C       step size is now fixed
   30 FK2XX=FK2MU*H2
      DO 32 N=IU, NRHOMX
      VQ=POT(N)-FK2XX
      V2=12*U1-10*V1-V0
      U1=V2/(1-VQ)
      X2=N*HMU
      UV1=U1*VQ
      UWF(N)=U1
      V0=V1
      V1=V2
   32 CONTINUE
C         logarithmic derivative
      IU=NRHOMX-3
      TEMP=PNMU/(60*FK*HMU*UWF(IU))
      VQ= (UWF(IU+3)-UWF(IU-3)-9*(UWF(IU+2)-UWF(IU-2))+
     + 45*(UWF(IU+1)-UWF(IU-1)))*TEMP
C  UWF(r)/r --> sqrt(2/pi)*(cos(delta)*j(L,rho)-sin(delta)*n(L,rho))
      RHO=FK*IU*HMU/PNMU
      CALL FJNCAL(LL, RHO, FJ, FJD, FN, FND)
      V0=FJD-FJ*VQ
      V1=FND-FN*VQ
      DELTA=ATAN(V0/V1)
C        normalize UWF(rho)
      VQ=SQRT(2/PI)*(COS(DELTA)*FJ-SIN(DELTA)*FN)/UWF(IU)
      DO 34 N=1,NRHOMX
   34 UWF(N)=VQ*UWF(N)
      UWF(0)=0
      RETURN
C          error messages
   91 WRITE(6,92)ID, HMU
   92 FORMAT(1H ,'(SCWFNC) ID=',I2,2X,'HMU=',F7.4,2X,
     +           'step size too large !!')
      STOP
   93 WRITE(6,94)ID, HMU
   94 FORMAT(1H ,'(SCWFNC) ID=',I2,' No convergence at HMU=',1PE13.4)
      STOP
      END
      SUBROUTINE FJNCAL(LL, RHO, FJ, FJD, FN, FND)
C          returns RHO*(spherical Bessel and Neuman functions)
C                  and their derivatives
C Input LL: order 0, 1, 2 and 3 are allowed
C       RHO: argument
C Output FJ, FJD: spherical Bessel function and its derivative
C        FN, FND: spherical Neuman function and its derivative
      IMPLICIT REAL*8 (A-H,O-Z)
      S=SIN(RHO)
      C=COS(RHO)
      LP=LL+1
      IF(LP .LT. 1 .OR. LP .GT. 4) GOTO 91
      GOTO(10, 11, 12, 13),LP
C          here for LL=0
   10 FJ= S
      FN=-C
      FJD=C
      FND=S
      RETURN
C         here for LL=1
   11 FJ= S/RHO-C
      FN=-C/RHO-S
      FJD=-FJ/RHO+S
      FND=-FN/RHO-C
      RETURN
C         here for LL=2
   12 FJ= 3*(S/RHO-C)/RHO-S
      FN=-3*(C/RHO+S)/RHO+C
      FJD=(-6*(S/RHO-C)/RHO+3*S)/RHO-C
      FND=( 6*(C/RHO+S)/RHO-3*C)/RHO-S
      RETURN
C         here for LL=3
   13 FJ=( 15*(S/RHO-C)/RHO-6*S)/RHO+C
      FN=(-15*(C/RHO+S)/RHO+6*C)/RHO+S
      FJD=((45*(-S/RHO+C)/RHO+21*S)/RHO-6*C)/RHO-S
      FND=((45*( C/RHO+S)/RHO-21*C)/RHO-6*S)/RHO+C
      RETURN
   91 WRITE(6,92)LL
   92 FORMAT(1H ,'(FJNCAL) your LL=',I2,' is out of bound !')
      STOP
      END
      SUBROUTINE PNBOUN(NRMAX, DR, UWF, ENERGY)
C --- Deuteron wave function under Reid soft core pot. --
C        due to Kamimura
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION UWF(0:NRMAX, 2), R0(20,2), AMP(20,2), LL(2)
      DATA ENERG, LL/-2.224600629780050D0, 0, 2/
      DATA (R0(N,1),N=1,20) /
     1      5.000000000000000D-02,    6.853628031883592D-02,
     2      9.394443439884112D-02,    1.287720418070693D-01,
     3      1.765111350903633D-01,    2.419483326789811D-01,
     4      3.316447750232324D-01,    4.545939853453906D-01,
     5      6.231236162177697D-01,    8.541314966877560D-01,
     6      1.170779913722778D+00,    1.604818007171338D+00,
     7      2.199765136004209D+00,    3.015274399935734D+00,
     8      4.133113830244105D+00,    5.665364961185353D+00,
     9      7.765660821766207D+00,    1.064459013883141D+01,
     A      1.459081227268133D+01,    1.999999999999998D+01 /
      DATA (R0(N,2),N=1,20) /
     1      1.000000000000000D-01,    1.314312241397370D-01,
     2      1.727416667886979D-01,    2.270364872597712D-01,
     3      2.983968344493754D-01,    3.921866123110386D-01,
     4      5.154556654725626D-01,    6.774696910282168D-01,
     5      8.904067080940795D-01,    1.170272436270383D+00,
     6      1.538103388760089D+00,    2.021548112382163D+00,
     7      2.656945430677623D+00,    3.492055904264408D+00,
     8      4.589651822618674D+00,    6.032235574219475D+00,
     9      7.928241058189351D+00,    1.042018427552750D+01,
     A      1.369537575094219D+01,    1.800000000000001D+01 /
      DATA (AMP(N,1),N=1,20) /
     1      5.654071434983240D-04,   -1.978464507237817D-03,
     2      4.080011707688121D-03,   -5.972445363836683D-03,
     3      7.874204861154775D-03,    2.488915529783482D-02,
     4      1.922172105205677D-01,   -2.195544797561942D-01,
     5     -5.528817353854350D-01,   -1.053029010656746D-01,
     6      1.554619463318996D-01,    1.635508240918638D-01,
     7      1.251317788974277D-01,    9.062900837974749D-02,
     8      5.981953265980704D-02,    3.593182813547673D-02,
     9      1.785980513081788D-02,    6.443631058929535D-03,
     A      1.221464265950173D-03,    7.614155306275971D-05 /
      DATA (AMP(N,2),N=1,20) /
     1      4.324930791686299D-03,   -1.468640566140386D-02,
     2      1.522397016973368D-02,   -1.809205937633738D-02,
     3     -1.088856600935350D-01,   -3.908868801793741D-01,
     4     -5.980811173264666D-02,    2.675394534922502D-01,
     5      2.051620423914201D-01,    9.221896596292808D-02,
     6      3.408939936552462D-02,    1.121488974378575D-02,
     7      3.260907122969903D-03,    8.441361338469141D-04,
     8      1.949758860385499D-04,    4.080615272078150D-05,
     9      7.231661421970024D-06,    1.016299599747866D-06,
     A      8.596836991379105D-08,    4.110939848073481D-09 /
CCCCC =========================================================
      NR1=MIN(INT(40.0/DR), NRMAX)
      DO 10 N=1,2
      DO 10 NR=0,NR1
   10 UWF(NR,N)= 0.0D0
      ENERGY= ENERG
C
      DO 20 NC=1,2
      L1= LL(NC)+1
      DO 20 NR=0,NR1
      R=DR*NR
      RL=R**L1
      DO 15 N=1, 20
      X=(R/R0(N,NC))**2
      IF(X.GT.174) GO TO 15
      UWF(NR,NC)=UWF(NR,NC)+AMP(N,NC)*EXP(-X)
   15 CONTINUE
      UWF(NR,NC)= UWF(NR,NC)*RL
   20 CONTINUE
C        change sign for NC=2: (i)**2
      DO 21 NR=0, NR1
   21 UWF(NR, 2)=-UWF(NR, 2)
      IF(NR1 .EQ. NRMAX) RETURN
C**********************************
C        due to Reid
      ALPHA=0.33087D0
      GMU=0.7D0
      AS=0.87758D0
      AD=-AS*0.026223D0
      XFAC=ALPHA*GMU*DR
      DO 22 N=NR1+1,NRMAX
      X=XFAC*N
      EX=EXP(-X)
      UWF(N,1)=AS*EX
   22 UWF(N,2)=AD*EX*(1+3/X+3/X**2)
      RETURN
      END
      SUBROUTINE REIDCC(ID, FK, HMU, NRHOMX, XREF, UU,
     +                  NPMAX,  POT, WF, PHASE, EPS)
C           solve coupled equation
C Input ID: =1 for 3S1-3D1 coupling and ID=2 for 3P2-3F2 coupling
C       FK: (wave number) in 1/fm
C       HMU  : integration step size scaled by PNMU
C       NRHOMX: max. number of integration steps
C       XREF: convergence ref. XREF >> 1
C       UU(-1:NPMAX): expansion coeff. of potential
C       NPMAX: size of array UU and UW
C       POT(NRHOMX, 3): potential scaled vy VIFAC and HMU**2/12
C Output WF(NRHOMX, 2, 2): wave function
C        WF(rho,1,*)=u(rho), and WF(rho,2,*)=w(rho)
C        PHASE(2): barred phase shift
C                  PHASE(1)= del(L=J-1) and PHASE(2)= del(L=J+1)
C        EPS     : barred mixing parameter. sin(2*epsilon)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      DIMENSION UU(-1:50, 3), WF(0:NRHOMX, 2, 2), PHASE(2),
     +          P(2,2), PUW(2,2,3), PV(2,2,3), POT(NRHOMX, 3),
     +          U(2), W(2), UM(2), WM(2), WJPX(6,2)
C         parameters of starting values for coupled equations
C                                  3S1-3D1
      DATA WJPX/ 1.0737797123581270D-06, -1.9907076427550060D-15,
     +          -5.1436125332707450D-12, -3.6415199623987780D-14,
     +           8.4939234333468060D-15, -6.0060980295808480D-16,
C                                 3P2-3F2
     +           3.9632618041062210D-08,  2.0882164905369820D-17,
     +          -6.6096828549973470D-14,  6.0824693319449770D-16,
     +          -6.0513947544433930D-16,  1.5245501197732730D-16/
C
      J=ID
      FK2MU=(FK/PNMU)**2
      FLM=J*(J-1)
      FLP=(J+1)*(J+2)
      FK2XX=FK2MU*HMU**2/12
C        define initial step size HH
      P(1,1)=POT(1,1)-FK2XX
      P(1,2)=POT(1,2)
      P(2,2)=POT(1,3)-FK2XX
      TEMP=MAX(ABS(P(1,1)),ABS(P(1,2)),ABS(P(2,2)))*XREF
      IF(TEMP .LT. 1.0D0)STOP '(REIDCC) something wrong at init. step'
      I0=1
      HH=HMU
      DO 10 N=1, 50
      I0=I0*2
      TEMP=TEMP/4
      IF(TEMP .LT. 1.0D0) GOTO 11
   10 CONTINUE
      STOP '(REIDCC) step size too large at 10 '
C        define starting values at X1 and X2
   11 NN=N
      P(1,1)=P(1,1)/I0**2
      P(1,2)=P(1,2)/I0**2
      P(2,2)=P(2,2)/I0**2
      HH=HH/I0
      H2=HH**2/12
      UU1=UU(0,1)
      UU3=UU(0,3)
      UU(0,1)=UU1-FK2MU
      UU(0,3)=UU3-FK2MU
      X2=HMU
      X1=HMU-HH
C        UJ and WJP are initial values of power series expansion
      UJ =1.0D-10
      WJP=((((WJPX(6,ID) *FK+WJPX(5,ID))*FK+WJPX(4,ID))*FK
     +       +WJPX(3,ID))*FK+WJPX(2,ID))*FK+WJPX(1,ID)
C
C#  k          3S1-3D1                   3P2-3F2
C  0.05    1.0737796993842985E-06  3.9632617877012252E-08 
C  0.10    1.0737796607003238E-06  3.9632617382632751E-08
C  0.15    1.0737795962199734E-06  3.9632616558710150E-08 
C  0.20    1.0737795059362573E-06  3.9632615405322955E-08
C  0.25    1.0737793898410226E-06  3.9632613922580667E-08 
C  0.30    1.0737792479115479E-06  3.9632612110569699E-08
C  0.35    1.0737790801237885E-06  3.9632609969333426E-08 
C  0.40    1.0737788864648269E-06  3.9632607498908388E-08
C  0.45    1.0737786669015521E-06  3.9632604699234672E-08 
C  0.50    1.0737784214282319E-06  3.9632601570272374E-08 
C  0.55    1.0737781500152532E-06  3.9632598111704663E-08 
C  0.60    1.0737778526596226E-06  3.9632594323517418E-08 
C  0.65    1.0737775293360185E-06  3.9632590205431480E-08 
C  0.70    1.0737771800318427E-06  3.9632585757174677E-08 
C  0.75    1.0737768047615230E-06  3.9632580978588558E-08 
C  0.80    1.0737764034864092E-06  3.9632575869411068E-08 
C  0.85    1.0737759762063350E-06  3.9632570429155373E-08 
C  0.90    1.0737755229153973E-06  3.9632564657815269E-08 
C  0.95    1.0737750435917055E-06  3.9632558555060066E-08 
C  1.00    1.0737745382366057E-06  3.9632552120650075E-08 
C  1.05    1.0737740068396619E-06  3.9632545354365728E-08 
C  1.10    1.0737734493935582E-06  3.9632538256020115E-08
C          two independent starting values at X1 and X2
      DO 12 I=1, 2
      CALL RCCINI(ID, X1, X2, NPMAX, UU, UJ, WJP, WF,
     +            UM(I),U(I),WM(I),W(I))
      PV( 1,I,2)=P(1,1)*U(I)+P(1,2)*W(I)
      PV( 2,I,2)=P(1,2)*U(I)+P(2,2)*W(I)
      PUW(1,I,2)=U(I)-PV(1,I,2)
      PUW(2,I,2)=W(I)-PV(2,I,2)
      WJP=-WJP
   12 CONTINUE
C       recover potential parameter
      UU(0,1)=UU1
      UU(0,3)=UU3
      DO 13 I=1,2
      WF(0,1,I)=0
      WF(0,2,I)=0
      WF(1,1,I)=U(I)
   13 WF(1,2,I)=W(I)
      CALL RCCPOT(ID, X1, P, FK2MU, FLM, FLP)
      P(1,1)=P(1,1)*H2
      P(1,2)=P(1,2)*H2
      P(2,2)=P(2,2)*H2
      DO 14 I=1,2
      PV( 1,I,1)=P(1,1)*UM(I)+P(1,2)*WM(I)
      PV( 2,I,1)=P(1,2)*UM(I)+P(2,2)*WM(I)
      PUW(1,I,1)=UM(I)-PV(1,I,1)
   14 PUW(2,I,1)=WM(I)-PV(1,I,1)
C       integration start
      XNEXT=2*HMU
      IU=2
      ID1=1
      ID2=2
      ID3=3
      IADD=1
      DO 30 N=1, NN
   15 NSTEP=2
      I1=I0+IADD*NSTEP
      IF(INT(I1/(2*IADD))*(2*IADD) .NE. I1) NSTEP=3
      I1=I0+IADD*NSTEP
      DO 20 M=1, NSTEP
      DO 16 I=1,2
      DO 16 K=1,2
   16 PUW(K,I,ID3)=2*PUW(K,I,ID2)-PUW(K,I,ID1)+PV(K,I,ID2)*12
      X3=X2+M*HH
      CALL RCCPOT(ID, X3, P, FK2MU, FLM, FLP)
      P(1,1)=P(1,1)*H2
      P(1,2)=P(1,2)*H2
      P(2,2)=P(2,2)*H2
      TEMP=(1-P(1,1))*(1-P(2,2))-P(1,2)**2
C             apply inverse
      DO 17 I=1,2
      U(I)=((1-P(2,2))*PUW(1,I,ID3)+   P(1,2) *PUW(2,I,ID3))/TEMP
      W(I)=(   P(1,2) *PUW(1,I,ID3)+(1-P(1,1))*PUW(2,I,ID3))/TEMP
      PV(1,I,ID3)=P(1,1)*U(I)+P(1,2)*W(I)
   17 PV(2,I,ID3)=P(1,2)*U(I)+P(2,2)*W(I)
      IF(ABS(XNEXT-X3) .GT. H2) GOTO 19
C       store u(X3) and w(X3)
      DO 18 I=1,2
      WF(IU,1,I)=U(I)
   18 WF(IU,2,I)=W(I)
      IU=IU+1
      XNEXT=HMU*IU
C         shift
   19 JD1=ID1
      ID1=ID2
      ID2=ID3
      ID3=JD1
   20 CONTINUE
      I0=I1
      X2=X3
      TEMP=MAX(ABS(P(1,1)), ABS(P(1,2)), ABS(P(2,2)))*XREF
C        increase the step size ?
      IF(TEMP .GT. 1.0D0) GOTO 15
C        yes !  increase the step size
      JD1=ID1
      ID1=ID3
      ID3=JD1
      DO 21 I=1,2
      DO 21 K=1,2
      PUW(K,I,ID1)=PUW(K,I,ID1)-3*PV(K,I,ID1)
   21 PUW(K,I,ID2)=PUW(K,I,ID2)-3*PV(K,I,ID2)
      DO 22 I=1,2
      DO 22 K=1,2
   22 PV(K,I,ID2)=4*PV(K,I,ID2)
      IADD=2*IADD
      HH=2*HH
      H2=HH**2/12
   30 CONTINUE
C           step size is fixed now
      DO 35 M=IU, NRHOMX
      DO 31 I=1,2
      DO 31 K=1,2
   31 PUW(K,I,ID3)=2*PUW(K,I,ID2)-PUW(K,I,ID1)+PV(K,I,ID2)*12
      X3=M*HMU
      P(1,1)=POT(M,1)-FK2XX
      P(1,2)=POT(M,2)
      P(2,2)=POT(M,3)-FK2XX
      TEMP=(1-P(1,1))*(1-P(2,2))-P(1,2)**2
C             apply inverse
      DO 32 I=1,2
      WF(M,1,I)=((1-P(2,2))*PUW(1,I,ID3)+   P(1,2) *PUW(2,I,ID3))/TEMP
      WF(M,2,I)=(   P(1,2) *PUW(1,I,ID3)+(1-P(1,1))*PUW(2,I,ID3))/TEMP
      PV(1,I,ID3)=P(1,1)*WF(M,1,I)+P(1,2)*WF(M,2,I)
   32 PV(2,I,ID3)=P(1,2)*WF(M,1,I)+P(2,2)*WF(M,2,I)
      JD1=ID1
      ID1=ID2
      ID2=ID3
   35 ID3=JD1
C        normalize
      DO 38 I=1, 2
      X1=0
      DO 36 N=1, NRHOMX
   36 X1=X1+WF(N,1,I)**2+WF(N,2,I)**2
      X1=1/SQRT(X1)
      DO 37 N=1,NRHOMX
      WF(N,1,I)=WF(N,1,I)*X1
   37 WF(N,2,I)=WF(N,2,I)*X1
   38 CONTINUE
C            inner product
C      CROSS=0
C      DO 39 N=1, NRHOMX
C   39 CROSS=CROSS+WF(N,1,1)*WF(N,1,2)+WF(N,2,1)*WF(N,2,2)
C      WRITE(6,998)CROSS
C  998 FORMAT(1H ,'CROSS=',1PE13.4)
C         derivative
C     P(2,2): derivatives with respect to (rho), the p-n relative dist.
C     P(1,*)=du/d(rho) and P(2,*)=dw/d(rho). * identifies indep. sol.
      TEMP=PNMU/(60*HMU*FK)
      K=NRHOMX
      DO 41 I=1,2
      DO 41 N=1,2
      P(N,I)=(WF(K  ,N,I)-WF(K-6,N,I)-9*(WF(K-1,N,I)-WF(K-5,N,I))+
     +    45*(WF(K-2,N,I)-WF(K-4,N,I)))*TEMP
   41 CONTINUE
C         normalized scattering state
      K=NRHOMX-3
      U1=WF(K,1,1)
      U2=WF(K,1,2)
      W1=WF(K,2,1)
      W2=WF(K,2,2)
      U1D=P(1,1)
      U2D=P(1,2)
      W1D=P(2,1)
      W2D=P(2,2)
      RHO=K*HMU*FK/PNMU
C
      CALL RSCPHS(ID, U1, U2, W1, W2, U1D, U2D, W1D, W2D, RHO)
C Output U1D, U2D: weights for ALPHA type solution
C        W1D, W2D: weights for GAMMA type solution
C        U1 , U2 : barred phase shifts for L=J-1 and L=J+1
C        W1      : barred mixing parameter sin(2*epsilon) 
      EPS=W1
      PHASE(1)=U1
      PHASE(2)=U2
      DO 44 N=1, NRHOMX
      U1=WF(N,1,1)
      U2=WF(N,1,2)
      W1=WF(N,2,1)
      W2=WF(N,2,2)
      WF(N,1,1)=U1D*U1+U2D*U2
      WF(N,2,1)=U1D*W1+U2D*W2
      WF(N,1,2)=W1D*U1+W2D*U2
   44 WF(N,2,2)=W1D*W1+W2D*W2
      RETURN
      END
      SUBROUTINE RCCINI(ID,X0,X1,NPMAX,UU,UJ,WJP,UW,U0,U1,W0,W1)
C returns u(X0), u(X1), w(X0) and w(X1) by using power series exp.
C Input ID: =1 for 3S1-3D1 coupled states. ID=2 for 3P2-3F2
C       X0, X1: radial distances scaled by PNMU
C       PNMAX : size of array
C       UU(-1:NPMAX, 3): expansion coeff. of potentials
C       UJ, WJP: initial values
C Output U0, U1, W0, W1: u and w at X0 and X1
C working area UW(NPMAX, 3)
C Output UW(1: NPMAX, 4): expansion coeff.
C        UW(*,1)=u(n), UW(*,2)=u_tilde (n)
C        UW(*,3)=w(n), UW(*,4)=w_tilde (n)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION UU(-1:NPMAX, 3), UW(NPMAX, 4)
C           evaluate expansion coeff. of u(x) and w(x)
      J=ID
      FLM=J*(J-1)
      FLP=(J+1)*(J+2)
      DO 1 I=1, 4
      DO 1 K=1, J+2
    1 UW(K,I)=0
C         given parameters
      UW(J  ,1)=UJ
      UW(J+2,3)=WJP
C         first stage
      FJJ=J*(J+1)
      UW(J+1,1)=UU(-1,1)*UJ/(FJJ-FLM)
      UW(J+1,3)=UU(-1,2)*UJ/(FJJ-FLP)
      FJJ=(J+1)*(J+2)
      UW(J+2,1)=(UU(-1,1)*UW(J+1,1)+UU(0,1)*UW(J,1)+UU(-1,2)*UW(J+1,3))
     +          /(FJJ-FLM)
      UW(J+2,4)=(UU(-1,2)*UW(J+1,1)+UU(0,2)*UW(J,1)+UU(-1,3)*UW(J+1,3))
     +          /(2*J+3)
C         recurrence start
      DO 20 N=J+3, NPMAX
      FJJ=N*(N-1)
      N2=N-2
      MMIN=MAX(N2-NPMAX, -1)
C         recurrence for u-tilde(n) and w-tilde(n)
      SU=0
      SW=0
      DO 11 M=MMIN, N-J-5
      SU=SU+UU(M,1)*UW(N2-M,2)
   11 SW=SW+UU(M,2)*UW(N2-M,2)
      DO 12 M=MMIN, N-J-4
      SU=SU+UU(M,2)*UW(N2-M,4)
   12 SW=SW+UU(M,3)*UW(N2-M,4)
      SU=SU/(FJJ-FLM)
      SW=SW/(FJJ-FLP)
      UW(N,2)=SU
      UW(N,4)=SW
C     recurrence for u(n) and w(n)
      SU=-(2*N-1)*SU
      SW=-(2*N-1)*SW
      DO 13 M=MMIN, N2-J
      SU=SU+UU(M,1)*UW(N2-M,1)
   13 SW=SW+UU(M,2)*UW(N2-M,1)
      DO 14 M=MMIN, N2-J-1
      SU=SU+UU(M,2)*UW(N2-M,3)
   14 SW=SW+UU(M,3)*UW(N2-M,3)
      UW(N,1)=SU/(FJJ-FLM)
      UW(N,3)=SW/(FJJ-FLP)
   20 CONTINUE
C          power series expansion
      U0=0
      W0=0
      U1=0
      W1=0
      U0T=0
      U1T=0
      W0T=0
      W1T=0
      XX0=X0
      XX1=X1
      DO 25 N=1, NPMAX
      U0 =U0 +XX0*UW(N,1)
      U1 =U1 +XX1*UW(N,1)
      W0 =W0 +XX0*UW(N,3)
      W1 =W1 +XX1*UW(N,3)
      U0T=U0T+XX0*UW(N,2)
      U1T=U1T+XX1*UW(N,2)
      W0T=W0T+XX0*UW(N,4)
      W1T=W1T+XX1*UW(N,4)
      XX0=XX0*X0
   25 XX1=XX1*X1
      U0=U0+LOG(X0)*U0T
      W0=W0+LOG(X0)*W0T
      U1=U1+LOG(X1)*U1T
      W1=W1+LOG(X1)*W1T
      RETURN
      END
      SUBROUTINE RCCPOT(ID, X, P, FK2MU, FLM, FLP)
C        returns Reid soft core pot. for coupled states
C Input ID: =1 for 3S1-3D1 pair and ID=2 for 3P2-3F2 pair
C       X : (distance between p-n pair)*PNMU
C Output VC, VT, VL: central, tensor and L*S pot,
C                    centrifugal pot. are included.
C                    which are scaled by VIFAC
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      DIMENSION P(2,2)
      IOFF=(ID-1)*3
      IP=(ID-1)*(MTERM(1)+MTERM(2)+MTERM(3))
      DO 20 I= 1, 3
      NT=MTERM(I+IOFF)
      VL=0
      DO 12 MT=1, NT
      IP=IP+1
      FAC=UDEP(IP)*VIFAC
      RANGE=IURNG(IP)
      N0=MPOW(IP)
   12 VL=VL+FAC*EXP(X*RANGE)*X**N0
      IF(I .EQ. 1) VC=VL-FK2MU
      IF(I .EQ. 2) VT=VL/(2*ID+1)
   20 CONTINUE
C          make up S, D, and T element
      VS=VC-2*(ID-1.0D0)      *VT      +(ID-1.0D0)*VL
      VD=VC-2*(ID+2.0D0)      *VT      -(ID+2.0D0)*VL
      VT=6*SQRT(ID*(ID+1.0D0))*VT
C
      P(1,1)=VS+FLM/X**2
      P(2,2)=VD+FLP/X**2
      P(1,2)=VT
      P(2,1)=VT
      RETURN
      END
      SUBROUTINE RSCPOT(ID, KOUPLE, NRHOMX, H, POT)
C         define table of REID soft core potential
C Input ID: identify p-n quantum numbers
C       KOUPLE =1 if coupled state
C       NRHOMX, H: number and size of potential table mesh
C Output POT(NRHOMX,3): potential table
C        POT(r,1): central pot. for uncouples states
C        POT(r,1): S-type pot. for coupled states
C        POT(r,2): T-type pot. for coupled states
C        POT(r,3): D-type pot. for coupled states
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      DIMENSION POT(NRHOMX,3)
      IF(KOUPLE .LT. 0 .OR. KOUPLE .GT. 1) GOTO 91
      IF(KOUPLE .EQ. 0 .AND. (ID .LT. 1 .OR. ID .GT. 6)) GOTO 91
      IF(KOUPLE .EQ. 1 .AND. (ID .LT. 1 .OR. ID .GT. 2)) GOTO 91
      HMU=H*PNMU
      EH=EXP(HMU)
      VH=VIFAC*HMU**2/12
      NK2=2*KOUPLE+1
      DO 11 I=1,NK2
      DO 11 N=1, NRHOMX
   11 POT(N,I)=0
      IF(KOUPLE .EQ. 1) GOTO 20
C          here for uncoupled states
      JD=0
      DO 12 II=1,ID-1
   12 JD=JD+NTERM(II)
      NT=NTERM(ID)
      DO 15 M=1,NT
      JD=JD+1
      VV=VDEP(JD)*VH
      N0=IRPOT(JD)
      NP=NPOW(JD)
      EX0=VV
      EX1=EH**N0
      DO 13 N=1, NRHOMX
      X=HMU*N
      EX0=EX0*EX1
   13 POT(N,1)=POT(N,1)+EX0*X**NP
   15 CONTINUE
C          add centrifugal pot.
      L=LSTAT(ID)
      IF(L .EQ. 0 ) RETURN
      VV=L*(L+1)/12.0D0
      DO 16 N=1, NRHOMX
   16 POT(N,1)=POT(N,1)+VV/N**2
      RETURN
C          here for coupled states
   20 JD=(ID-1)*(MTERM(1)+MTERM(2)+MTERM(3))
      IOFF=(ID-1)*3
      DO 30 I= 1, 3
      NT=MTERM(I+IOFF)
      DO 21 MT=1, NT
      JD=JD+1
      VV=UDEP(JD)*VH
      MP=IURNG(JD)
      N0=MPOW(JD)
      EX0=VV
      EX1=EH**MP
      DO 21 N=1, NRHOMX
      EX0=EX0*EX1
      X=HMU*N
   21 POT(N,I)=POT(N,I)+EX0*X**N0
   30 CONTINUE
C         distribute to S, T, and D type pot.
      FJ=ID
      FJJ=2*FJ+1
      ST=2*(FJ-1)/FJJ
      SL=FJ-1
      TT=6*SQRT(FJ*(FJ+1))/FJJ
      DT=2*(FJ+2)/FJJ
      DL=FJ+2
      FLM= FJ   *(FJ-1)/12
      FLP=(FJ+1)*(FJ+2)/12
      N0=NRHOMX
      DO 31 N=1, NRHOMX
      VC=POT(N,1)
      VT=POT(N,2)
      VL=POT(N,3)
      POT(N,1)=VC-ST*VT+SL*VL+FLM/N**2
      POT(N,2)=   TT*VT
   31 POT(N,3)=VC-DT*VT-DL*VL+FLP/N**2
      RETURN
C      error messages
   91 WRITE(6,92)ID, KOUPLE
   92 FORMAT(1H ,'(RPOT) ID=',I2,2X,'KOUPLE=',I2,' NOT accepted !!')
      STOP
      END
      SUBROUTINE RSCPHS(ID, U1,U2,W1,W2,U1D,U2D,W1D,W2D, RHO)
C Input ID: =1 for 3S1-3D1 coupling : =2 for 3P2-3F2 coupling
C       U1,U2,W1,W2: independent wave functions at matching point
C       U1D,U2D,W1D,W2D: their derivatives
C Output U1D, U2D: weights for ALPHA type solution
C        W1D, W2D: weights for GAMMA type solution
C         barred phase shifts and mixing parameter
C        U1, U2: phase shifts for L=J-1 and L=J+1
C        W1     : mixing parameter sin(2*epsilon)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(2,2), S(2,2), COM, COMD, COP, COPD
C      COMPLEX CU,CW,CUX,CWX
      PI=3.14159265358979D0
C          define incommin/outgoing waves
      CALL FJNCAL(ID-1, RHO, FJ, FJD, FN, FND)
      COM =DCMPLX(-FN,  FJ)
      COMD=DCMPLX(-FND, FJD)
      CALL FJNCAL(ID+1, RHO, FJ, FJD, FN, FND)
      COP =DCMPLX(-FN,  FJ)
      COPD=DCMPLX(-FND, FJD)
C       inverse of A*det(A)
      A(1,1)=  COPD*W2-COP*W2D
      A(2,2)=  COMD*U1-COM*U1D
      A(1,2)=-(COMD*U2-COM*U2D)
      A(2,1)=-(COPD*W1-COP*W1D)
      COMD=DCMPLX(0,2)/(A(1,1)*A(2,2)-A(1,2)*A(2,1))
C       evaluate weight matrix A
C  chi(-)=A(1,1)*chi(1)+A(2,1)*chi(2): has incomming wave in L=J-1 ch.
C  chi(+)=A(1,2)*chi(1)+A(2,2)*chi(2): has incomming wave in L=J+1 ch.
      A(1,1)=A(1,1)*COMD
      A(2,1)=A(2,1)*COMD
      A(1,2)=A(1,2)*COMD
      A(2,2)=A(2,2)*COMD
C        evaluate S-matrix S
      S(1,1)=(CONJG(COM)-U1*A(1,1)-U2*A(2,1))/COM
      S(1,2)=(          -U1*A(1,2)-U2*A(2,2))/COM
      S(2,1)=(          -W1*A(1,1)-W2*A(2,1))/COP
      S(2,2)=(CONJG(COP)-W1*A(1,2)-W2*A(2,2))/COP
C           2*epsilon (Eigen mixing parameter)
      COP=S(1,1)+S(2,2)
      COM=S(1,1)-S(2,2)
      EPS2=ATAN(DBLE(2*S(1,2)/COM))
      COM=COM/COS(EPS2)
C Eigen phse shift alpha and gamma
      ALP=ATAN2(IMAG(COP+COM), DBLE(COP+COM))/2
      IF(ID.EQ.1 .AND. IMAG(S(1,1)) .LT. 0)ALP=ALP+PI
      GAM=ATAN2(IMAG(COP-COM), DBLE(COP-COM))/2
      EPS=EPS2/2
C         chi(alpha)= cos(eps)*chi(-)+sin(esp)*chi(+)
C         chi(gamma)=-sin(eps)*chi(-)+cos(eps)*chi(+)
C         normalized by sqrt(2/PI) 
C         factor 2 appears from 1/2i due to exp(x)--> sin(x)
      FJD=1/SQRT(2*PI)
      FJ=COS(EPS)*FJD
      FN=SIN(EPS)*FJD
      COM=DCMPLX(COS(ALP), -SIN(ALP))
      COP=DCMPLX(COS(GAM), -SIN(GAM))
      U1D=-IMAG(( FJ*A(1,1)+FN*A(1,2))*COM)
      U2D=-IMAG(( FJ*A(2,1)+FN*A(2,2))*COM)
      W1D=-IMAG((-FN*A(1,1)+FJ*A(1,2))*COP)
      W2D=-IMAG((-FN*A(2,1)+FJ*A(2,2))*COP)
C             Barred parameters
C           U1=delta(-), U2=delta(+), EPS2B=2*epsilon(barred)
      EPS2B=ATAN(IMAG(S(1,2)/SQRT(S(1,1)*S(2,2))))
      IF(ID .EQ. 1 .AND. IMAG(S(1,2)) .LT. 0.0D0) EPS2B=-EPS2B
      W1=SIN(EPS2B)
      U1=ATAN2(IMAG(S(1,1)), DBLE(S(1,1)))/2
      U2=ATAN2(IMAG(S(2,2)), DBLE(S(2,2)))/2
      IF(ID.EQ.1 .AND. IMAG(S(1,1)).LT.0.0) U1=U1+PI
      RETURN
      END
      BLOCK DATA
C           define Reid soft core potential
      IMPLICIT REAL*8(A-H, O-Z)
      COMMON /REID/ITSTAT(6),ISSTAT(6),LSTAT(6), JSTAT(6),
     +             NTERM(6), NPOW(32), IRPOT(32),VDEP(32),
C                        for 3S1-3D1 and 3P2-3F2 coupled states
     +             MTERM(6), MPOW(23), IURNG(23), UDEP(23),
     +             PNMU, VIFAC
      COMMON /CNST/AMU,DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
C       Basic parameters  VIFAC=1/((41.47 MeV*fm**2)*PNMU**2)
      DATA PNMU, VIFAC/0.7D0, 4.9211871D-2/
C           uncoupled case
C              (2*T+1),(2*1+1)L,J for uncoupled states
C              1,1P1: 1,3D2; 3,1S0; 3,0D2; 3,3P0; 3,3P1
C            isospins of p-n pair
      DATA ITSTAT /0, 0, 1, 1, 1, 1/
C            spins of p-n pair
      DATA ISSTAT /0, 1, 0, 0, 1, 1/
C            orbital ang. mom. of p-n pair
      DATA LSTAT  /1, 2, 0, 2, 1, 1/
C            total ang. mom. of p-n pair
      DATA JSTAT  /1, 2, 0, 2, 0, 1/
C            number of potential terms
      DATA NTERM  /3, 7, 3, 4, 8, 7/
C            powers of the potential
      DATA NPOW   /-1, -1, -1,
     +             -1, -2, -3, -2, -3, -1, -1,
     +             -1, -1, -1,
     +             -1, -1, -1, -1,
     +             -1, -2, -3, -2, -3, -1, -1, -1,
     +             -1, -2, -3, -2, -3, -1, -1/
C            potential depths
      DATA VDEP   / 31.389D0, -634.39D0, 2163.4D0,
     +  -31.389D0, -62.778D0, -62.778D0, 251.112D0,  62.778D0,
     +  -220.12D0,  871.0D0,
     +  -10.463D0, -1650.6D0,  6484.2D0,
     +  -10.463D0, -12.322D0, -1112.6D0, 6484.2D0,
     +  -10.463D0, -41.852D0, -41.852D0, 167.408D0,  41.852D0,
     +   27.133D0, -790.74D0, 20662.0D0,
     +   10.463D0,  20.926D0,  20.926D0, -83.704D0, -20.926D0,
     +  -135.25D0,  472.81D0/
C         ranges
      DATA IRPOT / -1, -2, -3,
     +             -1, -1, -1, -4, -4, -2, -3,
     +             -1, -4, -7,
     +             -1, -2, -4, -7,
     +             -1, -1, -1, -4, -4, -2, -4, -7,
     +             -1, -1, -1, -4, -4, -2, -3/
C **********************************************************************
C        here for coupled states
C       number of terms
C                  3S1-3D1   3P2-3F2
      DATA MTERM / 4, 7, 2,  3, 6, 1 /
C       power of X
C                  3S1-3D1 coupled state
      DATA MPOW /4*-1,   -1, -2, -3, -2, -3, 2*-1,   2*-1,
C                  3P2-3F2 coupled state
     +           3*-1,   -1, -2, -3, -2, -3,   -1,     -1/
C       ranges
      DATA IURNG/-1, -2, -4, -6,   3*-1, 2*-4, -4, -6,   -4, -6,
     +           -1, -4, -6,       3*-1, 2*-4, -3,       -6/
C       potential depths
      DATA UDEP/-10.463D0,  105.468D0, -3187.8D0, 9924.3D0,
     +          -10.463D0,2*-31.389D0, 125.556D0, 31.389D0,
     +                      351.77D0,  -1673.5D0,
     +           708.91D0,  -2713.1D0,
     +           3.4877D0, -933.48D0, 4152.1D0,
     +           3.4877D0, 2*10.463D0, -41.852D0, -10.463D0, -34.925D0,
     +           -2074.1D0/
C           fundamental parameters
C            Mp*c**2     habr*c      e**2/4*pi*epsilon0  Md*c**2
      DATA    AMU,        HBARC,          CFAC,        DMAS /
     +    938.27231D0, 197.327053D0, 1.4399652D0, 1.99900755D0/

C       p-n angular momentum reference
C            JD =  1  2  3  4  5  6  7  8  8 10 10
      DATA LLTAB / 1, 2, 0, 2, 1, 1, 2, 0, 2, 1, 3/
      DATA ISTAB / 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1/
      DATA JJTAB / 1, 2, 0, 2, 0, 1, 3, 1, 1, 2, 2/
      END
      SUBROUTINE PRNTPN(NRHOMX, DRHO, PNWF, WORK)
C        print p-n wave function information
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
      DIMENSION PNWF(0:NRHOMX, *), WORK(*)
      CHARACTER STR*7, PNQNUM(7)*3
      DATA PNQNUM /'1P1','3D2','1S0','1D2','3P0','3P1','3D3'/
C
      WRITE(6,11)
   11 FORMAT(/1H ,5X,'"deuteron" quantum numbers'/
     +        1H ,' ID  Energy   wave-num.   L   S   J  ',
     +           'delta(rad)  mixing ')
      DO 15 N=1, NWF
      WRITE(6,13)N, EPN(N), FKPN(N), LLPN(N), ISPN(N), JJPN(N),
     +              PPN(N), RPN(N)
   13 FORMAT(1H ,I3,2F9.4,2X,3I4,F9.4,2X,F9.4)
   15 CONTINUE
C         print p-n wave functions
      ISP=KNTL(6)
      IF(ISP .LE. 0) RETURN
      DO 20 M=ISP, NRHOMX, ISP
   20 WORK(M)=M*DRHO
      NPN=KNTL(1)
      NW0=1
      DO 40 NP=1, NPN
      ID =IDPN(NP)
      KPL=KOUPLE(NP)
      NKB=NKBIN(NP)
      IF(NP .GT. 1 .AND. NKB .LE. 0) GOTO 40
      IF(KPL .NE. 0) GOTO 25
C        here for uncoupled states
   21 INC=MIN(NKB, 6)
      NW1=NW0+INC-1
      STR(1:3)=PNQNUM(ID)
      WRITE(6,22)STR,LLPN(NW0), ISPN(NW0), JJPN(NW0), (EPN(M),M=NW0,NW1)
   22 FORMAT(/,1H ,3X,A3,5X,'(L S J)=(',2(I2,','),I2,')'/
     +         1H ,2X,'r(fm)', 6(2X,'E=',F7.3,1X:))
      DO 24 M=ISP, NRHOMX, ISP
      WRITE(6,23)WORK(M),(PNWF(M,NW),NW=NW0, NW1)
   23 FORMAT((0PF8.2,1P6E12.4))
   24 CONTINUE
      NW0=NW1+1
      IF(NKB .LE. INC) GOTO 40
      NKB=NKB-INC
      GOTO 21
C        here for coupled states
C           check deuteron ground state
   25 IF(EPN(NW0) .GT. 0.0) GOTO 28
C         here for ground state wave function
      WRITE(6,26)EPN(NW0)
   26 FORMAT(1H ,5X,'deuteron ground state E=',F8.4,'MeV'/
     +       1H ,1X,'r(fm)',5X,'u(r)',10X,'w(r)')
      NW1=NW0+1
      WRITE(6,27)(WORK(M),PNWF(M,NW0),PNWF(M,NW1),M=ISP, NRHOMX, ISP)
   27 FORMAT((1H ,0PF7.2,1P2E14.5))
      NW0=NW0+2
   28 CONTINUE
      IF(ID .EQ. 1) STR='3S1-3D1'
      IF(ID .EQ. 2) STR='3P2-3F2'
      DO 35 NK=1, NKB
      NW1=NW0+3
      WRITE(6,31)STR,EPN(NW0),(LLPN(NW),ISPN(NW),JJPN(NW), NW=NW0, NW1)
   31 FORMAT(/1H ,5X,A7,' state with E=',F7.3,'MeV',3X, '(L S J)'/
     +       1H ,2X,'r(fm)',4(3X,'(',3I3,')': ))
      WRITE(6,32)(WORK(M),(PNWF(M,NW),NW=NW0,NW1),M=ISP, NRHOMX,ISP)
   32 FORMAT((1H ,0PF7.2,1P4E14.5))
   35 NW0=NW1+1
   40 CONTINUE
C           overlap
      WRITE(6,41)
   41 FORMAT(1H ,'Overlap of basis wave functions <N2|N1>')
      DO 50 N1=1, NWF
      DO 45 N2=1, N1
      SUM=PNWF(0,N1)*PNWF(0,N2)
      IW=2
      DO 42 M=1,NRHOMX
      IW=6-IW
   42 SUM=SUM+IW*PNWF(M,N1)*PNWF(M,N2)
   45 WORK(N2)=SUM*DRHO/3
      M0=1
   46 M1=MIN0(M0+5,N1)
      WRITE(6,47)N1,(WORK(M),M=M0,M1)
   47 FORMAT(1H ,'N1=',I3,1P6E12.3)
      M0=M1+1
      IF(M0 .LE. N1)GOTO 46
   50 CONTINUE
      RETURN
      END
      SUBROUTINE DATIME
C      SUBROUTINE DATIME(IDATE)
      DIMENSION IDATE(6)
      DIMENSION MON(12), IDEF(6)
C         1970/01/1/09:00:00
      DATA IDEF/1970, 1, 1, 9, 0, 0/
      DATA MON/31,28,31,30,31,30,31,31,30,31,30,31/
C
      CALL CURTIM(IT)
      IDAY=24*60*60
C        remove some days in 1970
      IT=IT+IDAY*(IDEF(3)-1)+3600*IDEF(4)+60*IDEF(5)+IDEF(6)
C        positive II is assumed
C        count up years
      IY0=IDEF(1)
      IY1=2100
      DO 1 IY=IY0,IY1
      II=365
      IF(INT(IY/4)*4 .EQ. IY) II=366
      IF(INT(IY/100)*100 .EQ. IY .AND. INT(IY/400)*400 .NE. IY)II=365
      JJ=II*IDAY
      IF(IT-JJ .LT. 0) GOTO 2
    1 IT=IT-JJ
    2 IDATE(1)=IY
C         count up Months
      IF(II .EQ. 366) MON(2)=29
      DO 3 M=1,12
      JJ=MON(M)*IDAY
      IF(IT-JJ .LT. 0) GOTO 4
    3 IT=IT-JJ
    4 IDATE(2)=M
      MON(2)=28
C         count up Days, Hours, Minutes and Seconds
      JJ=IT/IDAY
      IT=IT-IDAY*JJ
      IDATE(3)=JJ+1
      JJ=IT/3600
      IDATE(4)=JJ
      IT=IT-3600*JJ
      JJ=IT/60
      IDATE(5)=JJ
      IDATE(6)=IT-JJ*60
      WRITE(6,10)IDATE
   10 FORMAT(1H ,50X,'date=',I4,'/',I2,'/',I2,'/',I2,':',I2,':',I2)
      RETURN
      END
      SUBROUTINE CDC14(NRMAX, DR, TMAS, NPN, NPOT,PTAB)
C         returns potential table
C Input NRMAX, DR: number and size of potential mesh
C       TMAS     : target mass
C       NPN      : number of p-n states
C       NPOT     : number of potentials. max. of 10
C       POTPRM(5,10): potential parameters
C Output PTAB(0:NRMAX, NPOT)
C      POTPRM(1,*)= potential type identifier
C                 =1 Woods-Saxon
C                 =2 Vol + surface Woods-Saxon
C                 =3 Thomas type
C                 =-LUN external input from a file.
C                       LUN is a logical unit number
C      POTPRM(2,*)= depths
C      POTPRM(3,*)= radius parameter. scaled by A**1/3
C      POTPRM(4,*)= diffuseness parameter
C      POTPRM(5,*)= mixing parameter. surface/((volume)+ (surface))
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
      DIMENSION PTAB(0:NRMAX, NPOT)
C       open potential table file if LUN<0
      LUN=0
      DO 1 N=1, NPOT
      IF(POTPRM(1,N) .LT. 0) LUN=-POTPRM(1,N)+0.1
    1 CONTINUE
      IF(LUN .GT. 0) OPEN(LUN, FILE='POTTAB.IN',STATUS='OLD')
      A3=TMAS**0.333333333D0
      DO 2 N=1, NPN
      DO 2 M=0, NRMAX
    2 PTAB(M,N)=0      
      DO 50 N=1, NPOT
      ID=POTPRM(1,N)+0.1
      VV=POTPRM(2,N)
      RR=POTPRM(3,N)*A3
      AA=POTPRM(4,N)
      SV=POTPRM(5,N)
      IF(ID .LT. 0) THEN
         LUN=-ID
         ID=4
      END IF
      GOTO (10, 20, 30, 40), ID
C         here for Woods-Saxon
   10 E0=EXP( DR/AA)
      E1=EXP(-RR/AA)
      DO 11 M=0, NRMAX
      PTAB(M,N)=VV/(1+E1)
   11 E1=E1*E0
      GOTO 50
C        here for vol + surface Woods-Saxon
   20 E0=EXP( DR/AA)
      E1=EXP(-RR/AA)
      VS=4*SV*VV
      VV=VV*(1-SV)
      DO 21 M=0, NRMAX
      E2=(1+E1)
      PTAB(M,N)=(VS*E1/E2+VV)/E2
   21 E1=E1*E0
      GOTO 50
C       here for Thomas type
   30 E0=EXP( DR/AA)
      E1=EXP(-RR/AA)
      VS=4*VV/AA
      DO 31 M=1, NRMAX
      R=DR*M
      E1=E1*E0
   31 PTAB(M,N)=VS*E1/(R*(1+E1)**2)
C          reset
      DO 32 M=0, 4
   32 PTAB(M,N)=M*PTAB(5,N)/5
      GOTO 50
C          here for external input
C          external data should be consistent with the DR and NRMAX orde
C          from R=0 TO NRMAX*DR
   40 CONTINUE
      READ(LUN, *)(PTAB(M,N),M=0, NRMAX)
      CLOSE(LUN)
      GOTO 50
   50 CONTINUE
C            print potential table
      ISPOT=0
      IF(ISPOT .LE. 0)GOTO 55
      WRITE(6,51)DR, NRMAX
   51 FORMAT(1H ,'(CDC14) potential table r=0 to ',f7.3,'*',I4)   
      DO 53 N=1, NPOT
      WRITE(6,52)N,(M,PTAB(M,N),M=0,NRMAX)
   52 FORMAT(1H ,'p.ID=',I2/(1H ,I5,F9.4))
   53 CONTINUE  
C         modify ISN: <0 for protons, >0 for neutrons
C    abs(ISN)=1 for central real, =2 for central imaginary
C            =3 for L*S real    , =4 for L*S imaginary( NOT supported !)     
   55 DO 56 N=1, NPOT
      M=2*ISLS(N)+ISI(N)+1
      IF(ISN(N) .LE. 0) M=-M
   56 ISN(N)=M
C        unify potential if same values of ISN(?) present
      NN=NPOT
      DO 66 N1=2, NPOT
   61 M1=ISN(N1)
      IF(M1 .EQ. 0) GOTO 66
      ISON=0
      DO 65 N2=1,N1-1
      IF(ISN(N2) .NE. M1) GOTO 65
      ISON=1
C        summing PTAB(M,N1) and PTAB(M,N2)
      DO 62 M=0,NRMAX
   62 PTAB(M,N2)=PTAB(M,N2)+PTAB(M,N1)
C          shift the rest
      N4=N1
      DO 64 N3=N1+1,NN
      DO 63 M=0,NRMAX
   63 PTAB(M,N4)=PTAB(M,N3)
      ISN(N4) =ISN(N3)
      ISI(N4) =ISI(N3)
      ISLS(N4)=ISLS(N3)
   64 N4=N4+1
      ISN(NN)=0
      NN=NN-1
   65 CONTINUE
      IF(ISON .GT. 0) GOTO 61
   66 CONTINUE      
      NPOT=NN
C      DO 153 N=1, NPOT
C      WRITE(6,52)N,(M,PTAB(M,N),M=0,NRMAX)
C  153 CONTINUE  
      RETURN
      END
      SUBROUTINE CDC16(PNWF, RC, NPOT, PTAB, WORK, NFFMAX,
     +                 FFTAB, LTRFF, IDFF, IPFF)
C            control routine of radial matrix elements
C Input W(1-?): potentail table (NRMAX+1)*NPOT, where NPOT=KNTL(2)
C       NWF         : number of independent wave functions
C       PNWF(0:NRHOMX, NWF): "deuteron" wave functions
C       DR, NRMAX   : size and range of potential table meshes
C       DRHO, NRHOMX: size and range of p-n wf. table (PNWF)
C             NRFFMX: size and range of form-factor table to be output
C       NFFMAX      : max. size of LTRFF, IDFF, IPFF
C       MAXFF       : upper limit of number of form factor
C Output FFTAB(0:NRFFMX, NFF): radail matrix elements
C        LTRFF(1:NFF)        : quantum numbers of matrix elements
C        IDFF (1:NFF)        : coupling pair( 1000*N2+N1)
C        NFF                 : number of form factors
C         define LTR, orbital angular momentum transfer and some
C         digit 1    = L1,  digit 10=L,  digit 100=L2
C         digit 10**3= 0 if central and 1 for L*S
C         digit 10**4= 0 for real   and 1 for imaginary pot.
C        IPFF(1:?)           : pointer of the 1st ff.
C                              for given pair of wave functions
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
      COMMON /FF1/ CPOT(0:150), RFFTAB(0:150), DRHO,  DR, DRFF, DRDW,
     +             TMAS, TZ, RMASS, EFACT, ETOT,
     +             NRHOMX, NRMAX, NRFFMX, NRDWMX, NFF,
     +             JTMIN, JTMAX, JTINC
      COMMON /CNST/AMU, DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
      DIMENSION PNWF(0:NRHOMX, *), FFTAB(0:NRFFMX, NFFMAX),
     +          LTRFF(NFFMAX), IDFF(NFFMAX), IPFF(NFFMAX), 
     +          PTAB(0:NRMAX, NPOT)
      DIMENSION PLEXP(10, 0:6), PL(0:6), CE(0:6), WORK(*)
      K3  =KNTL(3)
      K3  =K3-(K3/2)*2
      LMAX=6
      COU=TZ*CFAC
C           count the number of independent form factors
C           temporarily Lmin=IDFF and Lmax=LTRFF
C           IDFF and LTRFF are redefined later
      ID=0
      NFFX=0
      L12=0
      DO 10 N1=1, NWF
      L1=LLPN(N1)
      J1=JJPN(N1)
      DO 10 N2=1, N1
      L2=LLPN(N2)
      J2=JJPN(N2)
      LL1=MAX0(IABS(L1-L2), LAMMIN, IABS(J1-J2))
      LL2=MIN0(     L1+L2 , LAMMAX,      J1+J2 )
      IF((-1)**(L1+L2+LL1) .NE. 1)LL1=LL1+1
      IF(L12 .LT. LL2) L12=LL2
      ID=ID+1
      IDFF (ID)=LL1
      LTRFF(ID)=LL2
      IF(LL1 .LE. LL2) NFFX=NFFX+(LL2-LL1)/2+1
   10 CONTINUE  
      NFF=NFFX*NPTYPE
      WRITE(6,11)NPTYPE, NFFX, NFF, NFFMAX, L12
   11 FORMAT(1H ,'(CDC16) NPTYPE=',I2,2X,'NFFX=',I5,2X,'NFF=',I7,2X,
     +           'NFFMAX=',I6/1H ,    10X,'max. Lambda=',I2)
      IF(NFF .GT. NFFMAX) GOTO 91
      IF(L12 .GT. LMAX)  GOTO 93
C           clear FFTAB
      DO 12 ID=1, NFF
      DO 12 NRF=0, NRFFMX
   12 FFTAB(NRF, ID)=0
C           evaluate (2nd derivatives)/6 of potentials
      IDER=NRMAX+2
      CALL NSPL3(NPOT, NRMAX, PTAB, WORK(IDER), WORK)
C
C       R-loop  R=(center of mass coordinate of "deuteron")
C
      RPMAX=(NRMAX-1)*DR-1.0D-3
      TW=DRHO/3
      DO 20 NRF=0, NRFFMX
      RFF=RFFTAB(NRF)
      IWRHO=4
C        RHO loop:  RHO=(relative coordinate of Rn-->Rp ) ??
      DO 20 NH=1, NRHOMX
      RHO=NH*DRHO
C         Legendre expansion of potential
      CALL LEGDEX(ISN, NPOT, NRMAX, DR, RPMAX, PTAB, WORK(IDER),
     +            RFF,  RHO,   L12, PLEXP, PL)
C         add multipole component of Coulomb int. 
      IF(K3 .LE. 0) GOTO 14
      CALL COUEXP(RFF, RHO, RC, COU, L12, CE)
      DO 13 LL=0, L12
   13 PLEXP(1, LL)=PLEXP(1, LL)+CE(LL)
   14 CONTINUE
C        loop for coupling pair of the wave function
      ID=1
      JD=1
      T1W=IWRHO*TW
      DO 16 N1=1, NWF
      T1=PNWF(NH, N1)*T1W
      DO 16 N2=1, N1
      LL1=IDFF (ID)
      LL2=LTRFF(ID)
      ID=ID+1
      T12=T1*PNWF(NH, N2)
      DO 15 LL=LL1, LL2, 2
      DO 15 NP=1, NPTYPE
      FFTAB(NRF, JD)=FFTAB(NRF, JD)+T12*PLEXP(NP, LL)
   15 JD=JD+1
   16 CONTINUE
   20 IWRHO=6-IWRHO
C           define IDFF and LTRFF
C         IDFF(ID)=1000*N2+N1
C         define LTR, orbital angular momentum transfer and some
C         digit 1    = L1,  digit 10=L,  digit 100=L2
C         digit 10**3= 0 if central and 1 for L*S
C         digit 10**4= 0 for real   and 1 for imaginary pot.
      JD=1
      DO 30 N1=1, NWF
      L1=LLPN(N1)
      J1=JJPN(N1)
      DO 30 N2=1, N1
      L2=LLPN(N2)
      J2=JJPN(N2)
      LL1=MAX0( LAMMIN, IABS(L1-L2), IABS(J1-J2))
      LL2=MIN0( LAMMAX,      L1+L2 ,      J1+J2 )
      IF((-1)**(L1+L2+LL1) .NE. 1)LL1=LL1+1
      N12=1000*N2+N1
      DO 30 LL=LL1, LL2, 2
      DO 22 NP=1, NPTYPE
      IDFF(JD)=N12
      LTRFF(JD)=(((ISI(NP)*10+ISLS(NP))*10+L2)*10+LL)*10+L1
   22 JD=JD+1
   30 CONTINUE
C         define NFF= (number of independent FFTAB)
      NFF=JD-1
C         define pointer of 1st ff. for a given combination of
C         wave function ID's
      DO 35 N=NFF, 1, -1
      ID=IDFF(N)
      N2=ID/1000
      N1=ID-1000*N2
      N3=N2+N1*(N1-1)/2
   35 IPFF(N3)=N
C            terminater of IPFF
      N3=NWF*(NWF+1)/2+1
      IPFF(N3)=NFF+1
C ********  print IPFF table
      IF(KNTL(7) .LE. 0) GOTO 40
      WRITE(6,36)
   36 FORMAT(1H ,'(CDC16) IPFF print out '/
     +       1H ,2X,'N1',2X,'N2',2X,'N3',2X,'IPFF',2X,'LTRFF')
      DO 38 N1=1, NWF
      DO 38 N2=1, N1
      N3=N1*(N1-1)/2+N2
      N4=IPFF(N3)
      WRITE(6,37)N1,N2,N3,IPFF(N3),LTRFF(N4)
   37 FORMAT(1H ,3I4,I5,I7)
   38 CONTINUE
C          print form factors    
   40 IF(KNTL(8) .LE. 0) GOTO 50
      WRITE(6,41)NFF
   41 FORMAT(/,1H ,5X,'Number of form factor data=',I4//
     +         1H ,20X,'LTRFF data '/
     +         1H ,15X,'digit 5=1 for imag. pot'/
     +         1H ,15X,'digit 4=1 for L*S   pot'/
     +         1H ,15X,'digit 3 2 1 for L2, Lambda and L1 ')
      WRITE(6,42)(RFFTAB(M),M=0, NRFFMX)
   42 FORMAT(/1H ,'RFFTAB ='/(1H ,10F7.2))
      DO 45 N=1, NFF
      N2=IDFF(N)/1000
      N1=IDFF(N)-1000*N2
      WRITE(6,43)N,N2,N1,LTRFF(N),(FFTAB(M,N),M=0,NRFFMX)
   43 FORMAT(1H ,'ID=',I4,2X,I3,'<--',I3,2X,'LTRFF=',I6/(1H ,1P6E12.4))
   45 CONTINUE
C
   50 RETURN
C         error messages
   91 NFX=NFF*(NRFFMX+1)
      WRITE(6,92) NFX
   92 FORMAT(1H ,'(CDC16) FFTAB size of ',I8,' not allowed !')
      STOP
   93 WRITE(6,94)L12
   94 FORMAT(1H ,'(CDC16) max. Legendre order L12=',I2,
     +           ' NOT accepted !')
      STOP
      END
      SUBROUTINE COUEXP(R, RHO, RC, COU,  LMAX, CE)
C        multipole exp. of Coulomb potential of 
C        uniformly charged sphere
C Input R, RHO: radius parameter
C       RC    : charge radius
C       COU   : coupling const. of Coulomb int. ZZ*e**2/(4*pi*epsilon)
C       LMAX: range of multipolarity
C Output CE(*):
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CE(0:6), P(28), FI(0:6), FJ(0:6), FK(0:6)
C         16*( coeff. of Legendre function)
C             P(0) P(1)      P(2)        P(3)            P(4)
      DATA P /16, 0, 16,  -8, 0, 24, 0, -24, 0, 40,  6, 0, -60, 0, 70,
     +        0, 30, 0, -140, 0, 126,    -5, 0, 105, 0, -315, 0, 231  /
      DATA ISDEF /0/
C         initial definition
      IF(ISDEF.GT.0) GOTO 10
      DO 1 L=1,28
    1 P(L)=P(L)/16
      ISDEF=1
C
   10 RH=RHO/2
C         here for (R+RC) <= (rho)/2
      IF(R+RC.LE.RH) THEN
        A=COU/RH
        B=R/RH
        GOTO 11
      END IF
      IF(R.LT.RC .OR. RH.GT.R-RC) GOTO 13
C         here for (rho)/2 <= (R-RC)  and RC <= R 
      A=COU/R
      B=RH/R
   11 DO 12 L=0,LMAX
      CE(L)=A
   12 A=A*B
      RETURN
C
   13 A=R*R+RH*RH
      B=R*RHO
      RC2=RC*RC
      C=2*RC2*RC
      C0=(3*RC2-A)/C
      C1=B/C
      IF(R.GT.RC .OR. RH.GT.(RC-R))GOTO 15
C        here for (rho)/2 < 2(RC-R) and  R < RC
      CE(0)=C0*COU
      CE(1)=C1*COU
      DO 14 L=2,LMAX
   14 CE(L)=0
      RETURN
C        here for intermediate (rho)
   15 XC=(A-RC2)/B
      D=XC
      DO 16 L=0,LMAX
      FI(L)=C0*(1-D)/(L+1)
      D=D*XC
   16 FJ(L)=C1*(1-D)/(L+2)
      C=R+RH
      FK(0)=2*(C-RC)/B
      D=XC
      S=-1
      DO 17 L=1,LMAX
      FK(L)=(L*A*FK(L-1)-D*RC+S*C)/((L+0.5D0)*B)
      D=D*XC
   17 S=-S
C        sum up
      I=1
      DO 19 L=0,LMAX
      A=0
      DO 18 M=0,L
      A=A+P(I)*(FI(M)+FJ(M)+FK(M))
   18 I=I+1
   19 CE(L)=(L+0.5D0)*COU*A
      RETURN
      END
      SUBROUTINE LEGDEX(ISN, NPOT, NRMAX, DR, RPMAX, PTAB, DER,
     +                  RFF, RHO, LMAX, PLEXP, PL)
C       returns Legendre expansion of potential
C       for CTAK version 2 
C Input NPOT: number of potentials
C       NRMAX, DR: number and size of potentail meshes
C       RPMAX    : outer max. of potential radius
C       PTAB(0:NRMAX, NPOT), DER(0:NRMAX, NPOT):
C               potentail and (their 2nd der.)/6
C       RFF      : "deuteron" CM coordinate
C       RHO      : "deuteron" relative coordinate
C       LMAX: max. L to which  expansion should be made
C Output PLEXP(NPOT, 0:LMAX): Legendre expansion
C working area: PL(0:LMAX)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION ISN(NPOT), PTAB(0:NRMAX, NPOT), DER(0:NRMAX, NPOT),
     +          PLEXP(10, 0:6), PL(0:LMAX)
      DATA PI /3.14159265358979D0/
      DO 11 L=0, LMAX
      DO 11 NP=1, NPOT
   11 PLEXP(NP, L)=0
      HRHO=RHO/2
      RR=RFF**2+HRHO**2
      RH=RFF*RHO
C             define angle( integration) range
      RNMAX=    RFF+HRHO
      RNMIN=ABS(RFF-HRHO)
      IF(RNMIN .GT. RPMAX) RETURN
      TMAX=PI
      IF(RNMAX .GT. RPMAX) THEN
          TMAX=ACOS((RR-RPMAX**2)/RH)
          RNMAX=RPMAX
      END IF
C            define number of angles NANG, etc
      NANG=INT((RNMAX-RNMIN)/DR)*2 +40
      IF(NANG .GT. 180) NANG=180
      DT=TMAX/NANG
      SS=SIN(DT)
      CC=COS(DT)
      ST=0
      CT=1
C         angle loop
      IWA=4
      DO 15 N=1, NANG
C           ST=sin(theta) and CT=cos(theta)
      T1=ST*CC+CT*SS
      CT=CT*CC-ST*SS
      ST=T1
      RPOT=SQRT(RR-RH*CT)
      IF(RPOT .GT. RPMAX) GOTO 16
C           PL=(Legendre function)*sin(theta)*(2 or 4)
      PL(0)=ST*IWA
      PL(1)=CT*PL(0)
      DO 12 L=2, LMAX
   12 PL(L)=((2*L-1)*CT*PL(L-1)-(L-1)*PL(L-2))/L
C           interpolate potential table
      T1=RPOT/DR
      I0=T1
      I1=I0+1
      T1=T1-I0
      DO 14 NP=1, NPOT
      POT=(((DER (I1,NP)-DER (I0,NP))*T1+3*DER(I0,NP))*T1+
     +       PTAB(I1,NP)-PTAB(I0,NP)-DER(I1,NP)-2*DER(I0,NP))*T1+
     +       PTAB(I0,NP)
      DO 14 L=0, LMAX
   14 PLEXP(NP, L)=PLEXP(NP, L)+PL(L)*POT
   15 IWA=6-IWA
   16 CONTINUE
C            apply rest of the weight of the angle integration
      T1=DT/6
      DO 21 L =0, LMAX
      T2=(2*L+1)*T1
      DO 21 NP=1, NPOT
   21 PLEXP(NP, L)=T2*PLEXP(NP, L)
C       apply (-1)**L for neutrons
      DO 23 N=1, NPOT
      IF(ISN(N) .LT. 0) GOTO 23
      DO 22 L=1, LMAX,2
   22 PLEXP(N,L)=-PLEXP(N,L)
   23 CONTINUE
C        add neutron matrix elements to that of proton
      DO 26 N=NPOT, 1, -1
      NN=ISN(N)
      IF(NN .LE. 0) GOTO 26
      DO 25 M=1, N-1
      IF(ISN(M)+NN .NE. 0) GOTO 25
      DO 24 L=0, LMAX
   24 PLEXP(M,L)=PLEXP(M,L)+PLEXP(N,L)
   25 CONTINUE
   26 CONTINUE
      RETURN
      END
      SUBROUTINE NSPL3(NPOT, NRX, PTAB, DER, WORK)
C        returns (2nd derivative)/6 of potential table PTAB
C Input NPOT, NRX: number of potentials and array size
C       PTAB(0:NRX, NPOT): potential table
C Output DER(0:NRX, NPOT): (2nd drivative)/6 of pot. table
C working area WORK(0:NRX)
C       2002/04/15
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PTAB(0:NRX, NPOT), DER(0:NRX, NPOT), WORK(0:NRX)
C         weights
      WORK(0)=0.0D0
      DO 1 N=1,NRX
    1 WORK(N)=1/(4-WORK(N-1))
C
      DO 3 NP=1,NPOT
      Z1=(PTAB(2,NP)-2*PTAB(1,NP)+PTAB(0,NP))/6
      DER(0,NP)=Z1
      Z1=5*Z1
      DER(1,NP)=Z1
      DO 2 N=2,NRX-1
      Z1=PTAB(N+1,NP)-2*PTAB(N,NP)+PTAB(N-1,NP)-Z1*WORK(N-1)
    2 DER(N,NP)=Z1
C
      DER(NRX,NP)=(PTAB(NRX,NP)-2*PTAB(NRX-1,NP)+PTAB(NRX-2,NP))/6
      DO 3 N=NRX-1,1,-1
    3 DER(N,NP)=(DER(N,NP)-DER(N+1,NP))*WORK(N)
      RETURN
      END
      SUBROUTINE CDC20(NCCMAX, RC)
C         scattering state coupling table
C Input NCCMAX: max. number of coupled states
C       RC    : Coulomb charge radius
C       NCD   : size of CPOT
C       TMAS, TZ: target mass and atomic number
C       ETOT: total energy of the system
C Output NCC        : number of coupled states
C        IDPNWF(NCC): ID for p-n wave function
C        EDCM(NCC)  : kinetic energy of the CM
C        FKCM(NCC)  : wave number of CM motion
C        ETACM(NCC) : Coulomb parameter
C        CPOT(0* NCD): Coulomb potential + vacuum polarization 
C                      some modificaton by KNTL(3)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
      COMMON /FF1/ CPOT(0:150), RFFTAB(0:150), DRHO,  DR, DRFF, DRDW,
     +             TMAS, TZ, RMASS, EFACT, ETOT,
     +             NRHOMX, NRMAX, NRFFMX, NRDWMX, NFF,
     +             JTMIN, JTMAX, JTINC
C             NCCMAX is referenced
      COMMON /QCM/EDCM(324),  FKCM (324), ETACM(324),
     +            LCM (324), ISOPEN(324),IDPNWF(324), IDCC(324),
     +            LCC (324), IDCWF(324), ISOCC(10),   NCC, ISOMAX
      COMMON /VCC/F(0:1000), IVFMAX
      COMMON /CNST/AMU,DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
      DIMENSION JW(50)
      EQUIVALENCE (JW, F(501))
      NPN=KNTL(1)
      IDWF=1
      NCC=0
      ISOMAX=0
C           p-n state (S, L and I are specified )
      DO 20 N=1, NPN
      ID=IDPN(N)
      KPL=KOUPLE(N)
      ISB=ISBND(N)
      NKB=NKBIN(N)
      IF(KPL .NE. 0) ID=6+2*ID
      LS=LLTAB(ID)
      II=JJTAB(ID)
      ISAG=1
      IF(KPL .NE. 0) ISAG=2
      MKB=NKB+ISB
      JDW=0
C           k-bin loop
      DO 18 M=1, MKB
      ECM=ETOT-EPN(IDWF)
      FK=SQRT(2*RMASS*ECM*AMU)/HBARC
      ETA=CFAC*TZ*EFACT/(2*FK)
      ISAGX=ISAG
      IF(ISB .NE. 0 .AND. M .EQ. 1)ISAGX=1
C          alpha and gamma state loop
      DO 16 ISA=1, ISAGX
      JDW=JDW+1      
C          orbital ang. mom. of the CM motion
      DO 14 L=-II, II
      NCC=NCC+1
      EDCM (NCC)=ECM
      FKCM (NCC)=FK
      ETACM(NCC)=ETA
      IDPNWF(NCC)=IDWF
      LCM   (NCC)=L
      ISOPEN(NCC)=0
      IF(EPN(IDWF) .LT. 0)THEN
         ISOMAX=ISOMAX+1
         ISOPEN(NCC)=ISOMAX
      END IF
      IF(NCC .GE. NCCMAX) GOTO 90
   14 CONTINUE
      IDWF=IDWF+ISAG
   16 CONTINUE
   18 CONTINUE
   20 CONTINUE
C            Coulomb potentail
      IF(ABS(RC) .LT. 1.0E-5)GOTO 92
C      CPOT= 0 if KNTL(3) = 1 
C          = Coulomb pot. if KNTL(3) = 0
C            vacuum pol. correction added if KNTL(3) > 1
      DO 31 M=0, NRFFMX
   31 CPOT(M)=0
C        add Coulomb pot if KNTL(3) is an even integer
      K3=KNTL(3)
      K3=K3-(K3/2)*2
      IF(K3 .NE. 0) GOTO 33      
      VCOU=CFAC*TZ
      VCIN=VCOU/(2*RC)
      DO 32 M=0, NRFFMX
      RFF=RFFTAB(M)
      IF(RFF .LE. RC) THEN
        CPOT(M)=VCIN*(3-(RFF/RC)**2)
      ELSE
        CPOT(M)=VCOU/RFF
      END IF
   32 CONTINUE  
C        add vacuum polarization potential if KNTL(3) > 1
   33 IF(KNTL(3) .LE. 1) GOTO 35
      IW=50
      CALL VCUPOL(TZ, RC, NRFFMX, RFFTAB, CPOT, IW, F, JW)
C     prepare factorial table for geometric factors
   35 F(0)=1
      DO 36 N=1, IVFMAX
   36 F(N)=F(N-1)*N/256.0D0
C      WRITE(6,37)(RFFTAB(M), CPOT(M), M=0, NRFFMX)
 37   FORMAT(1H ,'(CDC20) CPOT TABLE '/(1H ,0PF7.2,1PE17.8))
C       print coupling table
      WRITE(6,51)NCC
   51 FORMAT(1H ,'(CDC20) NCC=',I4,2X,'coupled channels base'/
     +       1H ,'  ID  Ecm(MeV)',3X,'KCM(1/fm)',5X,'eta',4X,
     +           'LCM',4X,'L S J  K(p-n 1/fm)' )
      DO 55 N=1, NCC
      M=IDPNWF(N)
      FK=FKPN(M)
      LS=LLPN(M)
      JS=ISPN(M)
      II=JJPN(M)
      WRITE(6,52)N,EDCM(N),FKCM(N),ETACM(N),LCM(N),LS,JS,II,FK
   52 FORMAT(1H ,I4,3(1X,F10.6),I4,3X,3I2,2X,F10.6)
   55 CONTINUE
      IF(KNTL(9) .LE. 1) RETURN
C        heading of S-matrix file
      WRITE(7,61)NCC, JTMIN, JTMAX, JTINC, TMAS
   61 FORMAT(1H ,4I5,2X,1PE15.7,'/  NCC JTMIN JTMAX JTINC Tmas'/
     +       1H ,'  ID  Ecm(MeV)',3X,'KCM(1/fm)',5X,'eta',4X,
     +           'LCM',4X,'L S J  K(p-n 1/fm)' )
      DO 65 N=1, NCC
      M=IDPNWF(N)
      FK=FKPN(M)
      LS=LLPN(M)
      JS=ISPN(M)
      II=JJPN(M)
      WRITE(7,52)N,EDCM(N),FKCM(N),ETACM(N),LCM(N),LS,JS,II,FK
   65 CONTINUE
      RETURN
C          memory check
   90 WRITE(6,91)N, ISA, M, L, NCC, NCCMAX
   91 FORMAT(1H ,'(CDC20) N=',I2,2X,'ISA=',I2,2X,'M=',I2,2X,'L=',I2,
     +       /1H , 5X,'NCC=',I5,2X,'exceed limit of',I6)
      STOP
   92 WRITE(6,93)RC
   93 FORMAT(1H ,'(CDC20) RC=',1PE12.3,2X,' too small !')
      STOP  
      END
      SUBROUTINE VCUPOL(ZZ, RC, NR, RTAB, VCOU, IW, WW, JW)
C          vacuum pol. corr. of Coulomb potential of 
C          uniformly charged sphere
C          order is ZZ*(alpha)**2 vacuum pol. correction 
C     see L.W. Fullerton, and G.A. Rinker, Jr, in 
C         Phys. Rev. A13(1976) 1283.  eq. (4) 
C Input ZZ: charge product
C       RC: charge radius
C       RTAB(NR): radius where Coulomb pot. is evaluated
C Output VCOU(NR): Coulomb potential
C working area JW(IW), WW(IW): used in INTHP, 
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CPCAL/ RFAC, R
      DIMENSION RTAB(0:NR), VCOU(0:NR), WW(IW), JW(IW)
C      Compton wave length of an electron, PI
      DATA CEL, PI/386.1593233D0, 3.14159265358979D0/
C          Coulomb coupling, fine structure constant
      DATA CFAC, ALPHA/ 1.4399651D0, 7.29735308D-3/
C        charge density 
      CRHO=3*ZZ/(4*PI*RC**3)
C        start integration
      VFAC=2*ALPHA*CFAC*CEL*CRHO/3
      RFAC=2/CEL
C          main loop
      RP0=0
      EPS=1.0D-4
      NN=IW/2
      DO 4 L=0, NR
      R=RTAB(L)
      IF(ABS(R) .GT. 1.0E-4) GOTO 2
      CALL INTHP( RP0, RC, EPS, NN, JW, WW)
      VCOU(L)=VCOU(L)+4*VFAC*WW(1)/CEL
      GOTO 4
    2 CONTINUE   
C          here for R > RC
      IF(R .GT. RC) THEN
         CALL INTHP( RP0, RC, EPS, NN, JW, WW)
      ELSE 
C          here for 0< R < RC 
         CALL INTHP( RP0, R, EPS, NN, JW, WW)
         TEMP=WW(1)
         CALL INTHP( R  ,RC, EPS, NN, JW, WW)
         WW(1)=WW(1)+TEMP
      END IF
      VCOU(L)=VCOU(L)+VFAC*WW(1)/R
    4 CONTINUE   
C      WRITE(6,10)(RTAB(L),VCOU(L),L=1, NR)
   10 FORMAT(1H ,'Vacuum polarization potential '/
     +      (1H ,0PF7.2,1PE18.9))
      WRITE(6,11)
   11 FORMAT(1H ,'Vac. pol. potential added ')  
      RETURN
      END
      SUBROUTINE INTHP( A, B, EPS, NN, ID, Q)
C         integrate VCINT fomm A to B and returns to Q(1)
C         this is just  a control routine to manipulate heap range
C         real integration is made by using subroutine INTHP1
C Input A,B: define range of integration
C      EPS: convergence reference
C       NN: size of the work area of ID, IW, Q
C      ID(NN), Q(NN): work area
C Output Q(1): integrated result
      IMPLICIT REAL*8 (A-H, O-Z)
      DIMENSION ID(NN), Q(NN)
C         initialize
      ISCHK=1
      E2=2*EPS
      IW=1
      ID(1)=1
      CALL INTHP1( A, B, IW, ID(1), Q(1))
      ID(2)=2
      IP=2
      NCALL=1
      IPMAX=3
C         start heap control
   10 IF(IP .GT. NN-1) GOTO 91
      IW=IW*2
      CALL INTHP1( A, B, IW, ID(IP), Q(IP))
      ID(IP+1)=ID(IP)+1
      CALL INTHP1( A, B, IW, ID(IP+1), Q(IP+1))
      NCALL=NCALL+2
C
   15 SUM=Q(IP)+Q(IP+1)
      ERR=E2/IW
      IDX=ID(IP)
      JP=IP-1
      IF((IDX/4)*4 .EQ. IDX) JP=IP-2
      IF((ISCHK .EQ. 0) .OR. (ABS(Q(JP)-SUM) .LT. ERR)) GOTO 20
C         subdivide
      IP=IP+2
      ID(IP)=2*IDX
      IF(IP .GT. IPMAX) IPMAX=IP+1
      GOTO 10
C        converged
   20 Q(JP)=SUM
      IW=IW/2
C      IF(JP .EQ. 1) RETURN
      IF(JP .EQ. 1) GOTO 30
      ISCHK=1
      IF((JP/2)*2 .EQ. JP) GOTO 25
      IP=JP-1
      ISCHK=0
      GOTO 15
C       subdivide
   25 IP=JP+2
      ID(IP)=2*(ID(JP)+1)
      IF(IP .GT. IPMAX) IPMAX=IP+1
      GOTO 10
C   30 WRITE(6,31)NCALL, IPMAX, Q(1)
   31 FORMAT(1H ,'(INTHP) Ncall=',I5, 2X,'IPmax=',I3,2X,
     +           'Q(1)=',1pE12.3)
 30   RETURN  
C      error message
   91 WRITE(6,92)IP, NN
   92 FORMAT(1H ,'(INTHP) IP=',I3,' beyond upper max. of ',I3)
      STOP  
      END
      SUBROUTINE INTHP1(A, B, IW, ID, S)
C         integrate VCINT and save to S
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION W(3), X(3)
C       Gauss-Legendre 6 point integration abscissae and weights
      DATA X(1),W(1) /0.93246 95142 03152D0, 0.17132 44923 79170D0/ 
      DATA X(2),W(2) /0.66120 93864 66264D0, 0.36076 15730 48139D0/
      DATA X(3),W(3) /0.23861 91860 83196D0, 0.46791 39345 72691D0/
C        define integration range
      XHSPAN=(B-A)/(2*IW)
      IR=ID-IW
      XC=A+XHSPAN*(2*IR+1)
      S=0
      DO 1 I=1,3
      XDEL=XHSPAN*X(I)
    1 S=S+W(I)*(VCINT(XC+XDEL)+VCINT(XC-XDEL))
      S=S*XHSPAN
      RETURN
      END
      REAL*8 FUNCTION VCINT(RP)
C          returns RP*(K0(RFAC*abs(R-RP)) - K0(RFAC*(R+RP)))
      IMPLICIT REAL*8 (A-H, O-Z)
      COMMON /CPCAL/ RFAC, R
      DATA LOOP /0/
      SAVE LOOP, NY, DY, DEY, EYY
      IF(LOOP .GT. 0) GOTO 1
      DY=0.25D0
      NY=80
      DEY=EXP( DY)
      EYY=EXP(-DY*NY)
      LOOP=1
C
    1 XM=ABS(R-RP)*RFAC
      XP=   (R+RP)*RFAC
C          t-integration
      U=0
      EY=EYY
      IF(ABS(R) .LT. 1.0D-5)GOTO 4
      DO 2 N=-NY, NY
      T=EY+1
      T2I=1/T**2
      FT=SQRT(1-T2I)*(1+T2I/2)*T2I*(EXP(-XM*T)-EXP(-XP*T))*EY
      U=U+FT
      IF(N .GT. 0 .AND. FT .LT. 1.0D-12) GOTO 3
    2 EY=EY*DEY
    3 VCINT=U*DY*RP
      RETURN
C          t-integration
    4 DO 5 N=-NY, NY
      T=EY+1
      T2I=1/T**2
      FT=SQRT(1-T2I)*(1+T2I/2)*EXP(-XM*T)*EY/T
      U=U+FT
      IF(N .GT. 0 .AND. FT .LT. 1.0D-12) GOTO 6
    5 EY=EY*DEY
    6 VCINT=U*DY*RP
      RETURN  
      END
      SUBROUTINE CDC22(NCC, FKCM, ETACM, RM, LMAX,
     +                 IDCWF, NCWF, F, FP, G, GP)
C       returns Coulomb wave function table at matching point RM
C Input NCC: number of coupled channels
C       FKCM(NCC) : wave numbers of the channel
C       ETACM(NCC): Coulomb parameters
C       RMM, RMP  : matching radii
C       LMAX      : maximum orbital angular momentum
C Output IDCWF(NCC): pointers of Coulomb wave functions for the channel
C        NCWF      : number of independent Coulomb wave functions
C        F (0:LMAX, NCWF), G (0:LMAX, NCWF) Coulomb wave functions
C        FP(0:LMAX, NCWF), GP(0:LMAX, NCWF) and their derivatives
C  working area WX(*), WY(*)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FKCM(NCC), ETACM(NCC), IDCWF(NCWF), F(0:LMAX, *),
     +          FP(0:LMAX, *), G(0:LMAX, *), GP(0:LMAX, *)
      DIMENSION ETOLD(30), FKOLD(30)
      DATA NER /30/
      NCWMAX=MIN(NCWF, NER)
C         define "old" parameters
      DO 11 N=1, NCWMAX
      ETOLD(N)=-1.0D50
   11 FKOLD(N)=-1.0D50
      WRITE(6,12)
   12 FORMAT(1H ,7X,'Sub   Lmax1',4X,'Eta',7X,'Rho',7X,'W-1')  
C         check the necessary memory size
      IW=0
      DO 14 N=1, NCC
      ETA=ETACM(N)
      FK =FKCM (N)
      DO 13 I=1, IW
      IF(ABS(ETOLD(I)-ETA) .GT. 1.0E-5 .OR. 
     +   ABS(FKOLD(I)-FK ) .GT. 1.0E-5) GOTO 13
         JW=I
         GOTO 14
   13 CONTINUE
      IW=IW+1
      FKOLD(IW)=FK
      ETOLD(IW)=ETA
      JW=IW
   14 IDCWF(N)=JW
      IF(IW .GT. NCWMAX) GOTO 91
C         main loop
      IWM=IW
      DO 20 IW=1, IWM
      ETA=ETOLD(IW)
      FK =FKOLD(IW)
      RHO=FK*RM
      CALL CWF(LMAX, ETA, RHO, F(0,IW), G(0,IW), FP(0,IW), GP(0,IW))
C derivatives of Coulomb wave function at r=RM
C          derivatives with respect to r NOT with rho
      DO 16 L=0, LMAX
      FP(L,IW)=FP(L,IW)*FK
   16 GP(L,IW)=GP(L,IW)*FK
   20 CONTINUE
      RETURN
C       error message
   91 NW=(LMAX+1)*IW
      WRITE(6,92)NCWMAX, IW, LMAX, NW
   92 FORMAT(1H ,'(CDC22) NCWMAX=',I3,' while IW=',I3,' LMAX=',I3/
     +       'increase F..GP to',I4,' or check IDCWF')
      STOP
      END
      SUBROUTINE CWF(L, E, X, F, G, FP, GP)
C        Coulomb wave function and their derivative with X
C Input L: maximum orb. ang. mom.
C       E: eta, the Coulomb parameter
C       X: (wave number)*(radius)
C Output F (0:L), G (0:L): regular and irregular Coulomb wave functions
C        FP(0:L), GP(0:L): their derivatives
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION F(0:L), G(0:L), FP(0:L), GP(0:L)
C          statement functions
      R(K)=SQRT(1+EE/K**2)
      S(K)=K*XI+E/K
C           F(L+1)/F(L)
      CALL CF3(L, E, X, T, S1)
C          recurrence for F(LL)
      F1=1.0D-30*S1
      F2=F1*T
      EE=E*E
      XI=1/X
      LP=L+1
      R2=R(LP)
      S2=S(LP)
      F(L)=F1
      DO 1 LL=L,1,-1
      R1=R(LL)
      S1=S(LL)
      F0=((S1+S2)*F1-R2*F2)/R1
      F2=F1
      F1=F0
      F(LL-1)=F0
      G (LL)=R1
      GP(LL)=S1
      R2=R1
    1 S2=S1
      T=S2-R2*F2/F1
C          (G'+iF')/(G+iF)=P+iQ for L=0
      CALL CF2(E, X, P, Q)
C       here for X > 2*E: T='(0)/F(0)
      IF(X .GE.2*E) THEN
          F0=SQRT(Q/((T-P)**2+Q*Q))
          IF(F1.LT.0)F0=-F0
      ELSE
C       here for X < 2*E
          CALL COUPS(E, X, F0)
      END IF
      F2=F0/F1
      F (0)=F0
      FP(0)=F0*T
      G (0)=(1-Q*F0*F0)/(FP(0)-P*F0)
      GP(0)=P*G(0)-Q*F0
C          upward recurrence
      DO 2 LL=1,L
      R1=G (LL)
      S1=GP(LL)
      G (LL)=(S1*G(LL-1)-GP(LL-1))/R1
      GP(LL)= R1*G(LL-1)-G (LL  )*S1
      F (LL)= F2*F(LL)
    2 FP(LL)= R1*F(LL-1)-S1*F(LL)
      RETURN
      END
      SUBROUTINE CF2(E, X, P, Q)
C  reference A.R.Barnett, Comp. Phys. Comm 21(1981)297-314
C           (G'(0)+iF'(0))/(G(0)+iF(0))=P+iQ 
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 C0, C1, C2, C3, C4, C5, CW
      DATA CW, CONV/(0.0D0,1.0D0), 1.0E-15/
      C0=CW*E
      C1=C0+1
      C2=X-E+CW
      C3=1/(2*C2)
      C4=C0*C1*C3
      C5=C4
      DO 1 N=1,5000
      C0=C1
      C1=C1+1
      C2=C2+CW
      C3=1/(C3*C0*C1+2*C2)
      C4=(2*C2*C3-1)*C4
      C5=C5+C4
      IF((ABS(DREAL(C4))+ABS(DIMAG(C4)))/
     &   (ABS(DREAL(C5))+ABS(DIMAG(C5))).LT.CONV) GOTO 2
    1 CONTINUE
      GOTO 91
    2 P=-DIMAG(C5)/X
      Q= DREAL(C5)/X+1-E/X
      RETURN
   91 WRITE(6,92)E,X
   92 FORMAT('(CF2) No conv. for E and X=',2F10.5)
      STOP
      END
      SUBROUTINE COUPS(E, X, F0)
C   calculate Coulomb wave function by power series expansion
      IMPLICIT REAL*8 (A-H,O-Z)
C
      B1=2*E*3.14159265358979324D0
      IF(B1.GT.1490)GOTO 91
      IF(B1.LE.40.0) THEN
          B0=SQRT(B1/(EXP(B1)-1.0D0))
      ELSE
          B0=SQRT(B1)*EXP(-B1/2)
      END IF
      B0=X*B0
      B1=X*B0*E
      F0=B0+B1
      C2=2*E*X
      C4=X**2
      DO 1 L=2,5000
      B2=(C2*B1-C4*B0)/(L*(L+1))
      F0=F0+B2
      IF((ABS(B1)+ABS(B2))/ABS(F0) .LT. 1.0E-15) RETURN
      B0=B1
    1 B1=B2
      GOTO 93
   91 WRITE(6,92)E
   92 FORMAT('(COUPS) exp(2*pi* ETA) may pun! for Eta =',0PF9.4)
      STOP
   93 WRITE(6,94)E,X
   94 FORMAT('(COUPS) No conv ! Eta=',0PF8.3,2X,'Rho=',F8.3)
      STOP
      END
      SUBROUTINE CF3(L, E, X, F, S)
C continued fraction F(L+1)/F(L)=F
C Input E: Coulomb parameter
C       X: (wave number)*(radius)
C       L: orbital angular momentum
C Output F: F(L+1)/F(L) for regular wave function
C        S: sign of F(L)
      IMPLICIT REAL*8 (A-H,O-Z)
C          statement functions
      R(M)=1+E2/(M*M)
      T(M)=(2*M+1)*(XI+E/(M*(M+1)))
C
      E2=E*E
      XI=1/X
      S=1
      M=L+1
      D=1/T(M)
      H=R(M)*D
      F=H
      DO 1 N=2,5000
      M=M+1
      B=T(M)
      D=1/(B-D*R(M))
      H=(B*D-1)*H
      F=F+H
      IF(D.LT.0)S=-S
      IF(ABS(H/F).LT.1.0E-15)GOTO 2
    1 CONTINUE
      GOTO 91
    2 F=F/SQRT(R(L+1))
      RETURN
   91 WRITE(6,92)E,X,L
   92 FORMAT('(CF3) No conv. for Eta=',F9.4,2X,'Rho=',F9.4,2X,'L=',I4)
      STOP
      END
      SUBROUTINE CF1(L, E, X, F)
C  reference A.R.Barnett, Comp. Phys. Comm 21(1981)297-314
C Input L: Lmax
C       E: ETA
C       X: RHO
C Output F: F'(L)/F(L)
C        S: sign of F(L)
      IMPLICIT REAL*8 (A-H,O-Z)
      A(Q2 )=-X2*(Q2-1)*(Q2+E2)
      B(P,Q)=(P+Q)*(P*Q+EX)
      DATA CONV /1.0E-15/
C
      X2=X*X
      E2=E*E
      EX=E*X
      Q=L+1
      P=Q+1
      D=1/B(P,Q)
      Q=Q*Q
      G=A(Q)*D
      H=G
      S=1
      DO 1 N=1,5000
      Q=P
      P=P+1
      BN=B(P,Q)
      Q=Q*Q
      D=1/(D*A(Q)+BN)
      G=G*(BN*D-1)
      H=H+G
      IF(D.LT.0) S=-S
      IF(ABS(G/H).LT.CONV) GOTO 2
    1 CONTINUE
      GOTO 91
    2 P=L+1
      F=P/X+E/P+H/(L*P*X)
      IF(S.LT.0)F=-F
      RETURN
   91 WRITE(6,92)L,E,X,CONV
   92 FORMAT('(CF1) No conv. for L E X Conv=',i4,2F9.5,1PE12.3)
      STOP
      END
C**************************      
      SUBROUTINE NGCOU(LMAX, ETA, RHO, F, G, FP, GP)
C       Coulomb wave function of negative energy
C Input LMAX: max. of orbital angular momentum
C       ETA : Coulomb parameter
C       RHO : ( wave number ) * ( radius )
C Output G(L)=1
C        GP(L)={dG/d(RHO)} / G , 
C              ratio of Coulomb wave function and its derivative
C        F(L)=1, FP(L)=0
C                     1998. Sept. 7:  Y. Aoki
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION G(0:LMAX), GP(0:LMAX), F(0:LMAX), FP(0:LMAX)
C        define radius for asymptotic expansion      
      RX=1.175960E+01+ETA*(3.953508E+00+ETA*1.868445E-01)
      IF(RHO .GT. RX) RX=RHO
      G0=1.0D0
      G1=0.0D0
      R2=2*RX
      T1=ETA
      T2=ETA+1
      T3=-1/R2
      T4=1
      CONV=1.0D-10
      NMAX=20
      DO 10 N=1, NMAX
      T4=T4*T1*T2*T3
      G1=G1+T4
      T4=T4/N
      G0=G0+T4
      IF(ABS(T4) .LE. CONV) GOTO 11
      T1=T2
   10 T2=T2+1
C       u (L=0, rho=RX, ETA) = ?*G0,   ? is a prop. coeff.
C       u'(L=0, rho=RX, ETA) = ?*G1
   11 G1=-(1+ETA/RX)*G0-G1/RX
      IF(ABS(RHO-RX) .LT. 1.0E-6) GOTO 15
C        interpolate from RX to RHO
      DR=0.1D0
      T1=RX-RHO
      NMAX=INT(T1/DR)+1
      DR=-T1/NMAX
      T2=2*ETA
      DO 14 N=1, NMAX
      G(0)=G0
      G(1)=G1
      T3=RX+T2
      G(2)=T3*G0/RX
      DO 12 M=1,6
   12 G(M+2)=(M*(G(M-1)-G(M+1))+T3*G(M))/RX
C       power series expansion
      G0=G0+G1*DR
      T4=DR
      DO 13 M=2, 8
      G1=G1+G(M)*T4
      T4=T4*DR/M
   13 G0=G0+G(M)*T4
   14 RX=RX+DR
   15 G (0)=G0
      GP(0)=G1
      T2=ETA**2
      G(1)=((ETA+1/RHO)*G0-G1)*3/(1-T2)
C          check if ETA is an integer
      LL=LMAX
      IE=ETA+1.0D-6
      IF(ABS(IE-ETA) .LT. 1.0D-6) LL=IE-1
C       recurrence relation
      DO 20 L=1, LL-1
      G(L+1)=(L+1)*(2*L+1)*(2*L+3)*(L*(L+1)*(G(L-1)+G(L)/RHO)+ETA*G(L))
     +       /(L*((L+1)**2-T2))
   20 CONTINUE
      IF(LL .EQ. LMAX) GOTO 22
C       here for integer ETA
      G(IE  )=1
      G(IE+1)=(IE+1)*(2*IE+3)*(1+(ETA+1)/RHO)
      DO 21 L=IE+1, LMAX-1
      G(L+1)=(L+1)*(2*L+1)*(2*L+3)*(L*(L+1)*(G(L-1)+G(L)/RHO)+ETA*G(L))
     +       /(L*((L+1)**2-T2))
   21 CONTINUE
C          Derivatives
   22 DO 23 L=1, LMAX
   23 GP(L)=-(ETA/L+L/RHO)*G(L)-(2*L+1)*G(L-1)
C         ratio GP/G
      DO 24 L=0, LMAX
      F (L)=1
      FP(L)=0
      GP(L)=GP(L)/G(L)
   24 G (L)=1.0D0
      RETURN
      END
      SUBROUTINE CDC23(JTOT, JPAR, KCCMAX, KCC, MCC, NFSZMX, NRFFMX)
C       returns form factor table, which are coupled
C       for given Jtot and parity JPAR
C INPUT JTOT, JPAR: total J and parity if the system
C       NFF     : number of form factors
C       NCC     : number of coupled channels
C output consists of
C     KCC  : number of coupled states
C     MCC  : number of form factors
C     IDCC(KCC) : ID number of coupled states among ALL the coupled stat
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
C             NCCMAX is referenced
      COMMON /QCM/EDCM(324),  FKCM (324), ETACM(324),
     +            LCM (324), ISOPEN(324),IDPNWF(324), IDCC(324),
     +            LCC (324), IDCWF(324), ISOCC(10),   NCC, ISOMAX
C         count the number of coupled states
      KCC=0
      ISOK=0
      DO 10 N1=1, NCC
      L1=LCM(N1)+JTOT
      ID1 =IDPNWF(N1)
      I1  =JJPN(ID1)
      LLS1=LLPN(ID1)
      IF(L1 .LT. 0 .OR. IABS(L1-I1) .GT. JTOT .OR. L1+I1 .LT. JTOT 
     +             .OR. (-1)**(L1+LLS1)*JPAR .LE. 0) GOTO 10
      KCC=KCC+1
      IDCC(KCC)=N1
      LCC (KCC)=L1
      IF(ISOPEN(N1) .NE. 0) ISOK=1
   10 CONTINUE
      IF(ISOK .EQ. 0) KCC=0
      MCC=KCC*(KCC+1)
      NFX=MCC*(NRFFMX+1)
      IF(KCC .LE. 0) RETURN
      IF(KCC .GT. KCCMAX) GOTO 97
      IF(NFX .GT. NFSZMX) GOTO 91
      RETURN
C        error messages
   91 WRITE(6,92)JTOT, JPAR, NFX, NFSZMX
   92 FORMAT(1H ,'(CDC23) JTOT=',I3,' JPAR=',I2,2X,'FCC memory pun !!'/
     +       1H ,'NFX=',I8,' while NFSZMX=',I8)
      STOP
   97 WRITE(6,98)JTOT, JPAR, KCC, KCCMAX
   98 FORMAT(1H ,'(CDC23) at Jtot=',I3,' Jpar=',I2,2X,'KCC=',I3,
     +           ' max.=',I4)
      END
      SUBROUTINE CDC24(JTOT, JPAR, FFTAB, NRFFMX, NFF, LTRFF, IDFF, 
     +                 LSPOT, CPOT, IPFF, KCC, MC4, W, RFFTAB,
     +                 FCC, GTAB, NGTAB)
C       returns form factor table, which are coupled
C       for given Jtot and parity JPAR
C INPUT JTOT, JPAR: total J and parity if the system
C       IPFF(?) : pointer of the form factor table for (N2|pot.|N1)pair
C                 ? = N1*(N1-1)/2+N2
C       LSPOT   : =1 if spin-orbit potential present, =0 otherwise
C       CPOT(*) : Coulomb pot. table
C       NFF     : number of form factors
C       LTRFF(NFF): information of (LS1, Lambda, LS1) etc.
C       NCC     : number of coupled channels
C       RFFTAB(0: NRFFMX): define radial nodes
C output consists of
C     KCC       : number of coupled states
C     LCC(KCC)  : orbital angular momentum of the state
C     IDCC(KCC) : ID number of coupled states among ALL the coupled stat
C     FCC are coupling matrix
C     notice that FCC(j,i)=FCC(i,j)
C     Geometric factors are already multiplied
C     Energy and Coulomb pot. are added to the diagonal part
C working memory  GTAB(*), W(0:NRFFMX)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
C             NCCMAX is referenced
      COMMON /QCM/EDCM(324),  FKCM (324), ETACM(324),
     +            LCM (324), ISOPEN(324),IDPNWF(324), IDCC(324),
     +            LCC (324), IDCWF(324), ISOCC(10),   NCC, ISOMAX
      COMMON /CNST/AMU,DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
      DIMENSION FFTAB(0:NRFFMX, NFF), IPFF(*), LTRFF(*), IDFF(*)
      DIMENSION CPOT(0:NRFFMX), FCC(MC4,0:NRFFMX)
      DIMENSION GTAB(*), NGTAB(*), W(0: NRFFMX), 
     +          RFFTAB(0:NRFFMX)
C          clear memory
      DO 11 M =0, NRFFMX
      DO 11 MC=1, MC4, 2
   11 FCC(MC,M)=0
C         coupling matrix elements
   19 IQ1OLD=-1
      IQ2OLD=-1
      IR=1
      JC=1
      DO 26 K1=1, KCC
      N1  =IDCC(K1)
      L1  =LCC (K1)
      ID1 =IDPNWF(N1)
      I1  =JJPN(ID1)
      LLS1=LLPN(ID1)
      IQ1=10*LLS1+ID1
      KPL1=0
      IF(KPLPN(ID1) .NE. 0)KPL1=1
      DO 25 K2=1, K1
      N2  =IDCC(K2)
      L2  =LCC (K2)
      ID2 =IDPNWF(N2)
      I2  =JJPN(ID2)
      LLS2=LLPN(ID2)
      IQ2 =10*LLS2+I2
      KPL2=0
      IF(KPLPN(ID2) .NE. 0) KPL2=1
C            geometric factors
      IF(IQ1 .EQ. IQ1OLD .AND. IQ2 .EQ. IQ2OLD) GOTO 15
      IQ1OLD=IQ1
      IQ2OLD=IQ2
      CALL GTCAL(JTOT, JPAR, LSPOT, ID1, ID2,
     +           GTAB, NGTAB, L1MIN, L2SPAN, L2MIN)
C           pointer of geometric factors
   15 NGP=((L1-L1MIN)/2)*L2SPAN+(L2-L2MIN)/2+1
      NG=NGTAB(NGP)
C           pointer of matrix elements for (p-n 2 |Lambda | p-n 1)
      LS1=LLS1
      DO 24 N1=ID1, ID1+KPL1
      LS2=LLS2
      DO 23 N2=ID2, ID2+KPL2
C             pointer of the leading form factor
      M1=MAX0(N1, N2)
      M2=MIN0(N1, N2)
      IPR= M1*(M1-1)/2+M2
      IPF=IPFF (IPR)
C         range of Lambda imposed by p-n wave functions
      LASMIN=MAX0(IABS(LS1-LS2), IABS(I1-I2), LAMMIN)
      LASMAX=MIN0(     LS1+LS2 ,      I1+I2 , LAMMAX)
      IF((-1)**(LS1+LS2+LASMIN) .LE. 0)LASMIN=LASMIN+1
      LAMIN=MAX0(LASMIN, IABS(L1-L2))
      LAMAX=MIN0(LASMAX,      L1+L2 )
      DO 22 LAM=LASMIN, LASMAX, 2
C        range of Lambda imposed by "deuteron" CM motion
      IF( LAM . LT. LAMIN .OR. LAM .GT. LAMAX) THEN
          IPF=IPF+NPTYPE
          IPC=IPC+1
          GOTO 22
      END IF
C            potential type
      DO 21 IP=1, NPTYPE
      LTR=LTRFF(IPF)
      JDFF=IDFF(IPF)
C         define LTR, orbital angular momentum transfer and some
C            digit 1    = LS1,  digit 10=LAM,  digit 100=LS2
C  LSF       digit 10**3= 0 if central and 1 for L*S
C  IRF       digit 10**4= 0 for real   and 1 for imaginary pot. 
C         extract flags
      IRF=LTR/10000
      LSF=(LTR-IRF*10000)/1000
      L2F=(LTR-IRF*10000-LSF*1000)/100
      LAF=(LTR-IRF*10000-LSF*1000-L2F*100)/10
      L1F=(LTR-IRF*10000-LSF*1000-L2F*100-LAF*10)
C           swap L1F and L2F if (N1 .NE. M1)
      IF(N1 .NE. M1) THEN
          ITEMP=L1F
          L1F=L2F
          L2F=ITEMP
      END IF
      NF2=JDFF/1000
      NF1=JDFF-NF2*1000      
      IF(LS2 .NE. L2F .OR. LS1 .NE. L1F .OR. LAM .NE. LAF .OR.
     +   M1  .NE. NF1 .OR. M2  .NE. NF2) GOTO 93
C            GG= geometric factor 
      GG=GTAB(NG+LSF)
      JR=IR+IRF
C ********** Y. Aoki *******************
      JR=2*JR-1
C***************************************
      DO 16 M=0, NRFFMX
   16 FCC(JR, M)=FCC(JR, M)+GG*FFTAB(M, IPF)
   21 IPF=IPF+1
      NG=NG+(1+LSPOT)
   22 CONTINUE  
   23 LS2=LS2+2
   24 LS1=LS1+2
      JC=JC+1
   25 IR=IR+2
   26 CONTINUE
C  add Coulomb pot. and ECM to diagonal elements 
C           add ECM to diagonal elements
      K2=-1
      JC=1
      DO 32 K1=1, KCC
      NC1=IDCC(K1)
      ECM=EDCM(NC1)
      K2=K2+2*K1
C********** Y. Aoki ************
      K3=2*K2-1
C*******************************      
      DO 31 M=0, NRFFMX
C********* Y. Aoki ****************        
   31 FCC(K3,M)=FCC(K3,M)+CPOT(M)-ECM
   32 CONTINUE
C         (2nd derivative of potential)/6 = DCC(R, form-factor ID)
C         initial preparation
      H1=RFFTAB(1)-RFFTAB(0)
      H2=RFFTAB(2)-RFFTAB(1)
      W(1)=0.5D0/(H1+H2)
      DO 41 I=2, NRFFMX-1
      H1=H2
      H2= RFFTAB(I+1)-RFFTAB(I)
   41 W(I)=1/(2*(H1+H2)-H1**2*W(I-1))
C         forward substitution
      DO 43 MC=1, MC4, 2
      MD=MC+1
C        MC for DCC --> MD
      H1=RFFTAB(1)-RFFTAB(0)
      H2=RFFTAB(2)-RFFTAB(1)
      D2=   (FCC(MC,2)-FCC(MC,1))/H2
      D1=D2-(FCC(MC,1)-FCC(MC,0))/H1
      FCC(MD,0)=D1/(3*(RFFTAB(2)-RFFTAB(0)))
      FCC(MD,1)=D1-FCC(MD,0)*H1
      DO 42 I=2, NRFFMX-1
      H1=H2
      D1=D2
      H2= RFFTAB(I+1)-RFFTAB(I)
      D2=(FCC(MC,I+1)-FCC(MC,I))/H2
   42 FCC(MD,I)=D2-D1-H1*W(I-1)*FCC(MD,I-1)
   43 FCC(MD,NRFFMX)=(D2-D1)/(3*(RFFTAB(NRFFMX)-RFFTAB(NRFFMX-2)))  
C        backward substitution
      DO 44 I=NRFFMX-1, 1, -1
      H2=RFFTAB(I+1)-RFFTAB(I)
      DO 44 MC=2, MC4, 2
   44 FCC(MC,I)=W(I)*(FCC(MC,I)-H2*FCC(MC,I+1))
      RETURN
   93 WRITE(6,94)K1, ID1, LS1, K2, ID2, LS2, LAM, IPF,LTR,
     +           JDFF,M2,M1,KCC,(IDCC(M),M=1, KCC)
   94 FORMAT(1H ,'(CDC24) pointer error !!'/
     +       1H ,'K1 ID1 LS1 K2 ID2 LS2 LAM IPF LTR=',8I4,I6/
     +       1H ,'JDFF=',I6,' while M2=',I3,' ,M1=',I3,2X,',KCC=',I3/
     +       1H ,'IDCC=',20I3/(1H ,5X,20I3))
      STOP
      END
      SUBROUTINE GTCAL(JTOT, JPAR, LSPOT, ID1, ID2,
     +                 GTAB, NGTAB, L1MIN, L2SPAN, L2MIN)
C       returns table of geometric factors
C       for given Jtot and parity JPAR
C INPUT JTOT, JPAR: total J and parity of the system
C       LSPOT   : =1, use spin-orbit potential as well
C       ID1, ID2: specifies "deuteron" spin quantum numbers
C Output GTAB(NG) : geometric factor table
C        NGTAB:  pointer for the first element of (L1, L2)
C        L1MIN  : min. of L1
C        L2SPAN : (L2MAX-L2MIN)/2+1
C        L2MIN  : L2MIN
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
C                NRFMX is referenced
C             NCCMAX is referenced
      COMMON /QCM/EDCM(324),  FKCM (324), ETACM(324),
     +            LCM (324), ISOPEN(324),IDPNWF(324), IDCC(324),
     +            LCC (324), IDCWF(324), ISOCC(10),   NCC, ISOMAX
      COMMON /CNST/AMU,DMAS,HBARC,CFAC,PI,LLTAB(11),ISTAB(11),JJTAB(11)
      DIMENSION  GTAB(*), NGTAB(*)
C       reduced mat. elem. (L || L || L ).  arguments are doubled
      RMAT(L)=SQRT(L*(L+2)*(L+1.0D0))/2
C
      LA2MAX=2*LAMMAX
      LA2MIN=2*LAMMIN
      JD=2*JTOT
      NG=0
      L12=0
      KPL1= KPLPN(ID1)
      I1  =2*JJPN(ID1)
      IS1 =2*ISPN(ID1)
      LLS1=2*LLPN(ID1)
      ISKPL1=1+KPL1
      L1MIN=IABS(JD-I1)
      L1MAX=     JD+I1
      IF((-1)**((L1MIN+LLS1)/2) .NE. JPAR) L1MIN=L1MIN+2
      KPL2= KPLPN(ID2)
      I2  =2*JJPN(ID2)
      IS2 =2*ISPN(ID2)
      LLS2=2*LLPN(ID2)
      ISKPL2=1+KPL2
      L2MIN=IABS(JD-I2)
      L2MAX=     JD+I2
      IF((-1)**((L2MIN+LLS2)/2) .NE. JPAR)L2MIN=L2MIN+2
C          CM-motion of "deuteron" 
      DO 16 L1=L1MIN, L1MAX, 4
      DO 15 L2=L2MIN, L2MAX, 4
      L12=L12+1
      NGTAB(L12)=NG+1
C           S/D loop of |1>
      LS1=LLS1
      DO 14 ISD1=1, ISKPL1
C          S/D loop of <2|
      LS2=LLS2
      DO 13 ISD2=1, ISKPL2
      LSUM=(LS1+L1-LS2-L2)/4
      ISIGN=1
      IF((LSUM/2)*2 .NE. LSUM) ISIGN=-1
C        define range of Lambda
      LAMIN=MAX0(IABS(LS1-LS2), IABS(L1-L2), IABS(I1-I2), LA2MIN)
      LAMAX=MIN0(     LS1+LS2 ,      L1+L2 ,      I1+I2 , LA2MAX)
      IF(LAMIN .GT. LAMAX) GOTO 13
C        <(LS2 IS2) I2 L2;J \ Lambda \ (LS1 IS1) I1 L1; J>
      DO 12 LAM=LAMIN, LAMAX, 4
      GG=(I1+1)*(I2+1)*(L1+1)*(L2+1)*(LS1+1)*(LS2+1)
      GG=SQRT(GG)*ISIGN*CLEB0(LS2, LS1, LAM)
     +                 *CLEB0(L2, L1, LAM)/(LAM+1.0D0)
C           central pot. geometric factor
      NG=NG+1
      GTAB(NG)=(-1)**((JD+IS1+LAM)/2)*GG
     *               *RAC(LS2, LS1, I2, I1, LAM, IS1)
     *               *RAC(L2,   L1, I2, I1, LAM, JD )
      IF(LSPOT .LE. 0) GOTO 12
C          GFAC for spin-orbit pot.
      GLS1=0
      LLMIN=MAX0(IABS(I1-I2), IABS(L1-L2), IABS(LAM-2))
      LLMAX=MIN0(     I1+I2 ,      L1+L2 ,      LAM+2 )
      DO 10 LL=LLMIN, LLMAX, 2
      GLS1=GLS1+(LL+1)*RAC(I2,  L2,  I1, L1,  JD,  LL)
     *         *W9J(LS1, IS1, I1, LS2, IS2, I2, LAM, 2, LL)*
     * (                     RMAT(L2)*RAC(L2, 2, L1, LAM, L2, LL)+
     +  (-1)**((LAM+2+LL)/2)*RMAT(L1)*RAC(L1, 2, L2, LAM, L1, LL) )
   10 CONTINUE
      GLS1=SQRT(6.0D0)*GG*(-1)**((JD+I1+LS2)/2)*GLS1/4
      GLS2=((I1*(I1+2)-LS1*(LS1+2)+
     +       I2*(I2+2)-LS2*(LS2+2)-2*IS1*(IS1+2))*GTAB(NG))/32.0D0
      NG=NG+1
      GTAB(NG)=GLS1+GLS2
   11 CONTINUE
   12 CONTINUE
   13 LS2=LS2+4
   14 LS1=LS1+4
   15 CONTINUE
   16 CONTINUE
C              
      L1MIN=L1MIN/2
      L2SPAN=(L2MAX-L2MIN)/4+1
      L2MIN=L2MIN/2
      RETURN
      END
      REAL*8 FUNCTION CLEB0(L1, L2, L3)
C       returns <L1, 0, L2, 0; L3, 0>
C       all the arguments should be doubled
C       L3 is the least or at least very small
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /VCC/F(0:1000), IVFMAX
      CLEB0=0
      L11=L1/2
      L22=L2/2
      L33=L3/2
      LSUM=L11+L22+L33
      LHLF=LSUM/2
      IF(LSUM .GT. IVFMAX) GOTO 91
      IF(IABS(L1-L2) .GT. L3 .OR. L1+L2 .LT. L3 .OR.
     +   (LSUM/2)*2 .NE. LSUM) RETURN
      CLEB0=(-1)**(LHLF-L33)*SQRT((L3+1.0D0)/(LSUM+1))*
     *           (F(LHLF)   /F(LHLF-L33))/(F(LHLF-L11)*F(LHLF-L22))*
     *      SQRT((F(LSUM-L3)/F(LSUM))     *F(LSUM-L1) *F(LSUM-L2))
      RETURN
C
   91 WRITE(6,92)LSUM, IVFMAX
   92 FORMAT(1H ,'(CLEB0) LSUM=',I4,' while max. allowd =',I4)
      STOP
      END
      REAL*8 FUNCTION W9J(J1,J2,J12,J3,J4,J34,J13,J24,J)
C         Wigner's 9-J coefficient
C         all the arguments should be doubled on input
      IMPLICIT REAL*8 (A-H,O-Z)
      W9J=0
C   triangular check
      IF(IABS(J1 - J2).GT.J12.OR. J1 + J2.LT.J12 .OR.
     +   IABS(J3 - J4).GT.J34.OR. J3 + J4.LT.J34 .OR.
     +   IABS(J1 - J3).GT.J13.OR. J1 + J3.LT.J13 .OR.
     +   IABS(J2 - J4).GT.J24.OR. J2 + J4.LT.J24 .OR.
     +   IABS(J12-J34).GT.J  .OR. J12+J34.LT.J   .OR.
     +   IABS(J13-J24).GT.J  .OR. J13+J24.LT.J) RETURN
C       reordering ?
      K11=MAX(IABS(J1-J),  IABS(J2 -J34),IABS(J3 -J24))
      K12=MIN(     J1+J,        J2 +J34,      J3 +J24)
      K21=MAX(IABS(J1-J4), IABS(J13-J34),IABS(J12-J24))
      K22=MIN(     J1+J4,       J13+J34,      J12+J24)
      K31=MAX(IABS(J2-J13),IABS(J3 -J12),IABS(J4 -J))
      K32=MIN(     J2+J13,      J3 +J12,      J4 +J)
C         looks for the min. (K1, K2, K3)
      K=MIN(K12-K11,K22-K21,K32-K31)
      IF(K.EQ.K32-K31)GOTO 14
      IF(K.EQ.K22-K21)GOTO 12
      DO 11 K=K11,K12,2
      W9J=W9J+(K+1)*RAC(J1, J3, J,J24, J13,K  )
     &             *RAC(J2, J4, K, J3, J24,J34)
     &             *RAC(J12,J34,J1, K, J,  J2 )
   11 CONTINUE
      RETURN
C
   12 DO 13 K=K21,K22,2
      W9J=W9J+(K+1)*RAC(J12,J34,J24,J13,J,  K)*
     &              RAC(J1, J3, K,  J34,J13,J4)*
     &              RAC(J2, J4, J12,K,  J24,J1)
   13 CONTINUE
      W9J=(-1)**((J1+J2+J3+J4-J13-J24)/2)*W9J
      RETURN
C
   14 DO 15 K=K31,K32,2
      W9J=W9J+(K+1)*RAC(J2, J4, J13,J, J24,K)*
     &              RAC(J12,J34,K,  J4,J,  J3)*
     &              RAC(J1, J3, J2, K, J13,J12)
   15 CONTINUE
      W9J=(-1)**((J1+J3-J13+J12+J34-J)/2)*W9J
      RETURN
      END
C***************************      
      REAL*8 FUNCTION RAC(JA, JB, JC, JD, JE, JF)
C        returns Racah coeff. W(JA, JB, JC, JD; JE, JF)
C        all the arguments should be doubled
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /VCC/ F(0:1000), IVFMAX
      RAC=0
C         triangle check
      IF(IABS(JA-JB) .GT. JE .OR. JA+JB .LT. JE .OR.
     +   IABS(JE-JD) .GT. JC .OR. JE+JD .LT. JC .OR.
     +   IABS(JB-JD) .GT. JF .OR. JB+JD .LT. JF .OR.
     +   IABS(JA-JF) .GT. JC .OR. JA+JF .LT. JC     )RETURN
      I1=(JA+JB+JE)/2
      I2=(JE+JD+JC)/2
      I3=(JB+JD+JF)/2
      I4=(JA+JF+JC)/2
      J1=(JA+JB+JC+JD)/2
      J2=(JA+JD+JE+JF)/2
      J3=(JB+JC+JE+JF)/2
      KMIN=MAX0(I1,I2,I3,I4)
      KMAX=MIN0(J1,J2,J3)
      IF(KMIN .GT. KMAX) RETURN
      IF(KMAX+1 .GT. IVFMAX) GOTO 91
      SIGN=(-1)**(J1+KMIN)
      DO 1 K=KMIN, KMAX
      RAC=RAC+SIGN*F(K+1)/(F(K-I1)*F(K-I2)*F(K-I3)*F(K-I4)*
     *                     F(J1-K)*F(J2-K)*F(J3-K))
    1 SIGN=-SIGN
      RAC=RAC*SQRT((F(I1-JA)*F(I1-JB)*F(I1-JE)/F(I1+1)))*
     *        SQRT((F(I2-JE)*F(I2-JD)*F(I2-JC)/F(I2+1)))*
     *        SQRT((F(I3-JB)*F(I3-JD)*F(I3-JF)/F(I3+1)))*
     *        SQRT((F(I4-JA)*F(I4-JF)*F(I4-JC)/F(I4+1)))/256
      RETURN
C
   91 WRITE(6,92)KMAX, IVFMAX
   92 FORMAT(1H ,'(RAC) KMAX=',I4,'while max. allowd =',I4)
      STOP
      END
      SUBROUTINE CDC26(KCC, H, NRMAX, LCC, MC4, FCC, NRFFMX, 
     +                 RFFTAB, EFACT, ER, EI, UR, UI, VUR, VUI, JTOT,
     +                 FK0, NS0,K10, NWM)
C               modified version of CDC26.  1998 May 16
C         integrate coupled radial Schraedinger equation
C         returns independent wave functions at r=H*(NRMAX-2) and
C         their derivatives with respect to r
C Input KCC: number of coupled states
C       H, NRMAX: step size and number of steps of integration
C       LCC(KCC): orbital ang. mom. of the channel
C       MC4     : number of matrix elements, (real + imag.)*2
C       FCC     : form factor and 2nd deriv. tables
C       NRFFMX, RFFTAB: table size and node table of form factors
C       EFACT   : hbar**2/2*(reduced mass) 
C       JTOT    : total J of the system       
C       FK0     : wave number of the ground state channel
C       K10     :print indep. sol. for ground state
C       NWM     : number of real solutions
C Output NS0    : starting point of integration
C  *************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FCC(MC4,0:NRFFMX), LCC(KCC)
      DIMENSION ER(KCC), EI(KCC), RFFTAB(0:NRFFMX),
     +          VUR(KCC,KCC,8), VUI(KCC,KCC,8),
     +           UR(KCC,KCC,5),  UI(KCC,KCC,5),
     +           DER(7), JV(8)
      EQUIVALENCE (JV(1),IV1),(JV(2),IV2),(JV(3),IV3),(JV(4),IV4),
     &            (JV(5),IV5),(JV(6),IV6),(JV(7),IV7),(JV(8),IV8)
C       statement function
      CAB(FR, FI)=ABS(FR)+ABS(FI)
      DATA DER /-1, 9, -45, 0, 45, -9, 1/
C         clear the working memory
      DO  3 I=1, KCC
      DO  3 J=1, KCC
      DO  1 K=1, 5
       UR(J,I,K)=0
    1  UI(J,I,K)=0
      DO 2  K=1, 8
      VUR(J,I,K)=0
    2 VUI(J,I,K)=0
    3 CONTINUE
C      define starting radius
      XS=JTOT*((9.8061580D-1*JTOT+1.8781468D+2)*JTOT-1.1764028D+3)/
     +        ((1.0D0       *JTOT+2.4188253D+2)*JTOT+4.1452663D+3)
      IF(JTOT .LE. 20 .OR. XS .LE. 0) XS=0      
      NS0=XS/(H*FK0)
      NS0=NS0+1
      IF(NS0 .GT. NRMAX-8) RETURN
C          define starting value  
      EPS=1.0E-10
      RR=2*EPS
      DO 10 I=1, KCC
      IF(LCC(I) .EQ. 1) VUR(I,I,1)=RR
   10 UR(I,I,4)=EPS
C         integrate r=(NS0+1)*H to (NS0+6)*H
      EHH=EFACT*H*H
      FAC=1
      IU4=4
      DO 29 N=1, 6
      M0=NS0+N-1
      R=M0*H
      RR=M0*M0*FAC
      VFAC=EHH/FAC
      IF(K10.GT.0)WRITE(1)M0
      IF(K10.GT.0)WRITE(1)((UR(I,K,IU4),UI(I,K,IU4),K=1,KCC),I=1,NWM)
      CALL VUCAL(KCC, LCC, R, RR, UR(1,1,IU4), UI(1,1,IU4), VFAC, 
     +           NRFFMX, RFFTAB, MC4, FCC,
     +           VUR(1,1,N+1), VUI(1,1,N+1), ER, EI)
      GOTO (11, 14, 16, 19, 21, 24),N
C       evaluate u at r=(NS+1)*H
   11 FAC=12
      IU4=5
      DO 12 I= 1, KCC
      DO 12 J= 1, KCC
       UR(J,I,5)=2*UR(J,I,4)+VUR(J,I,2)
       UI(J,I,5)=2*UI(J,I,4)+VUI(J,I,2)
      VUR(J,I,1)=            VUR(J,I,1)/12
      VUR(J,I,2)=            VUR(J,I,2)/12
   12 VUI(J,I,2)=            VUI(J,I,2)/12
C           improve the 1st approximation
      M0=M0+1
      R =M0*H
      RR=M0**2*12
      VFAC=EHH/12
      CALL VUCAL(KCC, LCC, R, RR, UR(1,1,5), UI(1,1,5), VFAC,
     +           NRFFMX, RFFTAB, MC4, FCC,
     +           VUR(1,1,3), VUI(1,1,3), ER, EI)
      DO 13 I= 1, KCC
      DO 13 J= 1, KCC
      UR(J,I,5)=2*UR(J,I,4)+VUR(J,I,3)+10*VUR(J,I,2)+VUR(J,I,1)
   13 UI(J,I,5)=2*UI(J,I,4)+VUI(J,I,3)+10*VUI(J,I,2)+VUI(J,I,1)
      GOTO 26
C      evaluate U at r=(NS+2)*H
   14 IU4=3
      DO 15 I= 1, KCC
      DO 15 J= 1, KCC
      UR(J,I,3)=2*UR(J,I,5)-   UR(J,I,4)
     +       +13*VUR(J,I,3)-2*VUR(J,I,2)+VUR(J,I,1)
      UI(J,I,3)=2*UI(J,I,5)-   UI(J,I,4)
     +       +13*VUI(J,I,3)-2*VUI(J,I,2)+VUI(J,I,1)
   15 CONTINUE 
C      IF(KCC .GT. -10) GOTO 26
C           improve the 1st approximation
      M0=M0+1
      R =M0*H
      RR=M0**2*12
      VFAC=EHH/12
      CALL VUCAL(KCC, LCC, R, RR, UR(1,1,3), UI(1,1,3), VFAC,
     +           NRFFMX, RFFTAB, MC4, FCC,
     +           VUR(1,1,4), VUI(1,1,4), ER, EI)
      DO 113 I= 1, KCC
      DO 113 J= 1, KCC
      UR(J,I,3)=2*UR(J,I,5)-UR(J,I,4)
     +          +VUR(J,I,4)+10*VUR(J,I,3)+VUR(J,I,2)
      UI(J,I,3)=2*UI(J,I,5)-UI(J,I,4)
     +          +VUI(J,I,4)+10*VUI(J,I,3)+VUI(J,I,2)
  113 CONTINUE
      GOTO 26
C       evaluate u at r=(NS+3)*H
   16 FAC=240
      IU4=4
      DO 17 I= 1, KCC
      DO 17 J= 1, KCC
      UR(J,I,4)= 2* UR(J,I,3)-   UR(J,I,5)
     +         +14*VUR(J,I,4)-5*VUR(J,I,3)+4*VUR(J,I,2)-VUR(J,I,1)
      UI(J,I,4)= 2 *UI(J,I,3)-   UI(J,I,5)
     +         +14*VUI(J,I,4)-5*VUI(J,I,3)+4*VUI(J,I,2)-VUI(J,I,1)
   17 CONTINUE  
      DO 18 K=1,4
      DO 18 I=1,KCC
      DO 18 J=1,KCC
      VUR(J,I,K)=VUR(J,I,K)/20
      VUI(J,I,K)=VUI(J,I,K)/20
   18 CONTINUE
      GOTO 26
C         evaluate u at r=(NS+4)*H
   19 IU4=5
      DO 20 I= 1, KCC
      DO 20 J= 1, KCC
      UR(J,I,5)=2*UR(J,I,4)-UR(J,I,3)+299*VUR(J,I,5)-176*VUR(J,I,4)+
     +                 194*VUR(J,I,3)- 96*VUR(J,I,2)+ 19*VUR(J,I,1)
      UI(J,I,5)=2*UI(J,I,4)-UI(J,I,3)+299*VUI(J,I,5)-176*VUI(J,I,4)+
     +                 194*VUI(J,I,3)- 96*VUI(J,I,2)+ 19*VUI(J,I,1)
   20 CONTINUE
      GOTO 26
C             evaluate u at r=(NS+5)*H
   21 FAC=60480
      IU4=3
      DO 22 I= 1, KCC
      DO 22 J= 1, KCC
      UR(J,I,3)=2*UR(J,I,5)-UR(J,I,4)+317*VUR(J,I,6)-266*VUR(J,I,5)+
     +                 374*VUR(J,I,4)-276*VUR(J,I,3)+109*VUR(J,I,2)
     +                 -18*VUR(J,I,1)
      UI(J,I,3)=2*UI(J,I,5)-UI(J,I,4)+317*VUI(J,I,6)-266*VUI(J,I,5)+
     +                 374*VUI(J,I,4)-276*VUI(J,I,3)+109*VUI(J,I,2)
     +                 -18*VUI(J,I,1)
   22 CONTINUE  
      DO 23 K=1, 6
      DO 23 I=1,KCC
      DO 23 J=1,KCC
      VUR(J,I,K)=VUR(J,I,K)/252
   23 VUI(J,I,K)=VUI(J,I,K)/252
      GOTO 26
C           evaluate u at r=(NS+6)*H
   24 IU4=4
      DO 25 I= 1, KCC 
      DO 25 J= 1, KCC
      UR(J,I,4)=    2* UR(J,I,3)-       UR(J,I,5)
     +         +84199*VUR(J,I,7)-92922*VUR(J,I,6)+158973*VUR(J,I,5)
     +        -155852*VUR(J,I,4)+92193*VUR(J,I,3)- 30426*VUR(J,I,2)
     +          +4315*VUR(J,I,1)
      UI(J,I,4)=    2* UI(J,I,3)-       UI(J,I,5)
     +         +84199*VUI(J,I,7)-92922*VUI(J,I,6)+158973*VUI(J,I,5)
     +        -155852*VUI(J,I,4)+92193*VUI(J,I,3)- 30426*VUI(J,I,2)
     +          +4315*VUI(J,I,1)
   25 CONTINUE
      GOTO 26
   26 CONTINUE
   29 CONTINUE
C         Now integrate from r=(NS+7)*H to (NRMAX+1)*H
      DO 30 I=1,8
   30 JV(I)=I
      IU3=3
      IU4=4
      IU5=5
      DERFAC=1/(60*H)
      M0=M0+1
      M6=NRMAX-6
      MM=0
      COMP=1
      LOOP=0
      DO 45 M=M0, NRMAX
      R=M*H
      RR=M*M*FAC
      IF(K10.GT.0)WRITE(1)M
      IF(K10.GT.0)WRITE(1)((UR(I,J,IU4),UI(I,J,IU4),J=1,KCC),I=1,NWM)
      CALL VUCAL(KCC, LCC, R, RR, UR(1,1,IU4), UI(1,1,IU4), VFAC, 
     +           NRFFMX, RFFTAB, MC4, FCC,
     +           VUR(1,1,IV8), VUI(1,1,IV8), ER, EI)
C        evaluate UR(IU5), UI(IU5), at r=(M+1)*H
      DO 33 I= 1, KCC
      DO 33 J= 1, KCC
      UR(J,I,IU5)= 2*UR(J,I,IU4)-        UR(J,I,IU3)
     +       +88324*VUR(J,I,IV8)-121797*VUR(J,I,IV7)
     +      +245598*VUR(J,I,IV6)-300227*VUR(J,I,IV5)
     +      +236568*VUR(J,I,IV4)-117051*VUR(J,I,IV3)
     +      + 33190*VUR(J,I,IV2)-  4125*VUR(J,I,IV1)
      UI(J,I,IU5)= 2*UI(J,I,IU4)-        UI(J,I,IU3)
     +       +88324*VUI(J,I,IV8)-121797*VUI(J,I,IV7)
     +      +245598*VUI(J,I,IV6)-300227*VUI(J,I,IV5)
     +      +236568*VUI(J,I,IV4)-117051*VUI(J,I,IV3)
     +      + 33190*VUI(J,I,IV2)-  4125*VUI(J,I,IV1)
   33 CONTINUE
C        save wave function and evaluate derivatives
      IF(M .LT. M6) GOTO 36
      MM=MM+1
      IF(MM .EQ. 4) THEN
        DO 34 I= 1, KCC 
        DO 34 J= 1, KCC
        UR(J,I,1)=UR(J,I,IU5)
   34   UI(J,I,1)=UI(J,I,IU5)
      ELSE
        DFAC=DER(MM)*DERFAC
        DO 35 I=1, KCC
        DO 35 J=1, KCC
        UR(J,I,2)=UR(J,I,2)+UR(J,I,IU5)*DFAC
   35   UI(J,I,2)=UI(J,I,2)+UI(J,I,IU5)*DFAC
      END IF
   36 CONTINUE
C         check the precursor of very large condition number
      IF(MM .GE. 1) GOTO 39
      LOOP=LOOP+1
      IF(LOOP .LT. 50) GO TO 39
      DO 38 I=1, KCC
      REF=CAB(UR(I,I,IU5), UI(I,I,IU5))
      DO 37 J= 1, KCC
      IF(J .EQ. I) GOTO 37
      IF(CAB(UR(J,I,IU5), UI(J,I,IU5))/REF .LT. COMP) GOTO 37
      CALL GSORTH(KCC, IU5, K10, M, UR, UI, VUR, VUI, UR, UI)
      LOOP=0
      GOTO 39
   37 CONTINUE
   38 CONTINUE
C         reset pointers
   39 I  =IU3
      IU3=IU4
      IU4=IU5  
      IU5=I
      I=IV1
      DO 40 J=1,7
   40 JV(J)=JV(J+1)
      IV8=I
   45 CONTINUE
      IF(K10.GT.0)WRITE(1)M
      IF(K10.GT.0)WRITE(1)((UR(I,J,IU4),UI(I,J,IU4),J=1,KCC),I=1,NWM)
      RETURN
      END
      SUBROUTINE VUCAL(KCC, LCC, R, RR, UR, UI, VFAC, NRFFMX, 
     +                 RFFTAB, MC4, FCC, VUR, VUI, VR, VI)
C           returns product, VFAC*(wave function)*(potential)
C Input KCC: number of coupled channels
C       LCC: orbital angular momenta 
C        R : current value of radius
C        RR: denominater or centrifugal potential
C       UR, UI: wave functions
C    VFAC  : scaling parameter of potentials
C   RFFTAB : r-table of form factors
C    FCC   : form factor tables
C    FCC   : (2nd deriv.)/6 of form factors
C Output VUR, VUI: products
C working area VR, VI
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION LCC(KCC), RFFTAB(0: NRFFMX), UR(KCC,KCC), UI(KCC,KCC),
     +          FCC(MC4,0:NRFFMX), 
     +          VUR(KCC,KCC), VUI(KCC,KCC), VR(KCC), VI(KCC)
      DATA ISOLD, ROLD /0,0.0/
      IS=0
      IF(R .GT. ROLD)IS=ISOLD
C          looks for the RFF span
      DO 11 II=IS, NRFFMX-1
      IF((R-RFFTAB(II))*(R-RFFTAB(II+1)) .GT. 1.0E-5) GOTO 11
      IS=II
      RFF=RFFTAB(II)
      DRF=RFFTAB(II+1)-RFF
      S  =(R-RFF)/DRF
      GOTO 12
   11 CONTINUE
      GOTO 91
   12 T=1-S
      IT=IS+1
      SS=(S*S-1)*DRF**2
      TT=(T*T-1)*DRF**2
      S = S*VFAC
      T = T*VFAC
C       for J-th row
      DO 16 J=1, KCC
C       matrix elements V(J,K)=(VR(K), VI(K))
      DO 13 K=1, KCC
      JJ=MAX(J,K)
      KK=MIN(J,K)
      JK=2*JJ*(JJ-1)+4*KK-3
      JI=JK+2
      KD=JK+1
      ID=JI+1
      VR(K)=S*(FCC(JK,IT)+SS*FCC(KD,IT))+T*(FCC(JK,IS)+TT*FCC(KD,IS))
   13 VI(K)=S*(FCC(JI,IT)+SS*FCC(ID,IT))+T*(FCC(JI,IS)+TT*FCC(ID,IS))
C********      
C         add centrifugal pot.
      LJ=LCC(J)
      VR(J)=VR(J)+LJ*(LJ+1)/RR
C       for independent solutions U(*,I)
      DO 15 I=1, KCC
      SR=0
      SI=0
C            (potential)*(wave function)
      DO 14 K=1, KCC
      SR=SR+VR(K)*UR(K,I)-VI(K)*UI(K,I)
   14 SI=SI+VR(K)*UI(K,I)+VI(K)*UR(K,I)
      VUR(J,I)=SR
   15 VUI(J,I)=SI
   16 CONTINUE
      ISOLD=IS 
      ROLD=R
      RETURN
   91 WRITE(6,92)R, RFFTAB(NRFFMX)
   92 FORMAT(1H ,'(VUCAL) R=',1PE12.3,' is larger than ',1PE12.3)
      STOP
      END
      SUBROUTINE UIMULT(N, IU, UR, UI, VUR, VUI)
C        multiply inverse of (UR(*,*,IU), UI(*,*,IU)) to the matrices
C Input N : dimension of the matrices
C       IU  : pointer
C      UR(N,N,3), UI(N, N,3), VUR(N, N, 8), VUI(N, N, 8)
C         matrices
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION  UR(N, N, 3),  UI(N, N, 3), VUR(N, N, 8), VUI(N, N, 8)
C 
      DO 6 I=1, N
C         divide by diagonal element
      Y= UR(I,I,IU)**2+UI(I,I,IU)**2
      X= UR(I,I,IU)/Y
      Y=-UI(I,I,IU)/Y
      DO 1 JU=1, 3
      DO 1 J =1, N
      P=UR(I,J,JU)*X-UI(I,J,JU)*Y
      Q=UR(I,J,JU)*Y+UI(I,J,JU)*X
      UR(I,J,JU)=P
    1 UI(I,J,JU)=Q
      DO 2 IV=1, 8
      DO 2 J =1, N
      P=VUR(I,J,IV)*X-VUI(I,J,IV)*Y
      Q=VUR(I,J,IV)*Y+VUI(I,J,IV)*X
      VUR(I,J,IV)=P
    2 VUI(I,J,IV)=Q
C        subtract
      DO 5 K=1, N
      IF(K .EQ. I) GOTO 5
      X=UR(K,I,IU)
      Y=UI(K,I,IU)
      DO 3 JU=1, 3
      DO 3 J =1, N
      P=UR(I,J,JU)*X-UI(I,J,JU)*Y
      Q=UR(I,J,JU)*Y+UI(I,J,JU)*X
      UR(K,J,JU)=UR(K,J,JU)-P
    3 UI(K,J,JU)=UI(K,J,JU)-Q
      DO 4 IV=1, 8
      DO 4 J =1, N
      P=VUR(I,J,IV)*X-VUI(I,J,IV)*Y
      Q=VUR(I,J,IV)*Y+VUI(I,J,IV)*X
      VUR(K,J,IV)=VUR(K,J,IV)-P
    4 VUI(K,J,IV)=VUI(K,J,IV)-Q
    5 CONTINUE
    6 CONTINUE
      RETURN
      END
      SUBROUTINE GSORTH(N, IU, K10, MR, UR, UI, VR, VI, PR, PI)
C                   May. 3. 2001: completely rewritten
C        Orthogonalization by Gram-Schmidt procedure
C        Complex vector UR(*,IU), UI(*,IU) are orthonormalized
C Input N: size of the problem
C      IU: pointer, which vectors are really orthonormalized
C       UR(N,N, 5),  UI(N,N, 5):  to be orthonormalized
C          U(*,*,3)-U(*,*,5) are to be modified
C      VR(N,N, 8), VI(N,N, 8): same as above
C working are PR(N,N), PI(N,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION UR(N,N,5),UI(N,N,5), VR(N,N,8), VI(N,N,8),
     +          PR(N,N),  PI(N,N)
C         for each vectors |i>
      DO  4 I=1, N
      DO  2 J=1, I-1
C           <J|I>=(SR, SI)
      SR=0
      SI=0
      DO 1 K=1, N
      SR=SR+UR(K,J,IU)*UR(K,I,IU)+UI(K,J,IU)*UI(K,I,IU)
    1 SI=SI+UR(K,J,IU)*UI(K,I,IU)-UI(K,J,IU)*UR(K,I,IU)
      PR(J,I)=SR
      PI(J,I)=SI
C          |I> - |J><J|I>
      DO 2 K=1, N
      UR(K,I,IU)=UR(K,I,IU)-(SR*UR(K,J,IU)-SI*UI(K,J,IU))
    2 UI(K,I,IU)=UI(K,I,IU)-(SR*UI(K,J,IU)+SI*UR(K,J,IU))
C          Normalize |I>
      SR=0
      DO 3 K=1, N
    3 SR=SR+UR(K,I,IU)**2+UI(K,I,IU)**2
      PR(I,I)=SQRT(SR)
      PI(I,I)=0
      SR=1/PR(I,I)
      DO 4 K=1, N
      UR(K,I,IU)=SR*UR(K,I,IU)
    4 UI(K,I,IU)=SR*UI(K,I,IU)
C       tranform rest of (UR, UI) matrices
      DO 8 M=3,5
      IF(M .EQ. IU) GOTO 8
      DO 7 I=1,N
      DI=1/PR(I,I)
      DO 7 J=1,N
      SR=UR(J,I,M)
      SI=UI(J,I,M)
      DO 6 K=1,I-1
      SR=SR-(UR(J,K,M)*PR(K,I)-UI(J,K,M)*PI(K,I))
    6 SI=SI-(UR(J,K,M)*PI(K,I)+UI(J,K,M)*PR(K,I))
      UR(J,I,M)=SR*DI
    7 UI(J,I,M)=SI*DI
    8 CONTINUE
C          transform UV
      DO 12 M=1,8
      DO 12 I=1,N
      DI=1/PR(I,I)
      DO 12 J=1,N
      SR=VR(J,I,M)
      SI=VI(J,I,M)
      DO 11 K=1,I-1
      SR=SR-(VR(J,K,M)*PR(K,I)-VI(J,K,M)*PI(K,I))
   11 SI=SI-(VR(J,K,M)*PI(K,I)+VI(J,K,M)*PR(K,I))
      VR(J,I,M)=SR*DI
   12 VI(J,I,M)=SI*DI
C        print Orthogonal matrix
      IF(K10 .LE. 0) RETURN
      MMR=-MR
      IF(K10.GT.0)WRITE(1)MMR
      IF(K10.GT.0)WRITE(1)((PR(I,J),PI(I,J),I=1,N),J=1,N)      
      RETURN
      END
      SUBROUTINE CDC28( KCC, UR, UI, DUR, DUI, ISMAX,NWM, 
     +                  NCWF, LMAX, F, FP, G, GP, WK,
     +                  SR, SI, WR, WI, IW, WX, CNUM, K10)
C    returns S-matrix for given u and u'
C Input JTOT, JPAR: total ang. mom. and parity of the total system
C       KCC      : number of coupled channels
C       IDCC(KCC): ID number of coupled channel
C       LCC(KCC) : orbital ang. mom. of the coupled channel
C       UR(KCC,KCC), UI(KCC,KCC)  : wave function at the matchinh point
C       DUR(KCC,KCC), DUI(KCC,KCC): their derivatives with respect to r
C       NCC      : max. number of coupled channels
C       FKCM(NCC): wave number table
C       NCWF     : number of independent set of Coulomb wave functions
C       LMAX     : max. of orbital ang. mom.
C       IDCWF(NCC): pointer of Coulomb wave function
C       F(0:LMAX, NCWF), G(0:LMAX, NCWF): Coulomb wave functions and
C       FP(           ),GP(            ): their der. with respect to rho
C       ISOPEN(NCC): =1 for open channel
C       ISMAX    : max. number of open channels
C       NWM      : number of weight vectors for incident channels
C Output SR(NCC,ISMAX), SI(NCC,ISMAX): S-matrix
C working area WR(KCC), WI(KCC), IW(KCC), WX(KCC),
      IMPLICIT REAL*8 (A-H,O-Z)
C             NCCMAX is referenced
      COMMON /QCM/EDCM(324),  FKCM (324), ETACM(324),
     +            LCM (324), ISOPEN(324),IDPNWF(324), IDCC(324),
     +            LCC (324), IDCWF(324), ISOCC(10),   NCC, ISOMAX
      DIMENSION UR(KCC,KCC), UI(KCC,KCC), DUR(KCC,KCC), DUI(KCC,KCC),
     +          F (0:LMAX, NCWF), G (0:LMAX, NCWF),
     +          FP(0:LMAX, NCWF), GP(0:LMAX, NCWF), WK(KCC), 
     +          SR(NCC,ISMAX), SI(NCC,ISMAX),
     +          IW(KCC), WR(KCC), WI(KCC), WX(KCC)
C       scaling
      DO 13 I=1, KCC
      GG=0
      DO 11 J=1, KCC
      FF=ABS( UR(J,I))+ABS( UI(J,I))
      IF(GG .LT. FF) GG=FF
      FF=ABS(DUR(J,I))+ABS(DUI(J,I))
      IF(GG .LT. FF) GG=FF
   11 CONTINUE
      GG=1/GG
      WK(I)=GG
      DO 12 J=1, KCC
       UR(J,I)= UR(J,I)*GG  
       UI(J,I)= UI(J,I)*GG
      DUR(J,I)=DUR(J,I)*GG
   12 DUI(J,I)=DUI(J,I)*GG
   13 CONTINUE
C       U'--> O'*U - O*U'
      DO 15 I=1, KCC
      LI=LCC(I)
      ID=IDCC(I)
      IC=IDCWF(ID)
      IF(IC .GT. NCWF) GOTO 91
      FF=F (LI, IC)
      GG=G (LI, IC)
      FD=FP(LI, IC)
      GD=GP(LI, IC)
      DO 14 J=1, KCC
      TR=GD*UR(I,J)-FD*UI(I,J)-(GG*DUR(I,J)-FF*DUI(I,J))
      TI=GD*UI(I,J)+FD*UR(I,J)-(GG*DUI(I,J)+FF*DUR(I,J))
      DUR(I,J)=TR
   14 DUI(I,J)=TI
   15 CONTINUE
C        L/U decomposition of (DUR, DUI) matrix
      CALL CLU(KCC, DUR, DUI, IW, WR, WI, CNUM)
C        solve S-matrix. 
C        No care is taken of the velocity factor
      DO 30 I=1, NWM
      ID=ISOCC(I)
      ISS=ISOPEN(ID)
      FK0=FKCM(ID)
      DO 21 J=1, KCC
      WR(J)=0
   21 WI(J)=0
      LI=LCC(I)
      IC=IDCWF(ID)
      FF=F (LI, IC)
      GG=G (LI, IC)
      FD=FP(LI, IC)
      GD=GP(LI, IC)
      WI(I)=2*(GG*FD-FF*GD)
C        weights for the channel I is given in (WR, WI)
      CALL CLEQ(KCC, DUR, DUI, WR, WI, IW, WX)
C        weights are now converted to S-matrix
      DO 27 J=1, KCC
      PR=0
      PI=0
      IF(J .EQ. I) THEN
         PR= GG
         PI=-FF
      END IF
      DO 26 K=1, KCC
      PR=PR-(UR(J,K)*WR(K)-UI(J,K)*WI(K))
   26 PI=PI-(UR(J,K)*WI(K)+UI(J,K)*WR(K))
C           divide by O(J)
      JD=IDCC(J)
      JC=IDCWF(JD)
      LJ=LCC(J)
      GD=G(LJ, JC)
      FD=F(LJ, JC)
      U=1/(GD*GD+FD*FD)
      TR= GD*U
      TI=-FD*U
C         volocity factor is applied to S-matrix
      VFAC=SQRT(FKCM(JD)/FK0)
      SR(JD,ISS)=(TR*PR-TI*PI)*VFAC
      SI(JD,ISS)=(TR*PI+TI*PR)*VFAC
   27 CONTINUE
      DO 28 J=1,KCC
      WR(J)=WR(J)*WK(J)
   28 WI(J)=WI(J)*WK(J)
      IF(K10.GT.0) WRITE(1)(WR(J),WI(J),J=1,KCC)      
   30 CONTINUE
      RETURN
C        error message
   91 WRITE(6,92)I, ID
   92 FORMAT(1H ,'(CDC28) for channel ',I3,1X,'CWF ID=',I3,1X,
     +           'NOT allowed !!')
      STOP
      END
      SUBROUTINE CLU(N, AR, AI, IR, BR, BI, CNUM)
C         L/U decomposition of complex matrix (AR, AI)
C         condition number estimated.         1998/May/29
C Input N: size of the problem
C   AR(N,N), AI(N,N): matrix to be decomposed
C Output IR(N): pointer, used for partial pivotting
C         CNUM: estimated condition number
C working area BR(N), BI(N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AR(N,N), AI(N,N), IR(N), BR(N), BI(N)
C        1-norm
      CNUM=0
      DO 2 I=1, N
      S=0
      DO 1 J=1, N
    1 S=S+SQRT(AR(J,I)**2+AI(J,I)**2)
      IF(CNUM .LT. S) CNUM=S
    2 IR(I)=I
C       Main loop
      DO 5 I=1, N
      J=I
      K=IR(I)
      S=ABS(AR(K,I))+ABS(AI(K,I))
      DO 3 L=I+1, N
      T=ABS(AR(IR(L),I)) + ABS(AI(IR(L),I))
      IF(S .GT. T) GOTO 3
      S=T
      J=L
    3 CONTINUE
C        define I-th largest pointer IR(J)
      IR(I)=IR(J)
      IR(J)=K
      IF(S .LT. 1.0D-60) GOTO 90
C       inverse of a diagonal element
      J=IR(I)
      U=AR(J,I)**2+AI(J,I)**2
      S= AR(J,I)/U
      T=-AI(J,I)/U
      AR(J,I)=S
      AI(J,I)=T
C
      DO 4 L=I+1, N
      K=IR(L)
      U=AR(K,I)*S-AI(K,I)*T
      V=AR(K,I)*T+AI(K,I)*S
      AR(K,I)=U
      AI(K,I)=V
      DO 4 M=I+1, N
      AR(K,M)=AR(K,M)-(U*AR(J,M)-V*AI(J,M))
    4 AI(K,M)=AI(K,M)-(U*AI(J,M)+V*AR(J,M))
    5 CONTINUE
C         estimate CNUM, condition number of matrix A
      DO 7 I=1, N
      S=0
      T=0
      DO 6 J=1, I-1
      K=IR(J)
      S=S+(AR(K,I)*BR(K)-AI(K,I)*BI(K))
    6 T=T+(AR(K,I)*BI(K)+AI(K,I)*BR(K))
C        add 1 
      U=1
      V=0
      IF(ABS(S)+ABS(T) .GT. 0.0) THEN
         V=ATAN2(T, S)
         U=-COS(V)
         V=-SIN(V)
      END IF
      S=U-S
      T=V-T
      K=IR(I)
      BR(K)=S*AR(K,I)-T*AI(K,I)
    7 BI(K)=S*AI(K,I)+T*AR(K,I)
      V=0
      DO 9 I=N, 1, -1
      L=IR(I)
      S=BR(L)
      T=BI(L)
      DO 8 J=I+1, N
      K=IR(J)
      S=S-(AR(K,I)*BR(K)-AI(K,I)*BI(K))
    8 T=T-(AR(K,I)*BI(K)+AI(K,I)*BR(K))
      U=S**2+T**2
      IF(U .GT. V) V=U
      BR(L)=S
    9 BI(L)=T
C  
      CNUM=CNUM*SQRT(V)
      RETURN
C     error message
   90 WRITE(6,91)I
   91 FORMAT(1H ,'(CLU) rank may be ',I3)
      STOP
      END
      SUBROUTINE CLEQ(N, AR, AI, BR, BI, IR, WX)
C         solve complex linear equation A*X=B
C         this routine is called after L/U decomposition is over
C Input N: order of the problem
C   AR(N,N), AI(N,N): real and imag. part of matrix A
C                     A should be L/U decomposed already
C   BR(N), BI(N)    : real and imag. part of vector B
C   IR(N)           : pointer of ordering
C Output BR(N), BI(N): solution vector
C workng area WX(N) : used to recover the ordering of B vector
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AR(N,N), AI(N,N),BR(N), BI(N), IR(N), WX(N)
C        forward substitution
      DO 2 I=1, N
      J=IR(I)
      R=BR(J)
      S=BI(J)
      DO 1 K=1, I-1
      L=IR(K)
      R=R-(AR(J,K)*BR(L)-AI(J,K)*BI(L))
    1 S=S-(AR(J,K)*BI(L)+AI(J,K)*BR(L))
      BR(J)=R
    2 BI(J)=S
C        backward substitution
      DO 4 I=N, 1, -1
      L=IR(I)
      R=BR(L)
      S=BI(L)
      DO 3 J=I+1, N
      K=IR(J)
      R=R-(AR(L,J)*BR(K)-AI(L,J)*BI(K))
    3 S=S-(AR(L,J)*BI(K)+AI(L,J)*BR(K))
      BR(L)=R*AR(L,I)-S*AI(L,I)
    4 BI(L)=R*AI(L,I)+S*AR(L,I)
C         reorder the solution
      DO 5 I=1, N
    5 WX(I)=BR(IR(I))
      DO 6 I=1,N
    6 BR(I)=WX(I)
      DO 7 I=1, N
    7 WX(I)=BI(IR(I))
      DO 8 I=1, N
    8 BI(I)=WX(I)
      RETURN
      END
      SUBROUTINE CDC29( KNTL9, JTOT, NCX, SR, SI)
C      print S-matrix
C Input KNTL9: =1       print S-matrix
C       KNTL9: =2 or 3 S-matrix is written onto file(LUN=7)
C       JTOT: total angular momentum of the sysytem
C       NCC : number of coupled channels
C       ISOMAX: max. number of incident channels
C       ISOPEN(NCC): open channel ID
C       SR(NCC, ISOMAX), SI(NCC, ISOMAX): S-matrix
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /QCM/EDCM(324),  FKCM (324), ETACM(324),
     +            LCM (324), ISOPEN(324),IDPNWF(324), IDCC(324),
     +            LCC (324), IDCWF(324), ISOCC(10),
     +            NCC, ISOMAX
      COMMON /FF0/ KNTL(10), IDPN(10), NKBIN(10), FKMIN(10), FKMAX(10),
     +             IT(10), JJ(10), IS(10), KOUPLE(10), ISBND(10),
C                    potential parameters
     +             ISN(10), ISI(10), ISLS(10), POTPRM(5,10), 
C                    quantum numbers for the "deuteron" wave functions
C                   NWFMAX is referenced
     +             EPN(122), DKPN(122), FKPN(122), PPN(122), RPN(122),
     +             KPLPN(122), LLPN(122), ISPN(122), JJPN(122), 
     +             NPNMAX, NPTYPE, NWFMAX, NWF, LAMMIN, LAMMAX
      DIMENSION  SR(NCX, *), SI(NCX, *)
      K9F=KNTL9/2
      K9P=KNTL9-K9F*2
C        print S-matrix
      DO 20 N=1, NCC
      ISO=ISOPEN(N)
      IF(ISO .LE. 0) GOTO 20
C          evaluate the absorption rate
      SUM=0
      DO 11 M=1, NCC
      SUM=SUM+SR(M, ISO)**2+SI(M, ISO)**2
C         divide by sqrt(DKbin)
      ID=IDPNWF(M)
      DKI=DKPN(ID)
      SR(M,ISO)=SR(M,ISO)*DKI
   11 SI(M,ISO)=SI(M,ISO)*DKI
      IF(SUM .LT. 1.0E-10)SUM=1
      DIF=1-SUM
      WRITE(6,15)JTOT, N, NCC, DIF
      IF(K9P .NE. 0) WRITE(6,16)(SR(M,ISO),SI(M,ISO),M=1,NCC)
      IF(K9F .EQ. 0) GOTO 20
      WRITE(7,17)JTOT, N, DIF
      WRITE(7,16)(SR(M,ISO),SI(M,ISO),M=1,NCC)
   20 CONTINUE
      RETURN
   15 FORMAT(1H ,'Jtot=',I3,2X,'Init. ch.=',I3,2X,'NCC=',I3,
     +           '  absorption rate=',1PE15.7)
   16 FORMAT((1H ,6F13.9))
   17 FORMAT(1H ,2I5,1PE14.5,2X,'/Jtot Init.ch  Dif ')
      END
      SUBROUTINE CDC30(JT, JPAR, NRDW, NS0, DR, KCC, NWM, 
     &                 NRP, NU, IR, U, W)
C         control routine to make up/write distorted waves for the
C         deuteron ground state
C Input JT: total angular momentum of the system
C       NRDW, DR: number and size of the distorted wave meshes
C       KCC: number of coupled channels
C       NWM: =1 if Jtot== Lin and =2 if Jtot != Lin
C       NRP: array size of IR and IP
C       NU : array size of U
C working area IR(NRP): store n-th point
C              W(2,KCC,NWM): weight
C              U: indep. sol. and orth. matrices
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IR(NRP), W(*), U(NU)
C       read independent solutions etc.
      REWIND 1
      KC2=2*KCC
      KCW=NWM*KC2
      KKC=KC2*KCC
      ID=-1
      IR0=1
    1 READ(1,ERR=91,END=93)M
      ID=ID+2
      IF(ID .GT. NRP) GOTO 95
      IR(ID  )=M
      IR(ID+1)=IR0
C         read indep. sol. if M > 0 or orthog. mat. if M < 0
      IRX=KCW
      IF(M .LT. 0) IRX=KKC
      IR1=IR0+IRX-1
      IF(IR1 .GT. NU) GOTO 97
      READ(1,ERR=91,END=93)(U(I),I=IR0,IR1)
      IR0=IR1+1
      IF(M .LE. NRDW) GOTO 1
      IDMX=ID+1
C         here for weight
      IR0=1
      DO 2 NW=1,NWM
      IR1=IR0+KC2-1
      READ(1,ERR=91,END=93)(W(I),I=IR0,IR1)
    2 IR0=IR1+1
C       make up distorted waves and print them
      DO 5 ID=IDMX, 1, -2
      N=IR(ID  )
      M=IR(ID-1)
      IF(M .GT. 0) CALL SUPPOS(KCC, NWM, U(N), W) 
      IF(M .LT. 0) CALL MODFYW(KCC, NWM, U(N), W)
    5 CONTINUE
C      print heading
      WRITE(8,10)JT, JPAR, NS0
   10 FORMAT('# Jtot=',I4,' Jpar=',I2,2X,'NS0=',I4)
      IF(JT .EQ. 0) WRITE(8,11)
      IF(JT .GT. 0 .AND. NWM .EQ. 1)WRITE(8,12)
      IF(JT .GT. 0 .AND. NWM .EQ. 2)WRITE(8,13)
   11 FORMAT('# R(fm)',9X,'Lin=Lout=1')
   12 FORMAT('# R(fm)',9X,'Lin=Lout=Jtot')
   13 FORMAT('# R(fm)',9X,'Lin=Lout=Jtot-1',12X,
     +                    'Lin=Jtot-1',2X,'Lout=Jtot+1')
   14 FORMAT('# R(fm)',6X,'Lin=Jtot+1',2X,'Lout=Jtot-1',10X,
     +                    'Lin=Lout=Jtot+1')
C        print distorted waves 
      NWW=2*NWM-1
      IPX=0
      DO 20 NW=1,NWM
      DO 16 ID=1, IDMX, 2
      IF(IR(ID) .LT. 0) GOTO 16
      R  =IR(ID  )*DR
      IP0=IR(ID+1)+IPX
      IP1=IP0+NWW
      WRITE(8,15)R,(U(I),I=IP0,IP1)
   15 FORMAT(0PF8.3,1P4E15.7)
   16 CONTINUE
C         new heading
      IF(NW. NE. NWM)WRITE(8,14)
   20 IPX=NWM**2
      RETURN
C     error messages
   91 WRITE(6,92)ID,M
   92 FORMAT('(GETSOL) read error at ID=',I4,' and M=',I5)
      STOP
   93 WRITE(6,94)ID,M
   94 FORMAT('(GETSOL) end of file at ID=',I4,' and M=',I5)
      STOP
   95 WRITE(6,96)ID,M,NRP
   96 FORMAT('(GETSOL) at ID=',I4,' and M=',I5,' IR and IP pun !',
     &' NRP=',I5)
      STOP
   97 WRITE(6,98)ID,IR1,NU
   98 FORMAT('GETSOL) at ID=',I4,2X,'IR1=',I8,' while NU=',I8)
      END
      SUBROUTINE SUPPOS(KCC, NWM, U, W)
C           superpose U by using weight W
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION W(2,KCC,NWM), U(2,KCC,NWM), DW(2,2,2)
      DO 2 N2=1,NWM
      DO 2 N1=1,NWM
      SX=0
      SY=0
      DO 1 K=1,KCC
      SX=SX+W(1,K,N2)*U(1,K,N1)-W(2,K,N2)*U(2,K,N1)
    1 SY=SY+W(1,K,N2)*U(2,K,N1)+W(2,K,N2)*U(1,K,N1)
      DW(1,N1,N2)=SX
    2 DW(2,N1,N2)=SY
C         save distorted waves
      K=0
      DO 3 N2=1,NWM
      DO 3 N1=1,NWM
      K=K+1
      U(1,K,1)=DW(1,N1,N2)
    3 U(2,K,1)=DW(2,N1,N2)
      RETURN 
      END
      SUBROUTINE MODFYW(KCC, NWM, U, W)
C        modify W by using matrix W, backward substitution
C        U is an upper right triangular matrix,
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION W(2,KCC,NWM), U(2,KCC,KCC)
      DO 2 I=KCC,1,-1
      X=U(1,I,I)
      Y=U(2,I,I)
      DEN=X*X+Y*Y
      DO 2 N=1,NWM
      WX=W(1,I,N)
      WY=W(2,I,N)
      DO 1 J=I+1,KCC
      WX=WX-(U(1,I,J)*W(1,J,N)-U(2,I,J)*W(2,J,N))
    1 WY=WY-(U(1,I,J)*W(2,J,N)+U(2,I,J)*W(1,J,N))
      W(1,I,N)=(WX*X+WY*Y)/DEN
    2 W(2,I,N)=(WY*X-WX*Y)/DEN
      RETURN
      END
